#include <bits/stdc++.h>
#include "tunnels.h"
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<bool> > grid, reachable, vis;

void dfs(int i, int j, int n, int m) {
    if (i < 0 || j < 0 || j >= m || vis[i][j] || grid[i][j])
        return;
    vis[i][j] = true;
    dfs(i - 1, j, n, m);
    dfs(i, j + 1, n, m);
    dfs(i, j - 1, n, m);
}

int do_search(vector<int> &pos) {
    int l = 0, r = pos.size(), ans = -1;
    while (l < r) {
        int mid = (l + r) / 2;
        if (investigate(pos[mid]))
            l = mid + 1, ans = mid;
        else
            r = mid;
    }
    return ans;
}

int get_nq(int siz) {
    return ceil(log2((long double)siz));
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    grid = blocked;

    vis = reachable = vector<vector<bool> > (n + 1, vector<bool>(m));
    grid.push_back(vector<bool>(m, false));
    dfs(n, 0, n, m);

    for (int i = 0; i < n; i++) {
        vector<int> l_ok, r_ok;
        for (int j = k - 1; j >= 0; j--) {
            if (grid[i][j])
                break;
            if (grid[i + 1][j])
                continue;
            if (vis[i][j])
                l_ok.push_back(j);
        }
        for (int j = k + 1; j < m; j++) {
            if (grid[i][j])
                break;
            if (grid[i + 1][j])
                continue;
            if (vis[i][j])
                r_ok.push_back(j);
        }

        if (r_ok.empty() and l_ok.empty()) {
            goDeeper(k);
            continue;
        }

        // figure out what to query first
        if (l_ok.size() < r_ok.size())
            swap(l_ok, r_ok);
        int v = l_ok[0];
        bool isl = investigate(l_ok[0]);
        if (isl) {
            l_ok.erase(l_ok.begin());
            int id = do_search(l_ok);
            if (id == -1)
            {
                goDeeper(v);
                k = v;
            }
            else
            {
                goDeeper(l_ok[id]);
                k = l_ok[id];
            }
        } else {
            int id = do_search(r_ok);
            if (id == -1)
                goDeeper(k);
            else
            {
                goDeeper(r_ok[id]);
                k = r_ok[id];
            }
        }
    }
}
