#include <bits/stdc++.h>
#include "tunnels.h"
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<bool> > grid, vis;

void dfs(int i, int j, int n, int m) {
    if (i < 0 || j < 0 || j >= m || vis[i][j] || grid[i][j])
        return;
    vis[i][j] = true;
    dfs(i - 1, j, n, m);
    dfs(i, j + 1, n, m);
    dfs(i, j - 1, n, m);
}

int do_search(vector<int> pos, bool sure) {
    int l = 1, r = pos.size();
    while (l < r) {
        int mid = (l + r) / 2;
        if (investigate(pos[mid]))
            l = mid + 1;
        else
            r = mid;
    }
    return l - 1;
}

int get_nq(int siz) {
    return ceil(log2((long double)siz));
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    grid = blocked;

    vis = vector<vector<bool> > (n + 1, vector<bool>(m));
    grid.push_back(vector<bool>(m, false));
    dfs(n, 0, n, m);

    for (int i = 0; i < n; i++) {
        vector<int> l_ok, r_ok;
        for (int j = k - 1; j >= 0; j--) {
            if (grid[i][j])
                break;
            if (vis[i + 1][j])
                l_ok.push_back(j);
        }
        for (int j = k + 1; j < m; j++) {
            if (grid[i][j])
                break;
            if (vis[i + 1][j])
                r_ok.push_back(j);
        }

        if (r_ok.empty() and l_ok.empty()) {
            goDeeper(k);
            continue;
        } else if (l_ok.empty()) {
            if (vis[i + 1][k])
                r_ok.insert(r_ok.begin(), k);
            
            int id = do_search(r_ok, true);
            goDeeper(r_ok[id]);
            k = r_ok[id];
        } else if (r_ok.empty()) {
            if (vis[i + 1][k])
                l_ok.insert(l_ok.begin(), k);
            
            int id = do_search(l_ok, true);
            goDeeper(l_ok[id]);
            k = l_ok[id];
        } else {
            // figure out what to query first
            if (l_ok.size() < r_ok.size())
                swap(l_ok, r_ok);
            bool isl = investigate(l_ok[0]);
            if (isl) {
                int id = do_search(l_ok, true);
                goDeeper(l_ok[id]);
                k = l_ok[id];
            } else {
                if (vis[i + 1][k])
                    r_ok.insert(r_ok.begin(), k);
                int id = do_search(r_ok, true);
                goDeeper(r_ok[id]);
                k = r_ok[id];
            }
        }
    }
}
