#include "tunnels.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

const int MAXN = 5000;
const int MAXM = 5000;
const int INF = 1000000000;

void calcDp()
{
	int dp[2*MAXM+2][2*MAXM+2], best[2*MAXM+2][2*MAXM+2];
	for (int i = 0; i <= 2*MAXM; i++) {
		dp[i][i] = best[i][i] = 0;
	}
	for (int len = 2; len <= MAXM; len++) {
		for (int l = 0; l + len - 1 <= 2*MAXM; l++) {
			int r = l + len - 1;
			dp[l][r] = INF;
			for (int i = l; i < MAXM && i < r; i++) {
				int res = max(dp[l][i], dp[i+1][r]) + 1;
				if (res < dp[l][r]) {
					dp[l][r] = res;
					best[l][r] = i;
				}
			}
			for (int i = r; i > MAXM && i > l; i--) {
				int res = max(dp[i][r], dp[l][i-1]) + 1;
				if (res < dp[l][r]) {
					dp[l][r] = res;
					best[l][r] = i;
				}
			}
		}
	}
}

int getCost(int l, int r, int q)
{
	if (!q || q < l || q > r) return INF;
	if (q < 0) {
		if (q == r) return INF;
		return max(q-l+1, r-q);
	}
	if (q == l) return INF;
	return max(r-q+1, q-l);
}

int amogus(int k, int l, int r)
{
	while (l < r) {
		int best = (l+r) / 2;
		int cost = getCost(l-k, r-k, best-k);
		for (int i = (l+r) / 2 - 2; i <= (l+r) / 2 + 2; i++) {
			if (getCost(l-k, r-k, i-k) < cost) {
				best = i;
				cost = getCost(l-k, r-k, i-k);
			}
		}
		bool res = investigate(best);
		if (best < k) {
			if (res) {
				r = best;
			}
			else {
				l = best+1;
			}
		}
		else {
			if (res) {
				l = best;
			}
			else {
				r = best-1;
			}
		}
	}
	return l;
}

void solve(int n, int m, int k, const vector<vector<bool>> &blocked)
{
	for (int i = 0; i < n; i++) {
		int l = k, r = k;
		while (l > 0 && !blocked[i][l-1]) {
			l--;
		}
		while (r < m-1 && !blocked[i][r+1]) {
			r++;
		}
		k = amogus(k, l, r);
		goDeeper(k);
	}
}
