#include "tunnels.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

const int MAXN = 400;
const int MAXM = 400;
const int INF = 1000000000;

int n, m, k;
bool blocked[MAXN][MAXM], reach[MAXN+1][MAXM];
int reachst[MAXN+1][MAXM], reachdr[MAXN+1][MAXM];
int dp[MAXN+1][MAXM][MAXM], best[MAXN+1][MAXM][MAXM];

int cntReach(int i, int l, int r)
{
	int suma = 0;
	for (int j = l; j <= r; j++) {
		suma += reach[i][j];
	}
	return suma;
}

void calcDp(int i, int l, int r)
{
	for (int j = l; j <= r; j++) {
		if (reach[i+1][j]) {
			dp[i][j][j] = dp[i+1][reachst[i+1][j]][reachdr[i+1][j]];
		}
	}
	for (int len = 2; len <= r-l+1; len++) {
		for (int l2 = l; l2 + len - 1 <= r; l2++) {
			int r2 = l2 + len - 1;
			dp[i][l2][r2] = INF;
			for (int j = l2; j < r2; j++) {
				int res = max(dp[i][l2][j], dp[i][j+1][r2]);
				if (res < dp[i][l2][r2]) {
					dp[i][l2][r2] = res;
					best[i][l2][r2] = j;
				}
			}
		}
	}
}

void calcDp()
{
	for (int j = 0; j < m; j++) {
		reach[n][j] = true;
		reachst[n][j] = 0;
		reachdr[n][j] = m-1;
	}
	for (int i = n-1; i >= 0; i--) {
		for (int l = 0; l < m; l++) {
			for (int r = l; r < m; r++) {
				dp[i][l][r] = -INF;
			}
		}
		for (int l = 0; l < m; l++) {
			if (blocked[i][l]) {
				reach[i][l] = false;
				continue;
			}
			int r = l;
			bool ok = reach[i+1][r];
			while (r < m-1 && !blocked[i][r+1]) {
				r++;
				ok = ok || reach[i+1][r];
			}
			for (int j = l; j <= r; j++) {
				reach[i][j] = ok;
			}
			if (ok) {
				calcDp(i, l, r);
			}
			l = r;
		}
		int last = -1;
		for (int j = 0; j < m; j++) {
			if (!reach[i][j]) {
				last = j;
			}
			reachst[i][j] = last+1;
		}
		last = m;
		for (int j = m-1; j >= 0; j--) {
			if (!reach[i][j]) {
				last = j;
			}
			reachdr[i][j] = last-1;
		}
	}
}

void solve(int N, int M, int K, const vector<vector<bool>> &Blocked)
{
	n = N;
	m = M;
	k = K;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			blocked[i][j] = Blocked[i][j];
		}
	}
	calcDp();
	for (int i = 0; i < n; i++) {
		int l = reachst[i][k], r = reachdr[i][k];
		while (cntReach(i+1, l, r) > 1) {
			int amogus = best[i][l][r];
			if (amogus < k) {
				bool res = investigate(amogus);
				if (res) {
					r = amogus;
				}
				else {
					l = amogus+1;
				}
			}
			else {
				bool res = investigate(amogus+1);
				if (res) {
					l = amogus+1;
				}
				else {
					r = amogus;
				}
			}
		}
		for (int j = l; j <= r; j++) {
			if (reach[i+1][j]) {
				k = j;
				break;
			}
		}
		goDeeper(k);
	}
}
