#include "bits_and_tree.h"
#include <iostream>
#include <algorithm>

using namespace std;

#define sz(X) ((int)((X).size()))

const int MAXN = 200;

int n;
bool v[MAXN+3];
vector<pair<int, int>> edges;
vector<int> nb[MAXN+3];

vector<pair<int, int>> encode(int N, vector<bool> data)
{
	n = N;
	for (int i = 0; i < n; i++) {
		v[i] = data[i];
	}
	edges.clear();
	int poz = 0;
	/// root is densest
	int root = 0;
	int m = 1;
	for (int i = 0; i < 8; i++) {
		edges.push_back({root, m});
		m++;
	}
	while (m + 3 <= n) {
		int node = m-1;
		for (int i = 0; i <= 2 * v[poz] + 1; i++) {
			edges.push_back({node, m});
			m++;
		}
		poz++;
	}
	while (m < n) {
		edges.push_back({root, m});
		m++;
	}
	return edges;
}

int findRelevantChild(int node, int p)
{
	for (auto x : nb[node]) {
		if (x != p && nb[x].size() > 2) {
			return x;
		}
	}
	return -1;
}

vector<bool> decode(int N, vector<pair<int, int>> tree)
{
	n = N;
	edges = tree;
	for (auto &p : edges) {
		nb[p.first].push_back(p.second);
		nb[p.second].push_back(p.first);
	}
	int poz = 0;
	int root = 0;
	for (int i = 1; i <= n; i++) {
		if (nb[i].size() > nb[root].size()) {
			root = i;
		}
	}
	int node = findRelevantChild(root, -1);
	int p = root;
	while (node != -1) {
		v[poz] = (sz(nb[node]) - 3) / 2;
		poz++;
		int aux = node;
		node = findRelevantChild(node, p);
		p = aux;
	}
	vector<bool> ansvec;
	for (int i = 0; i < n; i++) {
		ansvec.push_back(v[i]);
	}
	for (int i = 0; i <= n; i++) {
		nb[i].clear();
	}
	return ansvec;
}
