#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define sz(X) ((int)(X).size())

const int MAXN = 300000;
const int MAXQ = 300000;
const int BULAN = 601;

struct Interval
{
	int l, r;
	Interval(int l, int r) : l(l), r(r) {}
	Interval() : l(), r() {}
	Interval getIntersect(const Interval &other) const
	{
		return Interval(max(l, other.l), min(r, other.r));
	}
	int length() const
	{
		return max(0, r-l+1);
	}
	bool empty() const
	{
		return l > r;
	}
};

int n, q, a[MAXN+2], lastap[MAXN+2];
vector<int> allap[MAXN+2];
long long ans;

template<int MAXSZ>
struct MaxQueue
{
	pair<int, int> v[MAXSZ+2];
	int n = 0;
	void relabel(int poz)
	{
		while (poz > 1 && v[poz].second > v[poz-1].second) {
			swap(v[poz], v[poz-1]);
			poz--;
		}
	}
	void push(int key, int val)
	{
		for (int i = 1; i <= n; i++) {
			if (v[i].first == key) {
				v[i].second = val;
				relabel(i);
				return;
			}
		}
		v[++n] = {key, val};
		relabel(n);
		while (n > MAXSZ) {
			n--;
		}
	}
	int operator [](int poz)
	{
		return v[poz].first;
	}
};
MaxQueue<BULAN> mq;

Interval getGoodInterval(int val)
{
	if (sz(allap[val]) < val) return Interval(1, 0);
	if (sz(allap[val]) == val) return Interval(1, allap[val][0]);
	return Interval(allap[val][allap[val].size()-val-1] + 1, allap[val][allap[val].size()-val]);
}

void init(int N, int Q, const vector<int> &A)
{
	n = N;
	q = Q;
	for (int i = 1; i <= n; i++) {
		a[i] = A[i-1];
	}
	ans = 0;
	for (int i = 1; i <= n; i++) {
		lastap[a[i]] = i;
		allap[a[i]].push_back(i);
		mq.push(a[i], lastap[a[i]]);
		long long aux = 0;
		Interval good(1, i);
		for (int j = 1; j <= mq.n; j++) {
			good = good.getIntersect(getGoodInterval(mq.v[j].first));
			if (j == mq.n) {
				aux += good.length();
			}
			else {
				aux += good.getIntersect(Interval(lastap[mq.v[j+1].first] + 1, i)).length();
			}
		}
		ans += aux;
	}
}

long long query(int l, int r)
{
	l++;
	r++;
	return ans;
}
