#include "tunnels.h"
#include <iostream>
#include <vector>
#include <tuple>
#include <functional>
#include <cassert>
#include <map>
#include <set>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

const int inf = 1e9 + 5;

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

const int nmax = 1e2 + 5;

int cut[nmax][nmax][nmax][nmax];
int dp[nmax][nmax][nmax][nmax];
int fin[nmax][nmax];

int prv[nmax][nmax];
int nxt[nmax][nmax];

const int BULAN = 0;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
   for(int i = 0; i < m; i++) {
      fin[n][i] = 0;
   }
   for(int line = n - 1; line >= 0; line--) {
      for(int j = 0; j < m; j++) {
	 for(int step = -1; step < m; step++) {
	    for(int l = max(0, -step); l + step < m; l++) {
	       int r = l + step;
	       if(l > r) dp[line][j][l][r] = inf, cut[line][j][l][r] = r;
	       else if(l == r) dp[line][j][l][r] = fin[line + 1][l], cut[line][j][l][r] = l;
	       else {
		  auto eval = [&](int p) {
		     if(p == j) return inf;
		     if(p < j) return max(dp[line][j][l][p], dp[line][j][p + 1][r]) + 1;
		     else return max(dp[line][j][l][p - 1], dp[line][j][p][r]) + 1;
		  };
		  int& opt = cut[line][j][l][r];
		  opt = l;
		  for(int h = max(l, cut[line][j][l][r - 1] - BULAN); h <= min(r, cut[line][j][l + 1][r] + BULAN); h++)
		     if(eval(opt) > eval(h)) opt = h;
		  dp[line][j][l][r] = eval(opt);
	       }
	    }
	 }
      }
      int lst = 0;
      for(int j = 0; j < m; j++) {
	 if(blocked[line][j]) lst = j + 1;
	 else prv[line][j] = lst;
      }
      lst = m - 1;
      for(int j = m - 1; j >= 0; j--) {
	 if(blocked[line][j]) lst = j - 1;
	 else {
	    fin[line][j] = dp[line][j][prv[line][j]][lst];
	    nxt[line][j] = lst;
	 }
      }
   }
   
   // for(int i = 0; i < n; i++) {
      // for(int j = 0; j < m; j++)
	 // cerr << fin[i][j] << ' ';
      // cerr << '\n';
   // }
   
   int line = 0;
   while(line < n) {
      int l = prv[line][k], r = nxt[line][k];
      while(l < r) {
	 int mid = cut[line][k][l][r];
	 if(investigate(mid)) {
	    if(mid < k) r = mid;
	    else l = mid;
	 }
	 else {
	    if(mid < k) l = mid + 1;
	    else r = mid - 1;
	 }
      }
      goDeeper(l);
      k = l;
      line++;
   }
   return;
   
}
