#include "bits_and_tree.h"
#include <iostream>
#include <ranges>
#include <vector>
#include <set>
#include <cassert>
#include <functional>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

struct HNum {
   vector<int> A;
   int& operator [](const int& a) { return A[a]; }
   int operator [](const int& a) const { return A[a]; }
   int size() const  { return sz(A); }
   void init(int n) { A.assign(n, 0); }
   void initfromcst(int cst) {
      A.clear();
      while(cst) A.emplace_back(cst % 2), cst >>= 1;
      return;
   }
   void cut0() {
      while(sz(A) && A.back() == 0) A.pop_back();
      return;
   }
   HNum operator + (const HNum& a) const {
      HNum rez;
      rez.init(max(sz(a), sz(A)) + 2);
      for(int i = 0; i < sz(a); i++)
	 rez[i] += a[i];
      for(int i = 0; i < sz(A); i++)
	 rez[i] += A[i];
      for(int i = 0; i < sz(rez) - 1; i++) {
	 rez[i + 1] += rez[i] / 2;
	 rez[i] %= 2;
      }
      rez.cut0();
      return rez;
   }
   HNum operator - (const HNum& a) const {
      HNum rez;
      rez.init(max(sz(a), sz(A)) + 2);
      for(int i = 0; i < sz(a); i++)
	 rez[i] -= a[i];
      for(int i = 0; i < sz(A); i++)
	 rez[i] += A[i];
      for(int i = 0; i < sz(rez) - 1; i++) {
	 while(rez[i] < 0) rez[i] += 2, rez[i + 1]--;
	 rez[i + 1] += rez[i] / 2;
	 rez[i] %= 2;
      }
      rez.cut0();
      return rez;
   }
   HNum operator * (const HNum& a) const {
      HNum rez;
      rez.init(sz(a) + sz(A) + 20);
      for(int i = 0; i < sz(A); i++) {
	 for(int j = 0; j < sz(a); j++)
	    rez[i + j] += A[i] * a[j];
      }
      for(int i = 0; i < sz(rez) - 1; i++) {
	 rez[i + 1] += rez[i] / 2;
	 rez[i] %= 2;
      }
      rez.cut0();
      return rez;
   }
   HNum operator /(const HNum &a) const {
      HNum rez;
      rez.init(sz(A));
      for(int i = sz(rez) - 1; i >= 0; i--) {
	 rez[i] = 1;
	 if(rez * a <= (*this));
	 else rez[i] = 0;
      }
      return rez;
   }
   HNum operator % (const HNum& a) const {
      return (*this) - (((*this) / a) * a);
   }
   bool operator <(const HNum& a) const {
      auto getmine = [&](int x) { if(x >= sz(A)) return 0; return A[x]; };
      auto gethis = [&](int x) { if(x >= sz(a)) return 0; return a[x]; };
      for(int i = max(sz(A), sz(a)) - 1; i >= 0; i--) {
	 if(getmine(i) > gethis(i)) return 0;
	 if(getmine(i) < gethis(i)) return 1;
      }
      return 0;
   }
   bool operator <=(const HNum& a) const {
      auto getmine = [&](int x) { if(x >= sz(A)) return 0; return A[x]; };
      auto gethis = [&](int x) { if(x >= sz(a)) return 0; return a[x]; };
      for(int i = max(sz(A), sz(a)) - 1; i >= 0; i--) {
	 if(getmine(i) > gethis(i)) return 0;
	 if(getmine(i) < gethis(i)) return 1;
      }
      return 1;
   }
   HNum operator += (const HNum& a) { return (*this) = (*this) + a; }
   HNum operator -= (const HNum& a) { return (*this) = (*this) - a; }
   HNum operator *= (const HNum& a) { return (*this) = (*this) * a; }
   void print() const {
      // for(auto x : A | views::reverse) cerr << x;
      // cerr << '\n';
   }
};

bool alreadyinited = 0;
const int nmax = 2e2 + 5;
HNum dp[nmax];
void initdp() {
   if(alreadyinited) return;
   alreadyinited = 1;
   dp[0].initfromcst(0);
   dp[1].initfromcst(1);
   dp[2].initfromcst(0);
   dp[3].initfromcst(1);
   for(int i = 4; i < nmax; i++) {
      dp[i].initfromcst(0);
      for(int a = 0; a < i; a++) {
	 int b = i - 1 - a;
	 if(b <= a) continue;
	 dp[i] += dp[a] * dp[b];
      }
   }
   
}

namespace Encr {
   vector<vector<int>> g;
   void clear() { g.clear(); }
   int newnode() { g.emplace_back(); return sz(g) - 1; }
   void addedge(int a, int b) { g[a].emplace_back(b); g[b].emplace_back(a); return; }
   void encr(int node, int dim, HNum toencr) {
      if(dim == 1) return;
      // cerr << node << ' ' << dim << '\t'; toencr.print();
      for(int a = 1; a < dim; a++) {
	 int b = dim - a - 1;
	 if(b <= a && dim != 3) { break; }
	 // (dp[a] * dp[b]).print();
	 // (toencr).print();
	 if(dp[a] * dp[b] <= toencr) { //cerr << a << " mai mic\n";
	    toencr -= dp[a] * dp[b]; }
	 else {
	    // cerr << a << " mai mare\n";
	    HNum L, R;
	    L = toencr / dp[b];
	    R = toencr % dp[b];
	    // if(node == 170) {
	       // L.print();
	       // R.print();
	       // cerr << "<<<<<<<<<>>>>>>>>>>>\n";
	    // }
	    int l = newnode(), r = newnode();
	    assert(L < dp[a]);
	    assert(R < dp[b]);
	    encr(l, a, L);
	    encr(r, b, R);
	    addedge(node, l);
	    addedge(node, r);
	    return;
	 }
      }
   }
}

namespace Decr {
   const int nmax = 4e2 + 5;
   vector<vector<int>> g;
   int area[nmax];
   void init(int n) { g.assign(n + 5, vector<int>{}); }
   
   void initarea(int node, int f) {
      area[node] =1;
      for(auto x : g[node]) {
	 if(x == f) continue;
	 initarea(x, node);
	 area[node] += area[x];
      }
      return;
   }
   int findcentr(int node, int f, int n) {
      for(auto x : g[node]) {
	 if(x == f) continue;
	 if(area[x] * 2 > n) return findcentr(x, node, n);
      }
      return node;
   }
   void fix(int node, int f) {
      
      if(sz(g[node]) == 4) {
	 // for(auto x: g[node]) cerr << x << ' '; cerr << '\n';
	 // for(auto x: g[node]) cerr << area[x] << ' '; cerr << '\n';
	 for(int i = 0; i < sz(g[node]); i++) {
	    if(g[node][i] == f) continue;
	    if(sz(g[g[node][i]]) == 1) { swap(g[node][i], g[node].back()); g[node].pop_back(); break; }
	 }
      }
      if(sz(g[node]) == 2) {
	 for(int i = 0; i < sz(g[node]); i++) {
	    if(g[node][i] == f) continue;
	    if(sz(g[g[node][i]]) == 1) { swap(g[node][i], g[node].back()); g[node].pop_back(); break; }
	 }
      }
      for(auto x : g[node]) if(x != f) fix(x, node);
      return;
   }
   HNum getsub(int node, int f) {
      if(sz(g[node]) <= 2)  {
	 HNum a;
	 a.initfromcst(0);
	 return a;
      }
      // bool muie = 0;
      if(sz(g[node]) == 4) {
	 // cerr << node << " < --\n";
	 // for(auto x: g[node]) cerr << x << ' '; cerr << '\n';
	 // for(auto x: g[node]) cerr << area[x] << ' '; cerr << '\n';
	 for(int i = 0; i < sz(g[node]); i++) {
	    if(g[node][i] == f) continue;
	    if(sz(g[g[node][i]]) == 1) { swap(g[node][i], g[node].back()); g[node].pop_back(); break; }
	 }
      }
      int L = -1, R = -1;
      for(auto x : g[node]) {
	 if(x == f) continue;
	 if(L == -1) L = x;
	 else R = x;
      }
      if(area[L] > area[R]) swap(L, R);
      HNum lrez = getsub(L, node);
      HNum rrez = getsub(R, node);
      HNum here;
      here.initfromcst(0);
      for(int a = 1; a < area[L]; a++)
	 here += dp[a] * dp[area[node] - 1 - a];
      here += lrez * dp[area[R]] + rrez;
      return here;
   }
   
   void addedge(int a, int b) { g[a].emplace_back(b); g[b].emplace_back(a); return; }
}


std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
   initdp();
   Encr::clear();
   data.resize(min(sz(data), 95));
   HNum toencript; toencript.init(0);
   for(int i = 0; i < sz(data); i++) toencript.A.emplace_back(data[i]);
   using namespace Encr;
   int centr = newnode();
   int first = newnode(), second = newnode();
   HNum L, R;
   // dp[7].print();
   L = toencript / dp[99];
   R = toencript % dp[99];
   encr(first, 97, L);
   encr(second, 99, R);
   addedge(centr, first);
   addedge(centr, second);
   addedge(centr, newnode());
   addedge(centr, newnode());
   addedge(centr, newnode());
   vector<pii> a;
   for(int i = 0; i < sz(g); i++) {
      for(auto j : g[i])
	 if(i < j) a.emplace_back(i, j);
   }
   
   return a;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
   // cerr << "bienvenuti\n";
   initdp();
   Decr::init(n);
   using namespace Decr;
   for(auto [a, b] : tree) {
      addedge(a, b);
   }
   // for(int i = 0; i < 8; i++) cerr << sz(g[i]) << ' ';
   // cerr << '\n';
   initarea(0, 0);
   int root = findcentr(0, 0, n);
   initarea(root, root);
   HNum L, R;
   for(auto x : g[root]) {
      fix(x, root);
   }
   initarea(root, root);
   for(auto x : g[root]) {
      if(area[x] == 97 || area[x] == 98) L = getsub(x, root);
      else if(area[x] == 99 || area[x] == 100) R = getsub(x, root);
   }
   HNum rez = L * dp[99] + R;
   // cerr << "--\n";
   // for(auto x: g[root]) cerr << area[x] << ' ';
   // cerr << '\n';
   // L.print();
   // R.print();
   // cerr << "==\n";
   vector<bool> fin;
   for(auto x : rez.A) fin.emplace_back(x);
   while(sz(fin) < 95) fin.emplace_back(0);
   
   return fin;
}
