#include <iostream>
#include <vector>
#include <tuple>
#include <functional>
#include <map>
#include <cassert>
#include <set>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

const int nmax = 5e3 + 5;

namespace DS {
   int mat[nmax][nmax];
   int spec[nmax][nmax];
   void upd(int x1, int x2, int y1, int y2, int val) {
      // cerr << x1 << ' ' << x2 << ' ' << y1 << ' ' << y2 << "\t +" << val << '\n';
      mat[x1][y1] += val;
      mat[x2 + 1][y2 + 1] += val;
      mat[x2 + 1][y1] -= val;
      mat[x1][y2 + 1] -= val;
   }
   void init(int n) {
      for(int i = 1; i <= n; i++) {
	 for(int j = 1; j <= n; j++) {
	    mat[i][j] += mat[i - 1][j] + mat[i][j - 1] - mat[i - 1][j - 1];
	    // cerr << mat[i][j] << ' ';
	    // if(mat[i][j] == 0 && i <= j) cerr << i << ' ' << j << '\n'; 
	 }
	 // cerr << '\n';
      }
      for(int i = 1; i <= n; i++) {
	 for(int j = 1; j <= n; j++) {
	    spec[i][j] = (mat[i][j] == 0 && i <= j);
	    spec[i][j] += spec[i - 1][j] + spec[i][j - 1] - spec[i - 1][j - 1];
	 }
      }
   }
   int query(int l, int r) {
      return spec[r][r] + spec[l - 1][l - 1] - spec[r][l - 1] - spec[l - 1][r];
   }
}

vector<int> apar[nmax];

void init(signed n, signed q, const vector<signed>& v_) {
   vector<signed> v;
   copy(all(v_), back_inserter(v));
   
   v.insert(begin(v), -1);
   for(int i = 1; i < sz(v); i++) {
      apar[v[i]].emplace_back(i);
   }
   for(int i = 1; i <= n; i++) {
      int lst = 0;
      for(int j = 0; j < sz(apar[i]); j++)
	 DS::upd(lst + 1, apar[i][j], apar[i][j], n, 1),
	 lst = apar[i][j];
      apar[i].insert(begin(apar[i]), 0);
      apar[i].insert(end(apar[i]), n + 1);
      for(int l = 1, r = i; r < sz(apar[i]) - 1; l++, r++) {
	 DS::upd(apar[i][l - 1] + 1, apar[i][l], apar[i][r], apar[i][r + 1] - 1, -1);
      }
   }
   
   DS::init(n);
}
ll query(int l, int r) {
   ++l, ++r;
   int a = DS::query(l, r);
   assert(a <= (r - l + 1) * 2);
   return a;
}
