#include <iostream>
#include <vector>
#include <tuple>
#include <functional>
#include <cassert>
#include <map>
#include <set>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;
using tiii = tuple<int, int, int, int>;

const int nmax = 5e5 + 5;

void myassert(int a) {
   if(a) return;
   vector<int> pula;
   pula.assign(8, 192);
   while(true) {
      pula.assign(2 * sz(pula) + pula.back(), 1293);
   }
   return;
}

namespace DS {   
   template<typename T>
   struct AINTP {
      struct Node {
	 Node *l, *r;
	 T val;
      } *nil = new Node{0, 0, T()};
      using ns = Node*;
      ns root;
      
      int n;
      ns startbuild(int cl, int cr) {
	 if(cl == cr) { return new Node{nil, nil, T()}; }
	 int mid = (cl + cr) >> 1;
	 ns node = new Node{startbuild(cl, mid), startbuild(mid + 1, cr), T()};
	 node -> val.pull(node -> l -> val, node -> r -> val);
	 return node;
      }
      void init(int n_) {
	 n = n_;
	 root = startbuild(1, n);
      }
      template<class CB> ns upd(CB&& cb, int l, int r) {
	 return root = upd(cb, l, r, root, 1, n);
      }
      template<class CB> ns upd(CB&& cb, int l, int r, ns node, int cl, int cr) {
	 if(cr < l || r < cl) return node;
	 if(l <= cl && cr <= r) {
	    ns nv = new Node{node -> l, node -> r, node -> val};
	    cb(nv -> val);
	    return nv;
	 }
	 int mid = (cl + cr) >> 1;
	 ns L = upd(cb, l, r, node -> l, cl, mid);
	 ns R = upd(cb, l, r, node -> r, mid + 1, cr);
	 ns nv = new Node{L, R, T()};
	 nv -> val.pull(L -> val, R -> val);
	 return nv;
      }
      template<class CB> void query(CB&& cb, int l, int r, ns variant) {
	 query(cb, l, r, variant, 1, n);
      }
      template<class CB> void query(CB&& cb, int l, int r, ns node, int cl, int cr) {
	 if(cr < l || r < cl) return;
	 if(l <= cl && cr <= r) { 
	    cb(node -> val);
	    return;
	 }
	 int mid = (cl + cr) >> 1;
	 query(cb, l, r, node -> l, cl, mid);
	 query(cb, l, r, node -> r, mid + 1, cr);
	 return;
      }
   };
   
   
   template<typename T>
   struct AINT {
      vector<T> aint;
      int n;
      void init(int n_) {
	 n = n_;
	 aint.assign(2 * n + 5, T());
      }
      template<class CB> void walk(CB&& cb) { walk(cb, 1, n); }
      template<class CB> void walk(CB&& cb, int l, int r) { walk(cb, l, r, 1, 1, n); }
      template<class CB> void walk(CB&& cb, int l, int r, int node, int cl, int cr) { 
	 if(cr < l || r < cl) return;
	 if(l <= cl && cr <= r && !cb(aint[node], cl, cr)) return;
	 int mid = (cl + cr) >> 1, L = node + 1, R = node + (mid - cl + 1) * 2;
	 aint[node].push(aint[L], aint[R]);
	 walk(cb, l, r, L, cl, mid);
	 walk(cb, l, r, R, mid + 1, cr);
	 aint[node].pull(aint[L], aint[R]);
      }
   };
   
   struct MinCount {
      int mn;
      int count;
      int lazy;
      void apply(int a) {
	 mn += a;
	 lazy += a;
      }
      void push(MinCount& L, MinCount& R) {
	 if(lazy == 0) return;
	 L.apply(lazy);
	 R.apply(lazy);
	 lazy = 0;
      }
      void pull(const MinCount L, const MinCount R) {
	 mn = min(L.mn, R.mn);
	 count = 0;
	 if(L.mn == mn) count += L.count;
	 if(R.mn == mn) count += R.count;
	 return;
      }
   };
   
   struct Sum {
      int sum;
      void pull(const Sum L, const Sum R) {
	 sum = L.sum + R.sum;
	 return;
      }
   };
   
   AINTP<Sum>::ns alongtime[nmax];
   
   vector<tiii> qs;
   vector<pii> segm;
   void upd(int x1, int x2, int y1, int y2, int val) {
      qs.emplace_back(x1, y1, y2, val);
      qs.emplace_back(x2 + 1, y1, y2, -val);
   }
   void init(int n) {
      sort(all(qs));
      int lst = 0;
      AINT<MinCount> aint;
      aint.init(n);
      
      auto addline = [&](int L) {
	 aint.walk([&](auto &a, int cl, int cr) {
	    if(a.mn > 0) return 0;
	    if(cl == cr) {
	       myassert(a.mn == 0);
	       // cerr << '\t' << n << ' ' << cl << ' ' << cr << '\n';
	       segm.emplace_back(L, cl);
	       return 0;
	    }
	    return 1;
	 });
      };
      
      for(auto [x, l, r, val] : qs) {
	 for(int i = lst; i < x; i++) {
	    if(i != 0) addline(i);
	    aint.walk([&](auto &a, int cl, int cr) {
	       a.mn = 1e8;
	       return 0;
	    }, i, i);
	 }
	 lst = x;
	 aint.walk([&](auto &a, int cl, int cr) {
	    a.apply(val);
	    return 0;
	 }, l, r);
      }
      for(int i = lst; i <= n; i++) {
	 if(i != 0) addline(i);
	 aint.walk([&](auto &a, int cl, int cr) {
	    a.mn = 1e8;
	    return 0;
	 }, i, i);
      }
      return;
   }
   
   AINTP<Sum> aint;
   void initperst(int n) {
      sort(all(segm));
      int lst = 0;
      aint.init(n);
      for(auto [l, r] : segm) {
	 for(int i = lst; i < l; i++) alongtime[i] = aint.root;
	 aint.upd([&](Sum& a) {
	    a.sum++;
	    return;
	 }, r, r);
	 lst = l;
	 // cerr << l << ' ' << r<< '\t' << aint.root -> val.sum << '\n';
      }
      for(int i = lst; i <= n; i++) alongtime[i] = aint.root;
   }
   
   int query(int l, int r) {
      int sum = 0;
      aint.query([&](Sum& a) {
	 sum += a.sum;
	 return;
      }, l, r, alongtime[r]);
      aint.query([&](Sum& a) {
	 sum -= a.sum;
	 return;
      }, l, r, alongtime[l - 1]);
      return sum;
   }
}

vector<int> apar[nmax];

void init(signed n, signed q, const vector<signed>& v_) {
   vector<signed> v;
   copy(all(v_), back_inserter(v));
   
   v.insert(begin(v), -1);
   for(int i = 1; i < sz(v); i++) {
      apar[v[i]].emplace_back(i);
   }
   for(int i = 1; i <= n; i++) {
      int lst = 0;
      for(int j = 0; j < sz(apar[i]); j++)
	 DS::upd(lst + 1, apar[i][j], apar[i][j], n, 1),
	 lst = apar[i][j];
      apar[i].insert(begin(apar[i]), 0);
      apar[i].insert(end(apar[i]), n + 1);
      for(int l = 1, r = i; r < sz(apar[i]) - 1; l++, r++) {
	 DS::upd(apar[i][l - 1] + 1, apar[i][l], apar[i][r], apar[i][r + 1] - 1, -1);
      }
   }
   
   DS::init(n);
   DS::initperst(n);
}
ll query(int l, int r) {
   ++l, ++r;
   return DS::query(l, r);
}
