#include <bits/stdc++.h>
using namespace std;
const int NMAX = 3e5;
#define pii pair<int, int>
using ll = long long;

vector<int> posi[NMAX+1];
pii aint[4*NMAX+2];
int lazy[4*NMAX+2];

void push( int node, int left, int right ) {
  if( lazy[node] ) {
    aint[node].first += lazy[node];
    if( left != right ) {
      lazy[2*node] += lazy[node];
      lazy[2*node+1] += lazy[node];
    }
    lazy[node] = 0;
  }
}

pii combine( pii a, pii b ) {
  if( a.first > b.first )
    return a;
  if( a.first < b.first )
    return b;
  return { a.first, a.second + b.second };
}
void build( int node, int left, int right ) {
  if( left == right ) {
    aint[node] = { 0, 1 };
    lazy[node] = 0;
    return;
  }
  int mid = ( left + right ) / 2;
  build( 2 * node, left, mid );
  build( 2 * node + 1, mid + 1, right );
  aint[node] = combine( aint[2*node], aint[2*node+1] );
  lazy[node] = 0;
}
void update( int node, int left, int right, int qleft, int qright, int val ) {
  push( node, left, right );
  if( qleft > qright || left > qright || right < qleft )
    return;
  if( left >= qleft && right <= qright ) {
    lazy[node] += val;
    return;
  }
  int mid = ( left + right ) / 2;
  if( qleft <= mid )
    update( 2 * node, left, mid, qleft, qright, val );
  if( qright >= mid + 1 )
    update( 2 * node + 1, mid + 1, right, qleft, qright, val );
  push( 2 * node, left, mid ), push( 2 * node + 1, mid + 1, right );
  aint[node] = combine( aint[2*node], aint[2*node+1] );
}
pii qry( int node, int left, int right, int qleft, int qright ) {
  push( node, left, right );
  if( qleft > qright || left > qright || right < qleft )
    return { -1, 0 };
  if( left >= qleft && right <= qright )
    return aint[node];
  pii ans = { -1, 0 };
  int mid = ( left + right ) / 2;
  if( qleft <= mid )
    ans = combine( ans, qry( 2 * node, left, mid, qleft, qright ) );
  if( qright >= mid + 1 )
    ans = combine( ans, qry( 2 * node + 1, mid + 1, right, qleft, qright ) );
  return ans;
}

ll ans;
int N;
int v[NMAX+1];
void init( int n, int q, const vector<int>& a ) {
  int i, x, r, l;
  N = n;
  build( 1, 0, n - 1 );
  ans = 0;
  for( i = 0; i < n; i++ ) {
    x = a[i];
    v[i] = x;
    if( posi[x].size() >= x ) {
      r = posi[x][posi[x].size()-x];
      if( posi[x].size() > x )
        l = posi[x][posi[x].size()-x-1] + 1;
      else
        l = 0;
      update( 1, 0, n - 1, l, r, -1 );
    }

    if( posi[x].size() == 0 )   // pentru cand are 0
      update( 1, 0, n - 1, 0, i - 1, -1 );
    else
      update( 1, 0, n - 1, posi[x].back() + 1, i - 1, -1 );

    posi[x].push_back( i );
    if( posi[x].size() >= x ) {
      r = posi[x][posi[x].size()-x];
      if( posi[x].size() > x )
        l = posi[x][posi[x].size()-x-1] + 1;
      else
        l = 0;
      update( 1, 0, n - 1, l, r, +1 );
    }
    update( 1, 0, n - 1, i, i, n - 1 );
    push( 1, 0, n - 1 );
    if( aint[1].first == n )
      ans += aint[1].second;
  }
}

int query( int l, int r ) {
  if( l == 0 && r == N - 1 )
    return ans;
  int i, x, left, right;
  for( i = 1; i <= N; i++ )
    posi[i].clear();
  for( i = 0; i <= l - 1; i++ )
    posi[v[i]].push_back( i );
  build( 1, 0, N - 1 );
  ll rasp = 0;
  for( i = 1; i <= N; i++ ) {
    if( posi[i].size() == 0 )
      update( 1, 0, N - 1, 0, l - 1, +1 );
    else if( posi[i].size() < i )
      update( 1, 0, N - 1, posi[i].back() + 1, l - 1, +1 );
    else {
      update( 1, 0, N - 1, posi[i].back() + 1, l - 1, +1 );
      right = posi[i][posi[i].size() - i];
      if( posi[i].size() > i )
        left = posi[i][posi[i].size() - i - 1] + 1;
      else
        left = 0;
      update( 1, 0, N - 1, left, right, +1 );
    }
  }
  for( i = l; i <= r; i++ ) {
    x = v[i];
    if( posi[x].size() >= x ) {
      right = posi[x][posi[x].size()-x];
      if( posi[x].size() > x )
        left = posi[x][posi[x].size()-x-1] + 1;
      else
        left = 0;
      update( 1, 0, N - 1, left, right, -1 );
    }

    if( posi[x].size() == 0 )   // pentru cand are 0
      update( 1, 0, N - 1, 0, i - 1, -1 );
    else
      update( 1, 0, N - 1, posi[x].back() + 1, i - 1, -1 );

    posi[x].push_back( i );
    if( posi[x].size() >= x ) {
      right = posi[x][posi[x].size()-x];
      if( posi[x].size() > x )
        left = posi[x][posi[x].size()-x-1] + 1;
      else
        left = 0;
      update( 1, 0, N - 1, left, right, +1 );
    }
    update( 1, 0, N - 1, i, i, N - 1 );
    pii aux = qry( 1, 0, N - 1, l, i );
    if( aux.first == N )
      rasp += aux.second;
  }
  return rasp;
}
