#include<iostream>
#include<cassert>
#include "tunnels.h"
using namespace std;
const int INF = 1e9;
int n,m;
bool isfree[5005][5005],blocked[5005][5005];
void dfs(int lin, int col)
{
    assert(!isfree[lin][col]);

    cerr<<lin<<" "<<col<<" se ocupa\n";

    isfree[lin][col] = 1;
    if(col+1 < m && !isfree[lin][col+1] && !blocked[lin][col+1])
        dfs(lin,col+1);
    if(col-1 >= 0 && !isfree[lin][col-1] && !blocked[lin][col-1])
        dfs(lin,col-1);
    if(lin-1 >= 0 && !isfree[lin-1][col] && !blocked[lin-1][col])
        dfs(lin-1,col);
}
int dp[5005][5005];
int first_query[5005][5005];
pair<int,int> simplif(int lin, int le, int ri)
{
    int newle=le,newri=ri;
    while(!isfree[lin+1][newle] || !isfree[lin][newle])
        newle++;
    while(!isfree[lin+1][newri] || !isfree[lin][newri])
        newri--;
    return {newle,newri};
}
int calc_dp(int lin, int s)
{
    if(!isfree[lin][s])
        cerr<<lin<<" "<<s<<" not free\n";
    assert(isfree[lin][s]);

    for(int i=0;i<m;i++)
        dp[i][i] = -INF;
    int sle=s,sri=s;
    for(int i=s;i<m;i++)
    {
        if(blocked[lin][i])
            break;
        sri = i;
        if(isfree[lin][i] && isfree[lin+1][i])
            dp[i][i]=0;
    }
    for(int i=s;i>=0;i--)
    {
        if(blocked[lin][i])
            break;
        sle = i;
        if(isfree[lin][i] && isfree[lin+1][i])
            dp[i][i]=0;
    }
    for(int lun=2;lun<=m;lun++)
    {
        for(int le=sle;le+lun-1<=sri;le++)
        {
            int ri = le+lun-1;
            dp[le][ri] = INF;
            first_query[le][ri] = -1;

            auto [newle,newri] = simplif(lin,le,ri);

            if(newle > newri)
            {
                dp[le][ri] = -INF;
                continue;
            }

            if(le!=newle || ri!=newri)
            {
                dp[le][ri] = dp[newle][newri];
                continue;
            }

            assert(le==newle);
            assert(ri==newri);
            for(int f=le;f<=ri;f++)
            {
                if(f==s)
                    continue;
                int aux=INF;
                if(f > s)
                {
                    if(f>le) aux = max(dp[le][f-1], dp[f][ri]) + 1;
                }
                else
                {
                    assert(f < s);
                    if(f<ri) aux = max(dp[le][f], dp[f+1][ri]) + 1;
                }
                if(aux < dp[le][ri])
                {
                    dp[le][ri] = aux;
                    first_query[le][ri] = f;
                }
            }
            if(first_query[le][ri] == -1)
            {
                assert(dp[le][ri] == INF);
                dp[le][ri] = -INF;
            }
            //assert(first_query[le][ri] != -1);
        }
    }

    while(sle < sri)
    {
        auto [newle,newri] = simplif(lin,sle,sri);
        sle = newle;
        sri = newri;

        if(sle >= sri)
            break;

        //cerr<<sle<<" "<<sri<<"   "<<dp[sle][sri]<<" dp\n";
        //cerr<<sle<<" "<<sri<<"   "<<first_query[sle][sri]<<" first_query\n\n";

        int f = first_query[sle][sri];
        bool bl = investigate(f);
        if(f > s)
        {
            if(bl)
                sle = f;
            else
                sri = f-1;
        }
        else
        {
            assert(f < s);
            if(bl)
                sri = f;
            else
                sle = f+1;
        }
    }
    assert(sle==sri);
    goDeeper(sle);
    return sle;
}
void solve(int copn, int copm, int k, const std::vector<std::vector<bool>>& cop_blocked)
{
    n = copn;
    m = copm;
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
            blocked[i][j] = cop_blocked[i][j];
    for(int i=0;i<m;i++)
    {
        if(!isfree[n][i])
            dfs(n,i);
    }
    for(int i=0;i<n;i++)
    {
        k = calc_dp(i,k);
    }
}
/**


2 6 2
000010
001000


6 2 0
00
10
00
00
01
00



*/

