#include<iostream>
#include<vector>
#include<cassert>
using namespace std;
const int ROOT_INPLUS = 5;
const int FLIP_INPLUS = 5;
vector<bool> flip(vector<bool> data)
{
    vector<bool> aux;
    for(int i=0;i<data.size();i++)
    {
        if(data[i]==1)
            aux.push_back(0);
        else
            aux.push_back(1);
    }
    return aux;
}
int get_ans(vector<bool> data, int n)
{
    int cur=ROOT_INPLUS,cnt=0;
    for(int i=0;i<data.size();i++)
    {
        if(data[i]==0)
        {
            if(cur+1>=n)
                break;
            cur = cur+1;
        }
        else
        {
            if(cur+3>=n)
                break;
            cur = cur+3;
        }
        cnt=i;
    }
    return cnt;
}
std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    //assert(n == 200);

    bool flipped=0;
    if(get_ans(flip(data),n - FLIP_INPLUS) > get_ans(data,n))
    {
        data = flip(data);
        flipped=1;
    }

    vector<pair<int,int>> sol;
    int cur;
    if(flipped)
    {
        cur = ROOT_INPLUS + FLIP_INPLUS;
        for(int i=0;i<cur;i++)
            sol.push_back({cur,i});
    }
    else
    {
        cur = ROOT_INPLUS;
        for(int i=0;i<cur;i++)
            sol.push_back({cur,i});
    }


    for(int i=0;i<data.size();i++)
    {
        if(data[i]==0)
        {
            if(cur+1 >= n)
                break;
            sol.push_back({cur,cur+1});
            cur = cur+1;
        }
        else
        {
            if(cur+3 >= n)
                break;
            sol.push_back({cur,cur+1});
            sol.push_back({cur,cur+2});
            sol.push_back({cur,cur+3});
            cur = cur+3;
        }
    }
    while(cur+1 < n)
    {
        sol.push_back({cur,cur+1});
        cur++;
        //sol.push_back({ROOT_INPLUS,cur});
    }

    return sol;
}
vector<int> con[205];

int maxd[205],depth[205],nxt[205];
void dfs(int nod, int par)
{
    maxd[nod]=depth[nod];
    nxt[nod]=-1;
    for(int adj:con[nod])
    {
        if(adj==par)
            continue;
        depth[adj] = depth[nod] + 1;
        dfs(adj,nod);
        if(maxd[adj] > maxd[nod])
        {
            maxd[nod] = maxd[adj];
            nxt[nod] = adj;
        }
    }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    assert(n<=200);
    for(int i=0;i<n+1;i++)
        con[i].clear();


    for(auto [u,v]:tree)
    {
        con[u].push_back(v);
        con[v].push_back(u);
    }
    int root=0;
    for(int i=0;i<n+1;i++)
        if((int)con[i].size() > (int)con[root].size())
            root = i;

    depth[root]=0;
    dfs(root,-1);

    bool flipped=0;
    vector<bool> data;
    if((int)con[root].size() >= ROOT_INPLUS + FLIP_INPLUS)
    {
        flipped=1;
        if((int)con[root].size() >= ROOT_INPLUS + FLIP_INPLUS + 3)
        {
            data.push_back(1);
        }
        else
        {
            data.push_back(0);
        }
    }
    else
    {
        if((int)con[root].size() >= ROOT_INPLUS + 3)
        {
            data.push_back(1);
        }
        else
        {
            data.push_back(0);
        }
    }


    int cur = nxt[root];
    while(cur != -1)
    {
        if((int)con[cur].size() >= 4)
        {
            data.push_back(1);
        }
        else
        {
            data.push_back(0);
        }
        cur = nxt[cur];
    }
    if(flipped)
    {
        for(int i=0;i<data.size();i++)
            data[i] = 1 - data[i];
    }
    return data;
}
/**

1
30 60 110010000011111110101001001001101010111011011011101001111110


*/
