#include<iostream>
#include<vector>
#include<cassert>
#include<algorithm>
#include<cmath>
using namespace std;
#define int long long
const int INF = 1e9;
int n;
long long tot=0;
vector<int> pozs[300005];
int incle[300005];

struct PerSegTree
{
    struct node
    {
        int sum;
        int tole,tori;
    };
    node emp = {0,-1,-1};
    vector<node> aint;
    vector<int> roots;
    node combine(int idle, int idri)
    {
        return {aint[idle].sum + aint[idri].sum, idle, idri};
    }
    int build(int st, int dr)
    {
        if(st==dr)
        {
            aint.push_back(emp);
            return aint.size() - 1;
        }
        int mij=(st+dr)/2;
        aint.push_back(combine(build(st,mij), build(mij+1,dr)));
        return aint.size() - 1;
    }
    void init()
    {
        roots.push_back(build(0,n-1));
    }

    int upd(int oldnod, int st, int dr, int poz, int newv)
    {
        if(st==dr)
        {
            aint.push_back(emp);
            aint.back().sum = aint[oldnod].sum + newv;
            return aint.size() - 1;
        }
        int mij=(st+dr)/2;
        if(poz<=mij)
        {
            aint.push_back(combine(upd(aint[oldnod].tole,st,mij,poz,newv), aint[oldnod].tori));
        }
        else
        {
            aint.push_back(combine(aint[oldnod].tole, upd(aint[oldnod].tori, mij+1, dr, poz, newv)));
        }
        return aint.size() - 1;
    }
    void update(int poz, int newv)
    {
        roots.push_back(upd(roots.back(),0,n-1,poz,newv));
    }

    int qry(int nod, int st, int dr, int le, int ri)
    {
        if(le>ri)
            return 0;
        if(le==st && dr==ri)
            return aint[nod].sum;
        int mij=(st+dr)/2;
        return qry(aint[nod].tole,st,mij,le,min(mij,ri)) + qry(aint[nod].tori,mij+1,dr,max(mij+1,le),ri);
    }
    int query(int le, int ri, int t)
    {
        return qry(roots[t],0,n-1,le,ri);
    }
};

pair<int,int> combine(pair<int,int> x, pair<int,int> y)
{
    if(x.first < y.first)
        return x;
    if(x.first > y.first)
        return y;
    return {x.first, x.second + y.second};
}
pair<int,int> aint[1100000];
int lazy[1100000];
void propagate(int nod)
{
    if(!lazy[nod])
        return;
    lazy[nod*2] += lazy[nod];
    lazy[nod*2+1] += lazy[nod];
    aint[nod*2].first += lazy[nod];
    aint[nod*2+1].first += lazy[nod];
    lazy[nod]=0;
}
void build(int nod, int st, int dr)
{
    lazy[nod]=0;
    if(st==dr)
    {
        aint[nod] = {0,1};
        return;
    }
    int mij=(st+dr)/2;
    build(nod*2,st,mij);
    build(nod*2+1,mij+1,dr);
    aint[nod] = combine(aint[nod*2], aint[nod*2+1]);
}
void upd(int nod, int st, int dr, int le, int ri, int newv)
{
    if(le>ri)
        return;
    if(le==st && dr==ri)
    {
        aint[nod].first += newv;
        lazy[nod] += newv;
        return;
    }
    propagate(nod);
    int mij=(st+dr)/2;
    upd(nod*2,st,mij,le,min(mij,ri),newv);
    upd(nod*2+1,mij+1,dr,max(mij+1,le),ri,newv);
    aint[nod] = combine(aint[nod*2], aint[nod*2+1]);
}
pair<int,int> qry(int nod, int st, int dr, int le, int ri)
{
    if(le>ri)
        return {INF,0};
    if(le==st && dr==ri)
        return aint[nod];
    propagate(nod);
    int mij=(st+dr)/2;
    return combine(qry(nod*2,st,mij,le,min(mij,ri)),
                   qry(nod*2+1,mij+1,dr,max(mij+1,le),ri));
}
vector<int> ids;
void get_ids(int nod, int st, int dr, int le, int ri)
{
    if(le>ri || aint[nod].first > 0)
        return;
    int mij=(st+dr)/2;
    if(le==st && dr==ri)
    {
        if(aint[nod].second == dr-st+1)
        {
            for(int i=st;i<=dr;i++)
                ids.push_back(i);
            return;
        }
        propagate(nod);
        get_ids(nod*2,st,mij,st,mij);
        get_ids(nod*2+1,mij+1,dr,mij+1,dr);
        return;
    }
    propagate(nod);
    get_ids(nod*2,st,mij,le,min(mij,ri));
    get_ids(nod*2+1,mij+1,dr,max(mij+1,le),ri);
}

void baga(int le, int ri)
{
    if(le>ri)
        return;
    upd(1,0,n-1,le,ri,+1);
}
void scoate(int le, int ri)
{
    if(le>ri)
        return;
    upd(1,0,n-1,le,ri,-1);
}

PerSegTree segtree;

int myt[300005];
void init(int32_t N, int32_t Q, const std::vector<int32_t>& a)
{
    n=N;
    assert(n <= 300000);
    build(1,0,n-1);
    segtree.init();
    tot=0;
    int maxle=0;
    for(int i=0;i<n;i++)
    {
        assert(a[i]<=n);

        if((int)pozs[a[i]].size() >= a[i])
        {
            scoate(pozs[a[i]][(int)pozs[a[i]].size() - a[i]] + 1, pozs[a[i]].back());
        }
        else if(!pozs[a[i]].empty())
        {
            scoate(0,pozs[a[i]].back());
        }

        pozs[a[i]].push_back(i);

        if((int)pozs[a[i]].size() >= a[i])
        {
            baga(pozs[a[i]][(int)pozs[a[i]].size() - a[i]] + 1, pozs[a[i]].back());
        }
        else
        {
            baga(0,pozs[a[i]].back());
        }

        if((int)pozs[a[i]].size() > a[i])
            maxle = max(maxle, pozs[a[i]][pozs[a[i]].size() - a[i] - 1] + 1);

        incle[i] = maxle;

        pair<int,int> x = qry(1,0,n-1,maxle,i);
        if(x.first==0)
        {
            tot += x.second;
            assert(x.second <= 2*(sqrt(n)+5));
            ids.clear();
            get_ids(1,0,n-1,maxle,i);
            assert((int)ids.size() == x.second);
            for(int le:ids)
            {
                assert(0<=le && le<n);
                segtree.update(le,+1);
            }
        }
        myt[i] = segtree.roots.size() - 1;
    }

}
long long query(int32_t l, int32_t r)
{
    /*long long cnt=0;
    for(auto [le,ri]:bune)
        if(l <= le && ri <= r)
            cnt++;
    return cnt;*/
    return segtree.query(l,r,myt[r]);
}
/**

o sa avem maxim 2*sqrt le-uri bune la fiecare ri
candidatii o sa fie prev(x,x)
luam doar cele mai mici sqrt valori

7 3
1 2 1 2 3 3 3
0 3
2 6
0 6

*/
