#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#define MAXN 5005
#define MAXT 700
#define TEST 0
using namespace std;

struct AINT{
  int nr,pozMi;
};

AINT aint[MAXT][MAXN];
int sir[MAXN];
int nextWrong[MAXN];
int nextGood[MAXN];

int invNorm[MAXN];
int vf[MAXT][MAXN];
int norm[MAXT];
int nrApar[MAXN];
int auxi[MAXN];
AINT valori[MAXT];
int n,q,m;

AINT Comb(AINT a,AINT b){
  return {a.nr+b.nr,min(a.pozMi,b.pozMi)};
}

void InitAint(int x,int y,int t,int poz){
  int mij;

  if(x==y){
    if(invNorm[sir[x]]==t){
      aint[t][poz]={1, x};
    }else{
      aint[t][poz]={0,MAXN};
    }
    return;
  }

  mij=(x+y)/2;

  InitAint(x    ,mij,t,poz*2  );
  InitAint(mij+1,y  ,t,poz*2+1);

  aint[t][poz]=Comb(aint[t][poz*2],aint[t][poz*2+1]);
}

AINT Querry(int x,int y,int a,int b,int t,int poz){
  int mij;

  if(b<x || y<a){
    return {0,MAXN};
  }

  if(a<=x && y<=b){
    return aint[t][poz];
  }

  mij=(x+y)/2;
  return Comb(Querry(x,mij,a,b,t,poz*2),Querry(mij+1,y,a,b,t,poz*2+1));
}

int IMPOS;

void init(int N, int Q, const std::vector<int>& a){
  int i,z,st,dr,ma,j,ok,x,ans;

  n=N;
  q=Q;

  for(i=0;i<n;i++){
    sir[i]=a[i];
    auxi[i]=sir[i];
  }


  for(i=0;i<MAXN;i++){
    nrApar[sir[i]]++;
    invNorm[i]=-1;
  }

  sort(auxi,auxi+n);

  m=1;
  i=0;
  while(i<n && nrApar[auxi[i]]<auxi[i]){
    i++;
  }

  if(i==n){
    IMPOS=1;
  }

  norm[0]=auxi[i];
  invNorm[auxi[i]]=0;
  for(i++;i<n;i++){
    if(auxi[i]!=auxi[i-1] && nrApar[sir[i]]>=sir[i]){
      norm[m]=auxi[i];
      invNorm[auxi[i]]=m;
      m++;
    }
  }

  for(i=0;i<m;i++){
    for(j=0;j<MAXN;j++){
      vf[i][j]=-1;
    }
  }

  for(i=n-1;i>=0;i--){
    if(invNorm[sir[i]]!=-1){
      if(vf[invNorm[sir[i]]][0]==-1){
        nextWrong[i]=n;
      }else{
        nextWrong[i]=vf[invNorm[sir[i]]][0];
      }
      if(vf[invNorm[sir[i]]][1]==-1){
        nextGood[i]=n;
      }else{
        nextGood[i]=vf[invNorm[sir[i]]][1];
      }
      for(j=1;j<sir[i];j++){
        vf[invNorm[sir[i]]][j-1]=vf[invNorm[sir[i]]][j];
      }
      vf[invNorm[sir[i]]][sir[i]-1]=i;
    }
  }

  for(i=0;i<m;i++){
    InitAint(0,n-1,i,1);
  }

  if(TEST==1){
    printf("\nNorm : ");
    for(i=0;i<m;i++){
      printf("%2d ",norm[i]);
    }
    printf("\nSir       : ");
    for(i=0;i<n;i++){
      printf("%2d ",sir[i]);
    }
    printf("\nInvNorm   : ");
    for(i=0;i<n;i++){
      printf("%2d ",invNorm[i]);
    }
    printf("\nnextWrong : ");
    for(i=0;i<n;i++){
      printf("%2d ",nextWrong[i]);
    }
    printf("\nnextGood  : ");
    for(i=0;i<n;i++){
      printf("%2d ",nextGood[i]);
    }
    printf("\n");
  }
}

long long query(int st, int dr){
  if(IMPOS==1){
    return 0;
  }

  int i,z,ma,j,ok,x;
  int miGres,maCore;
  long long ans;

  ans=0;

  for(i=st;i<=dr;i++){
    if(invNorm[sir[i]]!=-1){
      miGres=nextWrong[i];
      maCore=i;
      ok=1;
      while(x<=dr && maCore<=dr && maCore<miGres && ok==1){
        int superOk=1;
        for(j=0;j<m;j++){
          valori[j]=Querry(0,n-1,i,maCore,j,1);
          if(valori[j].nr!=0){
            if(valori[j].nr>norm[j]){
              ok=0;
            }
            if(valori[j].nr!=norm[j]){
              superOk=0;
            }
            if(valori[j].nr<norm[j]){
              maCore=max(maCore,nextGood[valori[j].pozMi]);
              miGres=min(miGres,nextWrong[valori[j].pozMi]);
            }
          }
        }

        if(superOk==1){
          ans++;
          maCore++;
        }
      }
    }
  }

  return ans;
}
