#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include "tunnels.h"

std::mt19937 rng(123);
#define debug(x) #x << " = " << x << '\n'

using ll = long long;

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &a) {
  std::vector<std::vector<bool>> down(n + 1, std::vector<bool>(m, false));
  for (int j = 0; j < m; j++) {
    down[n][j] = true;
    down[n - 1][j] = !a[n - 1][j];
  }
  std::vector<std::vector<int>> st(n, std::vector<int>(m));
  std::vector<std::vector<int>> dr(n, std::vector<int>(m));
  
  for (int i = 0; i < n; i++) {
    st[i][0] = a[i][0] == 0? 0 : 1;
    for (int j = 1; j < m; j++) {
      if (a[i][j] == 1) {
        st[i][j] = j + 1;
      } else {
        st[i][j] = st[i][j - 1];
      }
    }
    dr[i][m - 1] = a[i][m - 1] == 0? m - 1: m - 2;
    for (int j = m - 2; j >= 0; j--) {
      if (a[i][j] == 1) {
        dr[i][j] = j - 1;
      } else {
        dr[i][j] = dr[i][j + 1];
      }
    }
  }

  for (int i = n - 2; i >= 0; i--) {
    for (int j = 0; j < m; j++) {
      down[i][j] = false;
      if (a[i][j] == 0) {
        for (int k = st[i][j]; k <= dr[i][j]; k++) {
          down[i][j] = down[i][j] | down[i + 1][k];
        }
      }
    }
  }

  for (int i = 0; i < n; i++) {
    // cobor pe un range
    std::vector<int> cand;
    for (int j = st[i][k]; j <= dr[i][k]; j++) {
      if (down[i + 1][j]) {
        cand.push_back(j);
      }
    }
    // std::cout << debug(k);
    // std::cout << debug((int) cand.size());
    // continue;
    std::shuffle(cand.begin(), cand.end(), rng);
    int where = -1;
    for (int j = 0; j + 1 < (int) cand.size(); j++) {
      if (investigate(cand[j])) {
        where = cand[j];
        break;
      }
    }
    if (where == -1) {
      where = cand.back();
    }
    goDeeper(where);
    k = where;
  }
}