#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include "tunnels.h"

std::mt19937 rng(123);
#define debug(x) #x << " = " << x << '\n'

using ll = long long;

const int INF = 1e9;

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &a) {
  std::vector<std::vector<int>> dp(n + 1, std::vector<int>(m, INF));
  bool allzero = true;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (a[i][j] == 1) {
        allzero = false;
      }
    }
  }
  std::vector<std::vector<bool>> down(n + 1, std::vector<bool>(m, false));
  for (int j = 0; j < m; j++) {
    down[n][j] = true;
    down[n - 1][j] = !a[n - 1][j];
  }
  std::vector<std::vector<int>> st(n, std::vector<int>(m));
  std::vector<std::vector<int>> dr(n, std::vector<int>(m));
  
  if (allzero) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        down[i][j] = true;
        st[i][j] = 0;
        dr[i][j] = m - 1;
      }
    }
  } else {
    for (int i = 0; i < n; i++) {
      st[i][0] = a[i][0] == 0? 0 : 1;
      for (int j = 1; j < m; j++) {
        if (a[i][j] == 1) {
          st[i][j] = j + 1;
        } else {
          st[i][j] = st[i][j - 1];
        }
      }
      dr[i][m - 1] = a[i][m - 1] == 0? m - 1: m - 2;
      for (int j = m - 2; j >= 0; j--) {
        if (a[i][j] == 1) {
          dr[i][j] = j - 1;
        } else {
          dr[i][j] = dr[i][j + 1];
        }
      }
    }

    for (int j = 0; j < m; j++) {
      dp[n][j] = 0;
    }
    for (int i = n - 1; i >= 0; i--) {
      for (int j = 0; j < m; j++) {
        if (a[i][j] == 1) {
          dp[i][j] = INF;
        } else { 
          std::vector<int> cand;
          for (int p = st[i][j]; p <= dr[i][j]; p++) {
            if (dp[i + 1][p] < INF) {
              cand.push_back(p);
            }
          }
          if (cand.empty()) {
            dp[i][j] = INF;
            continue;
          }

          std::sort(cand.begin(), cand.end(), [&](int x, int y) {
            return dp[i + 1][x] > dp[i + 1][y];
          });
          dp[i][j] = dp[i + 1][cand.back()] + (int) cand.size() - 1;
          for (int p = 0; p < (int) cand.size(); p++) {
            if (p != (int) cand.size() - 1) {
              dp[i][j] = std::max(dp[i][j], dp[i + 1][cand[p]] + p + 1);
            }
          }
        }
      }
    }
  }

  for (int i = 0; i < n; i++) {
    std::vector<int> cand;
    for (int j = st[i][k]; j <= dr[i][k]; j++) {
      if (dp[i + 1][j] != INF) {
        cand.push_back(j);
      }
    }
    std::sort(cand.begin(), cand.end(), [&](int x, int y) {
      return dp[i + 1][x] > dp[i + 1][y];
    });
    int where = cand.back();
    for (int j = 0; j + 1 < (int) cand.size(); j++) {
      if (investigate(cand[j])) {
        where = cand[j];
        break;
      }
    }
    goDeeper(where);
    k = where;
  }
}