#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include "tunnels.h"

#define debug(x) #x << " = " << x << '\n'

using ll = long long;

const int INF = 1e9;

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &a) {
  // if (m == 2) {
  //   for (int i = 0; i < n; i++) {
  //     if (i == n - 1) {
  //       int to = -1;
  //       if (a[i][0] == 0 && a[i][1] == 0) {
  //         if (investigate(0)) {
  //           to = 0;
  //         } else {
  //           to = 1;
  //         }
  //       } else if (a[i][0] == 1) {
  //         to = 1;
  //       } else if (a[i][1] == 1) {
  //         to = 0;
  //       } else {
  //         assert(false);
  //       }
  //       goDeeper(to);
  //       return;
  //     }
  //     int to = -1;
  //     if (a[i][0] == 0 && a[i][1] == 0 && a[i + 1][0] == 0 && a[i + 1][1] == 0) {
  //       if (investigate(0)) {
  //         to = 0;
  //       } else {
  //         to = 1;
  //       }
  //     } else if (a[i + 1][0] == 1) {
  //       to = 1;
  //     } else if (a[i + 1][1] == 1) {
  //       to = 0;
  //     } else if (a[i][0] == 1) {
  //       to = 1;
  //     } else if (a[i][1] == 1) {
  //       to = 0;
  //     } else {
  //       assert(false);
  //     }
  //     goDeeper(to);
  //   }
  //   return;
  // }
  std::vector<std::vector<int>> dp(n + 1, std::vector<int>(m, INF));
  bool allzero = true;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (a[i][j] == 1) {
        allzero = false;
      }
    }
  }
  if (allzero) {
    for (int i = 0; i < n; i++) {
      int to = m - 1;
      for (int j = 0; j < m - 1; j++) {
        if (investigate(j)) {
          to = j;
          break;
        } 
      }
      goDeeper(to);
      k = to;
    }
    return;
  } else {
    assert(false);
  }
  std::vector<std::vector<int>> st(n, std::vector<int>(m));
  std::vector<std::vector<int>> dr(n, std::vector<int>(m));
  
  for (int i = 0; i < n; i++) {
    st[i][0] = a[i][0] == 0? 0 : 1;
    for (int j = 1; j < m; j++) {
      if (a[i][j] == 1) {
        st[i][j] = j + 1;
      } else {
        st[i][j] = st[i][j - 1];
      }
    }
    dr[i][m - 1] = a[i][m - 1] == 0? m - 1: m - 2;
    for (int j = m - 2; j >= 0; j--) {
      if (a[i][j] == 1) {
        dr[i][j] = j - 1;
      } else {
        dr[i][j] = dr[i][j + 1];
      }
    }
  }

  for (int j = 0; j < m; j++) {
    dp[n][j] = 0;
  }
  for (int i = n - 1; i >= 0; i--) {
    for (int j = 0; j < m; j++) {
      if (a[i][j] == 1) {
        dp[i][j] = INF;
      } else { 
        std::vector<int> cand;
        for (int p = st[i][j]; p <= dr[i][j]; p++) {
          if (dp[i + 1][p] < INF) {
            cand.push_back(p);
          }
        }
        if (cand.empty()) {
          dp[i][j] = INF;
          continue;
        }

        std::sort(cand.begin(), cand.end(), [&](int x, int y) {
          return dp[i + 1][x] > dp[i + 1][y];
        });
        dp[i][j] = dp[i + 1][cand.back()] + (int) cand.size() - 1;
        for (int p = 0; p + 1 < (int) cand.size(); p++) {
          dp[i][j] = std::max(dp[i][j], dp[i + 1][cand[p]] + p + 1);
        }
      }
    }
  }

  for (int i = 0; i < n; i++) {
    std::vector<int> cand;
    for (int j = st[i][k]; j <= dr[i][k]; j++) {
      if (dp[i + 1][j] != INF) {
        cand.push_back(j);
      }
    }
    std::sort(cand.begin(), cand.end(), [&](int x, int y) {
      return dp[i + 1][x] > dp[i + 1][y];
    });
    int where = cand.back();
    for (int j = 0; j + 1 < (int) cand.size(); j++) {
      if (investigate(cand[j])) {
        where = cand[j];
        break;
      }
    }
    goDeeper(where);
    k = where;
  }
}