#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>

using ll = long long;
using ull = unsigned long long;
#define debug(x) #x << " = " << x << '\n'

const int NMAX = 3e5;

std::mt19937_64 rng(123);

int a[NMAX + 2];
int f[NMAX + 1];
int prev[NMAX + 1];
int good = 0;
ull hsh[NMAX + 1];

ull sumHashes = 0;
ull sum[NMAX + 1];

int len = 0;

int distincte = 0;

void add(int x) {
  if (f[x] == 0) {
    distincte++;
    len += x;
    sumHashes += (ull) hsh[x] * (ull) x;
  }
  good -= f[x] == x;
  f[x]++;
  good += f[x] == x;
}
void rem(int x) {
  good -= f[x] == x;
  f[x]--;
  good += f[x] == x;
  if (f[x] == 0) {
    sumHashes -= (ull) hsh[x] * (ull) x;
    distincte--;
    len -= x;
  }
}

bool isGood(int l, int r) {
  return sum[r] - sum[l - 1] == sumHashes;
}

int main() {
  #ifdef LOCAL
freopen("input.txt", "r", stdin);
  #endif
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);

  int n, q;
  std::cin >> n >> q;

  for (int i = 1; i <= n; i++) {
    std::cin >> a[i];
    hsh[i] = rng();
  }
  a[n + 1] = 0;

  int maxdistinct = 1;
  while (maxdistinct * (maxdistinct + 1) / 2 < n) {
    maxdistinct++;
  }

  len = 0;


  for (int i = 1; i <= n; i++) {
    sum[i] = sum[i - 1] + hsh[a[i]];
  }

  int answer = 0;
  for (int cate = 1; cate <= maxdistinct; cate++) {
    assert(len == 0);
    assert(distincte == 0);
    assert(good == 0);
    add(a[1]);
    for (int i = 1, j = 1; i <= n; i++) { // [i..j] sunt puse
      if (j < i) {
        add(a[++j]);
      }
      while (distincte <= cate && j <= n) {
        add(a[++j]);
      }
      // i = l si am atatea distincte
      // std::cout << " ? " << cate << ' ' << i << ' ' << j << '\n';
      int l = i, r = i + len - a[j] - 1;
      // am cel mult `cate` distincte
      sumHashes -= (ull) hsh[a[j]] * a[j];
      if (cate == distincte - 1 && l <= r && prev[i] < r && r < j && isGood(l, r)) {
        answer++;
      }
      sumHashes += (ull) hsh[a[j]] * a[j];
      prev[i] = j - 1;
      rem(a[i]);
    }
    rem(0);
  }
  std::cout << answer;
  
  return 0;
}