#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#pragma GCC optimize("Ofast")

using ll = long long;
using ull = unsigned long long;
#define debug(x) #x << " = " << x << '\n'

const int NMAX = 3e5;
const int BS = 512;

int suma[NMAX / BS + 2][NMAX + 1];

std::vector<int> when[NMAX + 1];

void update(int time, int pos) {
  suma[pos / BS][time]++;
  when[pos].push_back(time);
}
int getMe(int who, int time) {
  return std::upper_bound(when[who].begin(), when[who].end(), time) - when[who].begin() - 1;
}
int query(int time, int l, int r) {
  int bl = l / BS;
  int br = r / BS;
  int ret = 0;
  if (br - bl <= 1) {
    for (int i = l; i <= r; i++) {
      ret += getMe(i, time);
    }
    return ret;
  }
  for (int i = bl + 1; i < br; i++) {
    ret += suma[time][i];
  }
  for (int i = l; i < BS * (bl + 1); i++) {
    ret += getMe(i, time);
  }
  for (int i = br * BS; i <= r; i++) {
    ret + getMe(i, time);
  }
  return ret;
}

std::mt19937_64 rng(123);

int a[NMAX + 2];
int f[NMAX + 1];
int prev[NMAX + 1];
int good = 0;
ull hsh[NMAX + 1];

ull sumHashes = 0;
ull sum[NMAX + 1];

int len = 0;

int distincte = 0;

void add(int x) {
  if (f[x] == 0) {
    distincte++;
    len += x;
    sumHashes += (ull) hsh[x] * (ull) x;
  }
  good -= f[x] == x;
  f[x]++;
  good += f[x] == x;
}
void rem(int x) {
  good -= f[x] == x;
  f[x]--;
  good += f[x] == x;
  if (f[x] == 0) {
    sumHashes -= (ull) hsh[x] * (ull) x;
    distincte--;
    len -= x;
  }
}

int answer;

void init(int n, int q, const std::vector<int> &A) {
  std::vector<int> a = A;
  a.insert(a.begin(), 0);
  a.push_back(0);
  for (int i = 1; i <= n; i++) {
    hsh[i] = rng();
  }
  int maxdistinct = 1;
  while (maxdistinct * (maxdistinct + 1) / 2 < n) {
    maxdistinct++;
  }

  len = 0;


  for (int i = 1; i <= n; i++) {
    sum[i] = sum[i - 1] + hsh[a[i]];
  }

  for (int cate = 1; cate <= maxdistinct; cate++) {
    add(a[1]);
    for (int i = 1, j = 1; i <= n; i++) { // [i..j] sunt puse
      if (j < i) {
        add(a[++j]);
      }
      while (distincte <= cate && j <= n) {
        add(a[++j]);
      }
      // i = l si am atatea distincte
      // std::cout << " ? " << cate << ' ' << i << ' ' << j << '\n';
      int l = i, r = i + len - a[j] - 1;
      // am cel mult `cate` distincte
      sumHashes -= (ull) hsh[a[j]] * a[j];
      if (cate == distincte - 1 && l <= r && prev[i] < r && r < j && sum[r] - sum[l - 1] == sumHashes) {
        answer++;
        update(r, l);
        // std::cout << " ! " << l << ' ' << r << '\n';
      }
      sumHashes += (ull) hsh[a[j]] * a[j];
      prev[i] = j - 1;
      rem(a[i]);
    }
    rem(0);
  }

  for (int i = 1; i <= n; i++) {
    when[i].push_back(0);
    std::sort(when[i].begin(), when[i].end());
  }
  // for (int i = 1; i <= n; i++) {
  //   for (const auto &j : when[i]) {
  //     std::cout << j << ' ';
  //   }
  //   std::cout << '\n';
  //   std::cout << " > " << getMe(i, 1) << ' ' << getMe(i, 2) << ' ' << getMe(i, 3) << '\n';
  // }

  for (int bucket = 1; bucket <= NMAX / BS + 1; bucket++) {
    for (int time = 1; time <= n; time++) {
      suma[bucket][time] += suma[bucket][time - 1];
    }
  }
}

long long query(int l, int r) {
  l++, r++;
  return query(r, l, r) - query(l - 1, l, r);
}