#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#pragma GCC optimize("Ofast")

using ll = long long;
using ull = unsigned long long;
#define debug(x) #x << " = " << x << '\n'

const int NMAX = 3e5;

std::mt19937_64 rng(123);

int a[NMAX + 2];
int f[NMAX + 1];
int prev[NMAX + 1];
int good = 0;
ull hsh[NMAX + 1];

ull sumHashes = 0;
ull sum[NMAX + 1];
std::vector<int> sweep[NMAX + 1];

struct Node {
  int cnt;
  Node* l;
  Node* r;
  Node() {
    cnt = 0;
    l = r = nullptr;
  }
  Node(int x) {
    cnt = x;
    l = r = nullptr;
  }
};

Node* version[NMAX + 1];


Node* update(Node* node, int tl, int tr, int pos) {
  if (tl == tr) {
    return new Node(node -> cnt + 1);
  } else {
    int mid = (tl + tr) / 2;
    Node* ret = new Node();
    *ret = *node;
    if (pos <= mid) {
      if (node -> l == nullptr) {
        node -> l = new Node();
      }
      ret -> l = update(node -> l, tl, mid, pos);
      ret -> cnt = ret -> l -> cnt;
      if (ret -> r != nullptr) {
        ret -> cnt += ret -> r -> cnt;
      }
    } else {
      if (node -> r == nullptr) {
        node -> r = new Node();
      }
      ret -> r = update(node -> r, mid + 1, tr, pos);
      ret -> cnt = ret -> r -> cnt;
      if (ret -> l != nullptr) {
        ret -> cnt += ret -> l -> cnt;
      }
    }
    return ret;
  }
}

int query(Node* node, int tl, int tr, int l, int r) {
  if (l <= tl && tr <= r) {
    return node -> cnt;
  }
  int mid = (tl + tr) / 2;
  int ret = 0;
  if (l <= mid && node -> l != nullptr) {
    ret += query(node -> l, tl, mid, l, r);
  }
  if (mid < r && node -> r != nullptr) {
    ret += query(node -> r, mid + 1, tr, l, r);
  }
  return ret;
}

int len = 0;

int distincte = 0;

void add(int x) {
  if (f[x] == 0) {
    distincte++;
    len += x;
    sumHashes += (ull) hsh[x] * (ull) x;
  }
  good -= f[x] == x;
  f[x]++;
  good += f[x] == x;
}
void rem(int x) {
  good -= f[x] == x;
  f[x]--;
  good += f[x] == x;
  if (f[x] == 0) {
    sumHashes -= (ull) hsh[x] * (ull) x;
    distincte--;
    len -= x;
  }
}

int answer;

std::pair<int, int> ranges[NMAX * 10 + 1];
int cnt_ranges = 0;
int n;

void init(int N, int q, const std::vector<int> &A) {
  n = N;
  std::vector<int> a = A;
  a.insert(a.begin(), 0);
  a.push_back(0);
  for (int i = 1; i <= n; i++) {
    hsh[i] = rng();
  }
  int maxdistinct = 1;
  while (maxdistinct * (maxdistinct + 1) / 2 < n) {
    maxdistinct++;
  }

  len = 0;

  for (int i = 1; i <= n; i++) {
    sum[i] = sum[i - 1] + hsh[a[i]];
  }

  for (int cate = 1; cate <= maxdistinct; cate++) {
    add(a[1]);
    for (int i = 1, j = 1; i <= n; i++) { // [i..j] sunt puse
      if (j < i) {
        add(a[++j]);
      }
      while (distincte <= cate && j <= n) {
        add(a[++j]);
      }
      // i = l si am atatea distincte
      // std::cout << " ? " << cate << ' ' << i << ' ' << j << '\n';
      int l = i, r = i + len - a[j] - 1;
      // am cel mult `cate` distincte
      sumHashes -= (ull) hsh[a[j]] * a[j];
      if (cate == distincte - 1 && l <= r && prev[i] < r && r < j && sum[r] - sum[l - 1] == sumHashes) {
        cnt_ranges++;
        sweep[r].push_back(l);
      }
      sumHashes += (ull) hsh[a[j]] * a[j];
      prev[i] = j - 1;
      rem(a[i]);
    }
    rem(0);
  }

  // version[0] = new Node();
  // for (int i = 1; i <= n; i++) {
  //   version[i] = new Node();
  //   *version[i] = *version[i - 1];
  //   for (const auto &l : sweep[i]) {
  //     version[i] = update(version[i], 1, n, l);
  //   }
  // }
}

long long query(int l, int r) {
  return cnt_ranges;
  l++, r++;
  return query(version[r], 1, n, l, r) - query(version[l - 1], 1, n, l, r);
}