#include<bits/stdc++.h>

using namespace std;

const int NMAX = 3e5;

vector <int> values[NMAX + 1];

int v[NMAX + 1];

struct node {
    int maxim;
    int frecv;
    int lazy;
} aint[4 * NMAX];

int n;

void propag( int i ) {
    int l = aint[i].lazy;

    aint[i * 2 + 1].maxim += l;
    aint[i * 2 + 2].maxim += l;
    aint[i * 2 + 1].lazy += l;
    aint[i * 2 + 2].lazy += l;

    aint[i].lazy = 0;
}

node combine( node a, node b ) {
    a.lazy = b.lazy = 0;
    if ( a.maxim != b.maxim ) {
        if ( a.maxim > b.maxim ) return a;
        return b;
    }

    return { a.maxim, a.frecv + b.frecv, 0 };
}
void update( int st, int dr, int a, int b, int val, int i = 0 ) {
    //cout << st << ' ' << dr << ": " << aint[i].maxim << ' ' << aint[i].lazy << endl;
    if ( st == a && dr == b ) {
        aint[i].maxim += val;
        //cout << st << ' ' << dr << ": " << aint[i].maxim << endl;
        aint[i].lazy += val;
    } else {
        propag( i );
        int mij = ( st + dr ) / 2;
        if ( b <= mij ) update( st, mij, a, b, val, i * 2 + 1 );
        else if ( a > mij ) update( mij + 1, dr, a, b, val, i * 2 + 2 );
        else {
            update( st, mij, a, mij, val, i * 2 + 1 );
            update( mij + 1, dr, mij + 1, b, val, i * 2 + 2 );
        }
        aint[i] = combine( aint[i * 2 + 1], aint[i * 2 + 2] );
    }
}

node qry( int st, int dr, int a, int b, int i = 0 ) {
    if ( st == a && dr == b ) return aint[i];
    propag( i );
    int mij = ( st + dr ) / 2;
    if ( b <= mij ) return qry( st, mij, a, b, i * 2 + 1 );
    if ( a > mij ) return qry( mij + 1, dr, a, b, i * 2 + 2 );
    return combine( qry( st, mij, a, mij, i * 2 + 1 ),
                    qry( mij + 1, dr, mij + 1, b, i * 2 + 2 ) );
}

vector <pair<int, int>> ops[NMAX + 1];

int L, R;

int chestie[NMAX + 1];

void upd( int i, int st, int dr ) {
    //cout << "OP: " << i << ": " << st << ' ' << dr << ' ' << -1 << '\n';
    update( L, R, st, dr, -1 );
    //for ( int i = st; i <= dr; i ++ ) chestie[i] --;
    ops[i].push_back( {st, dr} );
}
void undo( int i ) {
    for ( auto p : ops[i] ) {
        //cout << "OP: " << i << ": " << p.first << ' ' << p.second << ' ' << +1 << '\n';
        //for ( int i = p.first; i <= p.second; i ++ ) chestie[i] ++;
        update( L, R, p.first, p.second, +1 );
    }
}

void clearAint( int st, int dr, int l, int r, int i = 0 ) {
    if ( st == dr ) aint[i] = { 0, 1, 0 };
    else {
        int mij = ( st + dr ) / 2;
        clearAint( st, mij, l, r, i * 2 + 1 );
        clearAint( mij + 1, dr, l, r, i * 2 + 2 );
        aint[i] = combine( aint[i * 2 + 1], aint[i * 2 + 2] );
    }
}
long long query( int l, int r ) {
//    cout << l << ' ' << r << endl;
    long long ans = 0;
    L = l;
    R = r;
    clearAint( L, R, l, r );
    for ( int i = l; i <= r; i ++ ) {
        values[v[i]].clear();
        ops[i].clear();
    }
    for ( int i = l; i <= r; i ++ ) {
        ops[i].clear();
        if ( values[v[i]].empty() ) {
            if ( v[i] != 1 ) {
                upd( i, l, i );
            }
        } else {
            undo( values[v[i]].back() );
            if ( v[i] == 1 ) {
                upd( i, l, values[v[i]].back() );
            } else {
                int l1 = -1, l2 = -1;
                if ( values[v[i]].size() >= v[i] - 1 ) l2 = values[v[i]][values[v[i]].size() - v[i] + 1];
                if ( values[v[i]].size() >= v[i] ) l1 = values[v[i]][values[v[i]].size() - v[i]];
//                cout << i << ": " << l1 << ' ' << l2 << endl;
                if ( l2 == -1 ) {
                    upd( i, l, i );
                } else {
                    upd( i, l2 + 1, i );
                    if ( l1 != -1 ) upd( i, l, l1 );
                }
            }
        }
        values[v[i]].push_back( i );
        auto q = qry( L, R, l, i );
//        cout << "ANS: " << q.frecv * (q.maxim == 0) << endl;
        if ( q.maxim == 0 ) ans += q.frecv;
    }
    return ans;
}
void init( int N, int q, const std::vector <int>& a ) {
    n = N;
    for ( int i = 0; i < n; i ++ ) v[i] = a[i];
}

int frecv[NMAX + 1];

long long queryBrut( int l, int r ) {
    long long ans = 0;
    for ( int i = l; i <= r; i ++ ) {
        for ( int k = l; k <= r; k ++ ) frecv[v[k]] = 0;
        int cntBad = 0;
        for ( int j = i; j <= r; j ++ ) {
            if ( !frecv[v[j]] ) cntBad ++;
            frecv[v[j]] ++;
            if ( frecv[v[j]] == v[j] ) cntBad --;
            else if ( frecv[v[j]] == v[j] + 1 ) break;
            if ( cntBad == 0 ) ans ++;

        }
    }
    int n = r - l + 1;
    assert( ans <= (n + 1) * sqrt( n )  );
    return ans;
}
