#include "tunnels.h"

#include <vector>

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    std::vector<std::vector<int>> nxt, prv;
    nxt.resize(n);
    prv.resize(n);
    for (int i = 0; i < n; i++) {
        nxt[i].resize(m);
        prv[i].resize(m);
        for (int j = 0; j < m; j++) {
            if (j == 0)
                prv[i][j] = -1;
            else prv[i][j] = (blocked[i][j - 1] ? j - 1 : prv[i][j - 1]);
        }
        for (int j = m - 1; j >= 0; j--) {
            if (j == m - 1)
                nxt[i][j] = m;
            else nxt[i][j] = (blocked[i][j + 1] ? j + 1 : nxt[i][j + 1]);
        }
    }

    int j = k;
    for (int i = 0; i < n; i++) {
        bool dreapta = false;

        if (j + 1 < m && !blocked[i][j + 1] && investigate(j + 1)) {
            dreapta = true;
        }

        if (dreapta) {
            int unde = j + 1;
            int st = j + 2;
            int dr = nxt[i][j + 1] - 1;
            while (st <= dr) {
                int mij = (st + dr) / 2;
                if (investigate(mij)) {
                    unde = mij;
                    st = mij + 1;
                } else {
                    dr = mij - 1;
                }
            }
            goDeeper(unde);
            j = unde;
        } else {
            int unde = j;
            int st = prv[i][j] + 1;
            int dr = j - 1;
            while (st <= dr) {
                int mij = (st + dr) / 2;
                if (investigate(mij)) {
                    unde = mij;
                    dr = mij - 1;
                } else {
                    st = mij + 1;
                }
            }
            goDeeper(unde);
            j = unde;
        }
    }
}
