#include "tunnels.h"

#include <queue>
#include <vector>

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    std::vector<std::vector<int>> nxt, prv;
    std::vector<std::vector<bool>> reachSt, reachDr;
    nxt.resize(n);
    prv.resize(n);
    reachSt.resize(n);
    reachDr.resize(n);
    for (int i = 0; i < n; i++) {
        nxt[i].resize(m);
        prv[i].resize(m);
        reachSt[i].resize(m);
        reachDr[i].resize(m);
        for (int j = 0; j < m; j++) {
            if (j == 0)
                prv[i][j] = -1;
            else prv[i][j] = (blocked[i][j - 1] ? j - 1 : prv[i][j - 1]);
        }
        for (int j = m - 1; j >= 0; j--) {
            if (j == m - 1)
                nxt[i][j] = m;
            else nxt[i][j] = (blocked[i][j + 1] ? j + 1 : nxt[i][j + 1]);
        }
    }

    for (int j = 0; j < m; j++)
        reachSt[n - 1][j] = reachDr[n - 1][j] = !blocked[n - 1][j];


    for (int i = n - 2; i >= 0; i--) {
        bool ok = false;
        for (int j = 0; j < m; j++) {
            if (blocked[i][j]) {
                reachSt[i][j] = false;
                ok = false;
                continue;
            }
            if (reachSt[i + 1][j] || reachDr[i + 1][j])
                ok = true;
            reachSt[i][j] = ok;
        }
        ok = false;
        for (int j = m - 1; j >= 0; j--) {
            if (blocked[i][j]) {
                reachDr[i][j] = false;
                ok = false;
                continue;
            }
            if (reachSt[i + 1][j] || reachDr[i + 1][j])
                ok = true;
            reachDr[i][j] = ok;
        }
    }



    int j = k;
    for (int i = 0; i < n; i++) {
        bool dreapta = false;

        if (j + 1 < m && !blocked[i][j + 1] && reachDr[i][j + 1] && investigate(j + 1)) {
            dreapta = true;
        }

        if (dreapta) {
            int unde = j + 1;
            int st = j + 2;
            int dr = nxt[i][j + 1] - 1;
            //useless ngl
            while (dr >= 0 && !reachDr[i][dr])
                dr--;
            while (st <= dr) {
                int mij = (st + dr) / 2;
                if (investigate(mij)) {
                    unde = mij;
                    st = mij + 1;
                } else {
                    dr = mij - 1;
                }
            }
            goDeeper(unde);
            j = unde;
        } else {
            if (j == 0 || !reachSt[i][j - 1]) {
                goDeeper(j);
                continue;
            }
            int unde = j;
            int st = prv[i][j] + 1;
            int dr = j - 1;
            while (st < m && !reachSt[i][st])
                st++;
            while (st <= dr) {
                int mij = (st + dr) / 2;
                if (investigate(mij)) {
                    unde = mij;
                    dr = mij - 1;
                } else {
                    st = mij + 1;
                }
            }
            goDeeper(unde);
            j = unde;
        }
    }
}
