#include "tunnels.h"

#include <queue>
#include <vector>

bool self_min(int &x, int y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    std::vector<std::vector<int>> nxt, prv;
    std::vector<std::vector<bool>> reachSt, reachDr;
    nxt.resize(n);
    prv.resize(n);
    reachSt.resize(n);
    reachDr.resize(n);
    for (int i = 0; i < n; i++) {
        nxt[i].resize(m);
        prv[i].resize(m);
        reachSt[i].resize(m);
        reachDr[i].resize(m);
        for (int j = 0; j < m; j++) {
            if (j == 0)
                prv[i][j] = -1;
            else prv[i][j] = (blocked[i][j - 1] ? j - 1 : prv[i][j - 1]);
        }
        for (int j = m - 1; j >= 0; j--) {
            if (j == m - 1)
                nxt[i][j] = m;
            else nxt[i][j] = (blocked[i][j + 1] ? j + 1 : nxt[i][j + 1]);
        }
    }

    for (int j = 0; j < m; j++)
        reachSt[n - 1][j] = reachDr[n - 1][j] = !blocked[n - 1][j];


    for (int i = n - 2; i >= 0; i--) {
        bool ok = false;
        for (int j = 0; j < m; j++) {
            if (blocked[i][j]) {
                reachSt[i][j] = false;
                ok = false;
                continue;
            }
            if (reachSt[i + 1][j] || reachDr[i + 1][j])
                ok = true;
            reachSt[i][j] = ok;
        }
        ok = false;
        for (int j = m - 1; j >= 0; j--) {
            if (blocked[i][j]) {
                reachDr[i][j] = false;
                ok = false;
                continue;
            }
            if (reachSt[i + 1][j] || reachDr[i + 1][j])
                ok = true;
            reachDr[i][j] = ok;
        }
    }

    std::vector<std::vector<int>> dp;
    std::vector<std::vector<int>> unde;
    dp.resize(m);
    unde.resize(m);
    for (int i = 0; i < m; i++) {
        dp[i].resize(m);
        unde[i].resize(m);
    }

    int j = k;
    for (int i = 0; i < n; i++) {


        bool dreapta = false;

        int dr = j + 1;
        while (dr < m && reachDr[i][dr])
            dr++;
        dr--;

        int st = j - 1;
        while (st >= 0 && reachSt[i][st])
            st--;
        st++;

        if (st == dr) {
            goDeeper(j);
            continue;
        }


        for (int l = dr; l >= st; l--) {
            for (int r = l; r <= dr; r++) {
                if (l == r) {
                    dp[l][r] = 0;
                    continue;
                }

                dp[l][r] = m + m;

                for (int k = l; k <= r; k++) {
                    if (k == j) continue;
                    if (l >= j && k == l) continue;
                    if (r <= j && k == r) continue;

                    if (k > j) {
                        if (self_min(dp[l][r], std::max(dp[k][r], dp[l][k - 1])))
                            unde[l][r] = k;
                    }
                    else {
                        if (self_min(dp[l][r], std::max(dp[l][k], dp[k + 1][r])))
                            unde[l][r] = k;
                    }
                }

                dp[l][r]++;
            }
        }

        while (st != dr) {
            int pos = unde[st][dr];
            if (pos > j) {
                if (investigate(pos))
                    st = pos;
                else dr = pos - 1;
            } else {
                if (investigate(pos))
                    dr = pos;
                else st = pos + 1;
            }
        }

        goDeeper(st);
    }
}
