#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

struct ST {
    struct node {
        ll mn, cnt, pl;

        node() : mn(0), cnt(0), pl(0) {}
    };

    ll n;
    vector<node> t;

    ST(ll n) : n(n), t(4 * n) { build(1, 0, n); }

    node merge(node a, node b) {
        node c;
        c.mn = min(a.mn, b.mn);
        c.cnt = (a.mn == c.mn ? a.cnt : 0) + (b.mn == c.mn ? b.cnt : 0);
        return c;
    }

    void update(ll v, ll x) {
        t[v].mn += x;
        t[v].pl += x;
    }

    void push(ll v) {
        update(v * 2, t[v].pl);
        update(v * 2 + 1, t[v].pl);
        t[v].pl = 0;
    }

    void build(ll v, ll l, ll r) {
        if (l + 1 == r) {
            t[v].cnt = 1;
            return;
        }
        ll m = (l + r) / 2;
        push(v);
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(ll l, ll r, ll x) {
        if (l >= r) return;
        update(1, 0, n, l, r, x);
    }

    void update(ll v, ll l, ll r, ll L, ll R, ll x) {
        if (l >= R || r <= L) return;
        if (l >= L && r <= R) {
            update(v, x);
            return;
        }
        push(v);
        ll m = (l + r) / 2;
        update(v * 2, l, m, L, R, x);
        update(v * 2 + 1, m, r, L, R, x);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    ll get() {
        return t[1].mn == 0 ? t[1].cnt : 0;
    }
};

const int N = 3e5 + 5;

ll n, q, a[N], ans;
deque<ll> dq[N];


void init(int _n, int _q, const std::vector<int>& _a) {
    n = _n;
    q = _q;
    for (ll i = 0; i < n; i++) a[i] = _a[i];
    for (ll i = 0; i < N; i++) dq[i].push_front(n);

    ST t(n);
    for (ll i = n - 1; i >= 0; i--) {
        if (a[i] >= N) {
            t.update(i, n, 1);
        } else {
            ll l, r;
            l = dq[a[i]][0], r = (dq[a[i]].size() >= a[i] ? dq[a[i]][a[i] - 1] : n);
            t.update(l, r, -1);
            if (dq[a[i]].size() > a[i]) t.update(dq[a[i]][a[i]], n, -1);

            dq[a[i]].push_front(i);

            l = dq[a[i]][0], r = (dq[a[i]].size() >= a[i] ? dq[a[i]][a[i] - 1] : n);
            t.update(l, r, +1);
            if (dq[a[i]].size() > a[i]) t.update(dq[a[i]][a[i]], n, +1);
        }
        ans += t.get() - i;
    }
}

ll query(int l, int r) {
    return ans;
}