#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;

bool ckmin(int &x, int y) {
    if (x > y) {
        x = y;
        return true;
    } else {
        return false;
    }
}

array<vector<vector<int>>, 2> find_dp(vector<int> a) {
    int n = a.size();
    vector dp(n, vector<int>(n + 1, inf)), par(n, vector<int>(n + 1, -1));
    for (int i = 0; i < n; ++i) {
        dp[i][i + 1] = a[i];
    }
    for (int l = n - 1; l >= 0; --l) {
        for (int r = l + 2; r <= n; ++r) {
            for (int mid = l + 1; mid < r; ++mid) {
                if (ckmin(dp[l][r], 1 + max(dp[l][mid], dp[mid][r]))) {
                    par[l][r] = mid;
                }
            }
        }
    }
    return {dp, par};
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &blocked) {
//    vector blocked(n, vector<char>(m));
    vector dp(n + 1, vector<int>(m, -1));
    bool anyBlock = false;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            blocked[i][j] = Blocked[i][j];
            if (blocked[i][j]) {
                anyBlock = true;
                dp[i][j] = inf;
            }
        }
    }
    if (!anyBlock) {
        fill(dp[n].begin(), dp[n].end(), 0);
        for (int i = n - 1; i >= 0; --i) {
            for (int s = 0, j = 0; s < m; s = j) {
                vector<int> nxt;
                while (j < m && blocked[i][s] == blocked[i][j]) {
                    if (dp[i + 1][j] < inf) {
                        nxt.push_back(j);
                    }
                    j += 1;
                }
                if (blocked[i][s]) {
                    continue;
                }
                if (nxt.empty()) {
                    while (s < j) {
                        dp[i][s++] = inf;
                    }
                    continue;
                }

                vector<int> nxa;
                for (int u : nxt) {
                    nxa.push_back(dp[i + 1][u]);
                }
                int op = 0;
                int len = m;
                while (len > 1) {
                    len = (len + 1) / 2;
                    op += 1;
                }
//                auto [dq, par] = find_dp(nxa);
//                parent[i][s] = par;
                for (int mid = s; mid < j; ++mid) {
                    dp[i][mid] = op + dp[i + 1][0];
                }
            }
        }
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cerr << dp[i][j] << " ";
//        }
//        cerr << endl;
//    }
        int i = 0, j = k;
        while (i < n) {
            int l = j, r = j + 1;
            vector<int> nxt;
            while (l >= 0 && !blocked[i][l]) {
                if (dp[i + 1][l] < inf) {
                    nxt.push_back(l);
                }
                l -= 1;
            }
            while (r < m && !blocked[i][r]) {
                if (dp[i + 1][r] < inf) {
                    nxt.push_back(r);
                }
                r += 1;
            }
            l += 1;
//        cerr << l << " " << r << endl;
            sort(nxt.begin(), nxt.end());
            int x = 0, y = nxt.size();
            while (x + 1 < y) {
                int mid = ((x + y) >> 1) - 1;
                int pos = nxt[mid];
                if (pos >= j) {
                    if (investigate(pos + 1)) {
                        x = mid + 1;
                    } else {
                        y = mid + 1;
                    }
                } else {
                    if (investigate(pos)) {
                        y = mid + 1;
                    } else {
                        x = mid + 1;
                    }
                }
            }
            goDeeper(j = nxt[x]);
            i += 1;
        }
        return;
    }
    fill(dp[n].begin(), dp[n].end(), 0);
    vector parent(n, vector(m, vector<vector<int>>{}));
    vector first_move(n, vector<int>(m, -1));
    for (int i = n - 1; i >= 0; --i) {
        for (int s = 0, j = 0; s < m; s = j) {
            vector<int> nxt;
            while (j < m && blocked[i][s] == blocked[i][j]) {
                if (dp[i + 1][j] < inf) {
                    nxt.push_back(j);
                }
                j += 1;
            }
            if (blocked[i][s]) {
                continue;
            }
            if (nxt.empty()) {
                while (s < j) {
                    dp[i][s++] = inf;
                }
                continue;
            }

            vector<int> nxa;
            for (int u : nxt) {
                nxa.push_back(dp[i + 1][u]);
            }
            auto [dq, par] = find_dp(nxa);
            parent[i][s] = par;
            for (int mid = s; mid < j; ++mid) {
                dp[i][mid] = dq[0].back();
            }
        }
    }
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cerr << dp[i][j] << " ";
//        }
//        cerr << endl;
//    }
    int i = 0, j = k;
    while (i < n) {
        int l = j, r = j + 1;
        vector<int> nxt;
        while (l >= 0 && !blocked[i][l]) {
            if (dp[i + 1][l] < inf) {
                nxt.push_back(l);
            }
            l -= 1;
        }
        while (r < m && !blocked[i][r]) {
            if (dp[i + 1][r] < inf) {
                nxt.push_back(r);
            }
            r += 1;
        }
        l += 1;
//        cerr << l << " " << r << endl;
        sort(nxt.begin(), nxt.end());
        auto &par = parent[i][l];
        int x = 0, y = nxt.size();
        while (x + 1 < y) {
            int mid = par[x][y] - 1;
            int pos = nxt[mid];
            if (pos >= j) {
                if (investigate(pos + 1)) {
                    x = mid + 1;
                } else {
                    y = mid + 1;
                }
            } else {
                if (investigate(pos)) {
                    y = mid + 1;
                } else {
                    x = mid + 1;
                }
            }
        }
        goDeeper(j = nxt[x]);
        i += 1;
    }
}