#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;

bool ckmin(int &x, int y) {
    if (x > y) {
        x = y;
        return true;
    } else {
        return false;
    }
}

pair<int, vector<vector<int>>> find_dp2(vector<int> a) {
    int n = a.size();
    vector dp(n, vector<int>(n + 1, inf)), par(n, vector<int>(n + 1, -1));
    for (int i = 0; i < n; ++i) {
        dp[i][i + 1] = a[i];
        par[i][i + 1] = i;
    }
    for (int l = n - 1; l >= 0; --l) {
        for (int r = l + 2; r <= n; ++r) {
            // par[l][r] <= par[l + 1][r]
            // par[l][r - 1] <= par[l][r]
            int lx = (r - 1 <= l ? l + 1 : par[l][r - 1]);
            int rx = (l + 1 >= r ? r - 1 : par[l + 1][r]);
//            cerr << lx << " " << rx << " to " << l << " " << r << endl;
            for (int mid = lx; mid <= rx; ++mid) {
                if (ckmin(dp[l][r], 1 + max(dp[l][mid], dp[mid][r]))) {
                    par[l][r] = mid;
                }
            }
        }
    }
    return {dp[0][n], par};
}

vector<vector<int>> solve2(int n, int m, int k, const vector<vector<bool>> &blocked) {
    vector dp(n + 1, vector<int>(m, -1));
    bool anyBlock = false;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            blocked[i][j] = Blocked[i][j];
            if (blocked[i][j]) {
                anyBlock = true;
                dp[i][j] = inf;
            }
        }
    }
    fill(dp[n].begin(), dp[n].end(), 0);
    vector parent(n, vector(m, vector<vector<int>>{}));
    vector first_move(n, vector<int>(m, -1));
    for (int i = n - 1; i >= 0; --i) {
        for (int s = 0, j = 0; s < m; s = j) {
            vector<int> nxt;
            while (j < m && blocked[i][s] == blocked[i][j]) {
                if (dp[i + 1][j] < inf) {
                    nxt.push_back(j);
                }
                j += 1;
            }
            if (blocked[i][s]) {
                continue;
            }
            if (nxt.empty()) {
                while (s < j) {
                    dp[i][s++] = inf;
                }
                continue;
            }

            vector<int> nxa;
            for (int u : nxt) {
                nxa.push_back(dp[i + 1][u]);
            }
            auto [dq, par] = find_dp2(nxa);
            parent[i][s] = par;
            for (int mid = s; mid < j; ++mid) {
                dp[i][mid] = dq;
            }
        }
    }
    return dp;
}

constexpr int D = 15;

pair<int, vector<vector<int>>> find_dp(vector<int> a) {
    int n = a.size();
    vector dp(n, vector<int>(D * 2 + 1, 1e9));
    // D = __lg(n);
    int lvl = max(0, *max_element(a.begin(), a.end()) - D);
    for (int i = 0; i < a.size(); ++i) {
        a[i] = max(a[i], lvl) - lvl;
    }
    for (int i = 0; i < n; ++i) {
        dp[i][a[i]] = i;
    }
    for (int d = 1; d <= 2 * D; ++d) {
        for (int i = 0; i < n; ++i) {
            dp[i][d] = min(dp[i][d], dp[i][d - 1]);
            int l = dp[i][d - 1];
            if (l > i) {
                continue;
            }
            if (l > 0) {
                dp[i][d] = min(dp[i][d], dp[l - 1][d - 1]);
            }
        }
    }
    int res = lvl + 2 * D;
    for (int d = 0; d <= 2 * D; ++d) {
        if (dp[n - 1][d] <= 0) {
            res = lvl + d;
            return {res, dp};
        }
    }
    exit(228);
    return {res, dp};
//    vector dp(n, vector<int>(n + 1, inf)), par(n, vector<int>(n + 1, -1));
//    for (int i = 0; i < n; ++i) {
//        dp[i][i + 1] = a[i];
//        par[i][i + 1] = i;
//    }
//    for (int l = n - 1; l >= 0; --l) {
//        for (int r = l + 2; r <= n; ++r) {
//            // par[l][r] <= par[l + 1][r]
//            // par[l][r - 1] <= par[l][r]
//            int lx = (r - 1 <= l ? l + 1 : par[l][r - 1]);
//            int rx = (l + 1 >= r ? r - 1 : par[l + 1][r]);
////            cerr << lx << " " << rx << " to " << l << " " << r << endl;
//            for (int mid = lx; mid <= rx; ++mid) {
//                if (ckmin(dp[l][r], 1 + max(dp[l][mid], dp[mid][r]))) {
//                    par[l][r] = mid;
//                }
//            }
//        }
//    }
//    return {dp[0][n], par};
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &blocked) {
//    vector blocked(n, vector<char>(m));
    vector dp(n + 1, vector<int>(m, -1));
    bool anyBlock = false;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            blocked[i][j] = Blocked[i][j];
            if (blocked[i][j]) {
                anyBlock = true;
                dp[i][j] = inf;
            }
        }
    }
//    auto res = solve2(n, m, k, blocked);
    fill(dp[n].begin(), dp[n].end(), 0);
    vector parent(n, vector(m, vector<vector<int>>{}));
    vector st(n, vector<int>(m, -1));
    vector first_move(n, vector<int>(m, -1));
    for (int i = n - 1; i >= 0; --i) {
        for (int s = 0, j = 0; s < m; s = j) {
            vector<int> nxt;
            while (j < m && blocked[i][s] == blocked[i][j]) {
                if (dp[i + 1][j] < inf) {
                    nxt.push_back(j);
                }
                j += 1;
            }
            if (blocked[i][s]) {
                continue;
            }
            if (nxt.empty()) {
                while (s < j) {
                    dp[i][s++] = inf;
                }
                continue;
            }

            vector<int> nxa;
            for (int u : nxt) {
                nxa.push_back(dp[i + 1][u]);
            }
            auto [dq, par] = find_dp(nxa);
            parent[i][s] = par;
            for (int mid = s; mid < j; ++mid) {
                dp[i][mid] = dq;
            }
        }
    }
//    assert(res == dp);
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cerr << (dp[i][j] >= inf ? -1 : dp[i][j]) << " ";
//        }
//        cerr << endl;
//    }
    int i = 0, j = k;
    while (i < n) {
//        cout << "process: " << i << endl;
        int l = j, r = j + 1;
        vector<int> nxt;
        while (l >= 0 && !blocked[i][l]) {
            if (dp[i + 1][l] < inf) {
                nxt.push_back(l);
            }
            l -= 1;
        }
        while (r < m && !blocked[i][r]) {
            if (dp[i + 1][r] < inf) {
                nxt.push_back(r);
            }
            r += 1;
        }
        l += 1;
//        cerr << l << " " << r << endl;
        sort(nxt.begin(), nxt.end());
        auto &par = parent[i][l];
        int x = 0, y = nxt.size();
        int d = 2 * D; // st[i][l];
        while (x + 1 < y) {
            assert(d > 0);
            if (par[y - 1][d - 1] <= x) {
                d -= 1;
                continue;
            }
//            cout << x << " " << y << " " << d << endl;
            int mid = par[y - 1][d - 1] - 1;
//            assert(mid > x);
            int pos = nxt[mid];
//            cout << mid << " " << pos << endl;
            if (pos >= j) {
                if (investigate(pos + 1)) {
                    x = mid + 1;
                } else {
                    y = mid + 1;
                }
            } else {
                if (investigate(pos)) {
                    y = mid + 1;
                } else {
                    x = mid + 1;
                }
            }
            d -= 1;
        }
        goDeeper(j = nxt[x]);
        i += 1;
    }
}