#include<bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> a;

constexpr int N_ = 1e7;
int top = 1;
struct Info {
    int L = 0, R = 0;
    int sum;
};
Info tree[N_];
vector<int> roots;

int create() {
    tree[top].sum = tree[top].L = tree[top].R = 0;
    return top++;
}

int build(int lx, int rx) {
    int x = create();
    int mid = lx + rx >> 1;
    if (lx + 1 < rx) {
        tree[x].L = build(lx, mid);
        tree[x].R = build(mid, rx);
    }
    return x;
}

int modify(int x, int lx, int rx, int i) {
    int nx = create();
    tree[nx] = tree[x];
    tree[nx].sum += 1;
    if (lx + 1 < rx) {
        int mid = lx + rx >> 1;
        if (i < mid) {
            tree[nx].L = modify(tree[x].L, lx, mid, i);
        } else {
            tree[nx].R = modify(tree[x].R, mid, rx, i);
        }
    }
    return nx;
}

int rangeSum(int x, int lx, int rx, int l, int r) {
    if (!x || l >= rx || lx >= r) {
        return 0;
    }
    if (l <= lx && rx <= r) {
        return tree[x].sum;
    }
    int mid = lx + rx >> 1;
    return rangeSum(tree[x].L, lx, mid, l, r) + rangeSum(tree[x].R, mid, rx, l, r);
}

void init(int N, int Q, const std::vector<int>& a_) {
    a = a_;
    vector<vector<int>> adj(N + 1);
    set<pair<int, int>, greater<>> st; // {start, x}
    vector<vector<int>> best(N);
    int cnt = 0;
    int lim = -1;
    roots.assign(N + 1, 0);
    roots[0] = 0;
    for (int i = 0; i < N; ++i) {
        int x = a[i];
        adj[x].push_back(i);
        if (adj[x].size() >= x) {
            int rem = adj[x].size() == x ? -1 : adj[x].rbegin()[x];
            if (rem != -1) {
                st.erase({rem, x});
                lim = max(lim, rem);
            }
            st.emplace(adj[x].rbegin()[x - 1], x);
        }
        auto it = st.begin();
        int sum = 0;
        roots[i + 1] = roots[i];
        while (it != st.end()) {
            auto [start, y] = *(it++);
            sum += y;
            if (start <= lim) {
                break;
            }
            if (i - sum + 1 == start) {
                roots[i + 1] = modify(roots[i + 1], 0, N, start);
                best[i].push_back(start);
                cnt += 1;
                assert(cnt <= N * 20);
            }
        }
    }
}

long long query(int l, int r) {
    return rangeSum(roots[r + 1], 0, a.size(), l, r + 1);
    int N = a.size();
    vector<vector<int>> adj(N + 1);
    set<pair<int, int>, greater<>> st; // {start, x}
    int cnt = 0;
    int lim = -1;
    for (int i = l; i <= r; ++i) {
        int x = a[i];
        adj[x].push_back(i);
        if (adj[x].size() >= x) {
            int rem = adj[x].size() == x ? -1 : adj[x].rbegin()[x];
            if (rem != -1) {
                st.erase({rem, x});
                lim = max(lim, rem);
            }
            st.emplace(adj[x].rbegin()[x - 1], x);
        }
        auto it = st.begin();
        int sum = 0;
        while (it != st.end()) {
            auto [start, y] = *(it++);
            sum += y;
            if (start <= lim) {
                break;
            }
            if (i - sum + 1 == start) {
                cnt += 1;
            }
        }
    }
    return cnt;
}

//int main(){
//	std::ios_base::sync_with_stdio(false);
//	std::cin.tie(nullptr); std::cout.tie(nullptr);
//	int n, q; std::cin >> n >> q;
//	std::vector<int> input(n);
//	for(int i = 0; i < n; i ++){
//		std::cin >> input[i];
//	}
//	init(n, q, input);
//	for(int i = 0; i < q; i ++){
//		int l, r;
//		std::cin >> l >> r;
//		std::cout << query(l, r) << " ";
//	}
//	std::cout << std::endl;
//}
