#include<bits/stdc++.h>
#include"bits_and_tree.h"
using namespace std;

vector<bool> get_sample(int n) {
	mt19937 rng(338);
	vector<bool> ret(n);
	for (int i = 0; i < n; ++i) ret[i] = rng() & 1;
	return ret;
}

vector<pair<int, int>> encode(int n, vector<bool> data) {
	auto sample = get_sample(n);
	vector<pair<int, int>> tree;
	tree.emplace_back(0, 4);
	tree.emplace_back(1, 4);
	tree.emplace_back(2, 4);
	tree.emplace_back(3, 4);
	tree.emplace_back(4, 5);
	int sz = 5;
	for (int i = 0; i < n; ++i) {
		if (data[i] != sample[i]) {
			tree.emplace_back(sz, sz + 1);
			sz++;
		} else {
			tree.emplace_back(sz, sz + 1);
			tree.emplace_back(sz, sz + 2);
			tree.emplace_back(sz, sz + 3);
			sz += 3;
		}
	}
	while (tree.size() && tree.back().second >= n) tree.pop_back();
	return tree;
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
	for (int del = 0; del <= n; ++del) {
		vector<vector<int>> g(n + 1);
		for (auto [x, y] : tree) {
			if (del == x || del == y) continue;
			g[x].push_back(y);
			g[y].push_back(x);
		}
		vector<bool> used(n + 1);
		used[del] = true;
		int prv = -1;
		int st = 0;
		while (st <= n && g[st].size() < 4) ++st;
		if (st > n) continue;
		vector<bool> data;
		bool ok = true;
		while (ok) {
			used[st] = true;
			int cntneighb = 0;
			int nxt = -1;
			for (auto x : g[st]) {
				used[x] = true;
				if (x == prv) continue;
				if (g[x].size() > 1) {
					if (nxt != -1) ok = false;
					nxt = x;
				} else {
					cntneighb++;
				}
			}
			if (nxt == -1) {
				if (cntneighb == 3) data.push_back(true);
				else if (cntneighb == 1) data.push_back(false);
				else ok = false;
				break;
			}
			if (cntneighb == 4) {}
			else if (cntneighb == 2) data.push_back(true);
			else if (cntneighb == 0) data.push_back(false);
			else ok = false;
			prv = st;
			st = nxt;
		}
		for (int i = 0; i <= n; ++i) ok &= used[i];
		if (ok) {
			while (data.size() < n) data.push_back(false);
			auto sample = get_sample(n);
			vector<bool> ret(n);
			for (int i = 0; i < n; ++i) {
				if (!data[i]) ret[i] = !sample[i];
				else ret[i] = sample[i];
			}
			return ret;
		}
	}
	assert(false);
}