#include<bits/stdc++.h>
#include"bits_and_tree.h"
using namespace std;

vector<bool> get_sample(int n) {
	mt19937 rng(228);
	vector<bool> ret(n);
	for (int i = 0; i < n; ++i) ret[i] = rng() & 1;
	return ret;
}

vector<pair<int, int>> encode(int n, vector<bool> data) {
	// assert(n == 200 && data.size() == 2 * n);
	auto sample = get_sample(data.size());
	vector<pair<int, int>> tree;
	tree.emplace_back(0, 5);
	tree.emplace_back(1, 5);
	tree.emplace_back(2, 5);
	tree.emplace_back(3, 5);
	tree.emplace_back(4, 5);
	tree.emplace_back(5, 6);
	int sz = 6;
	for (int i = 0; i < data.size(); ++i) {
		if (data[i] != sample[i]) {
			if (sz + 1 >= n) break;
			tree.emplace_back(sz, sz + 1);
			sz++;
		} else {
			if (sz + 3 >= n) break;
			tree.emplace_back(sz, sz + 1);
			tree.emplace_back(sz, sz + 2);
			tree.emplace_back(sz, sz + 3);
			sz += 3;
		}
	}
	while (sz + 1 < n) {
		++sz;
		tree.emplace_back(sz, 5);
	}
	return tree;
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
	for (int del = 0; del <= n; ++del) {
		vector<vector<int>> g(n + 1);
		for (auto [x, y] : tree) {
			if (del == x || del == y) {
				continue;
			}
			g[x].push_back(y);
			g[y].push_back(x);
		}
		vector<bool> used(n + 1);
		used[del] = true;
		int prv = -1;
		int st = 0;
		while (st <= n && g[st].size() <= 5) ++st;
		if (st > n) continue;
		vector<bool> data;
		int ok = 0;
		while (ok == 0) {
			used[st] = true;
			int cntneighb = 0;
			int nxt = -1;
			for (auto x : g[st]) {
				used[x] = true;
				if (x == prv) continue;
				if (g[x].size() > 1) {
					if (nxt != -1) ok = -1;
					nxt = x;
				} else {
					cntneighb++;
				}
			}
			if (nxt == -1) {
				if (cntneighb == 3) data.push_back(true);
				else if (cntneighb == 1) data.push_back(false);
				else ok = -2;
				break;
			}
			if (cntneighb >= 5) {}
			else if (cntneighb == 2) data.push_back(true);
			else if (cntneighb == 0) data.push_back(false);
			else ok = -3;
			prv = st;
			st = nxt;
		}
		for (int i = 0; i <= n; ++i) if (!used[i]) ok = -4;
		if (ok == 0) {
			while (data.size() < 2 * n) data.push_back(false);
			auto sample = get_sample(2 * n);
			vector<bool> ret(2 * n);
			for (int i = 0; i < n; ++i) {
				if (!data[i]) ret[i] = !sample[i];
				else ret[i] = sample[i];
			}
			return ret;
		}
	}
	// return vector(n, false);
	assert(false);
}