#include<bits/stdc++.h>
#include"bits_and_tree.h"
using namespace std;

vector<bool> get_sample(int n) {
	mt19937 rng(23423);
	vector<bool> ret(n);
	for (int i = 0; i < n; ++i) ret[i] = rng() & 1;
	return ret;
}

const int DEG = 7;

vector<pair<int, int>> encode(int n, vector<bool> data) {
	// assert(n == 200 && data.size() == 2 * n);
	auto sample = get_sample(data.size());
	for (int i = 0; i < data.size(); ++i) data[i] = data[i] == sample[i];
	vector<pair<int, int>> tree;
	for (int i = 0; i < DEG; ++i) tree.emplace_back(i, DEG);
	tree.emplace_back(DEG, DEG + 1);
	int sz = DEG + 1;
	for (int i = 0; i + 1 < data.size(); i += 2) {
		if (data[i] && data[i + 1] && sz + 5 < n) {
			tree.emplace_back(sz, sz + 1);
			tree.emplace_back(sz, sz + 2);
			tree.emplace_back(sz, sz + 3);
			tree.emplace_back(sz, sz + 4);
			tree.emplace_back(sz, sz + 5);
			sz += 5;
		} else if (data[i] && !data[i + 1] && sz + 3 < n) {
			tree.emplace_back(sz, sz + 1);
			tree.emplace_back(sz + 1, sz + 2);
			tree.emplace_back(sz, sz + 3);
			sz += 3;
		} else if (!data[i] && data[i + 1] && sz + 3 < n) {
			tree.emplace_back(sz, sz + 1);
			tree.emplace_back(sz, sz + 2);
			tree.emplace_back(sz, sz + 3);
			sz += 3;
		} else if (!data[i] && !data[i + 1] && sz + 1 < n) {
			tree.emplace_back(sz, sz + 1);
			sz += 1;
		}
	}
	while (sz + 1 < n) {
		tree.emplace_back(sz, sz + 1);
		sz++;
	}
	return tree;
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
	for (int del = 0; del <= n; ++del) {
		vector<vector<int>> g(n + 1);
		for (auto [x, y] : tree) {
			if (del == x || del == y) {
				continue;
			}
			g[x].push_back(y);
			g[y].push_back(x);
		}
		vector<bool> used(n + 1);
		used[del] = true;
		int prv = -1;
		int st = 0;
		while (st <= n && g[st].size() != DEG + 1) ++st;
		if (st > n) continue;
		vector<bool> data;
		int ok = 0;
		while (ok == 0) {
			used[st] = true;
			if (prv != -1) g[st].erase(find(g[st].begin(), g[st].end(), prv));
			int nxt = -1;
			vector<int> leafes;
			if (g[st].empty()) {}
			else if (g[st].size() == DEG + 1) {
				sort(g[st].begin(), g[st].end(), [&](int u, int v) {return g[u].size() < g[v].size();});
				bool kk = true;
				for (int j = 0; j + 1 < g[st].size(); ++j) {
					kk &= g[g[st][j]].size() == 1;
				}
				if (kk) nxt = g[st].back();
				else ok = -1;
			} else if (g[st].size() == 1) {
				data.push_back(false);
				data.push_back(false);
				nxt = g[st][0];
			} else if (g[st].size() == 2) {
				int u = g[st][0], v = g[st][1];
				if (g[u].size() == 2 && g[g[u][0] ^ g[u][1] ^ st].size() == 1) swap(u, v);
				if (g[v].size() == 2 && g[g[v][1] ^ g[v][1] ^ st].size() == 1) {
					data.push_back(true);
					data.push_back(false);
					nxt = u;
				} else {
					ok = -1;
				}
			} else if (g[st].size() == 3) {
				sort(g[st].begin(), g[st].end(), [&](int u, int v) {return g[u].size() < g[v].size();});
				bool kk = true;
				for (int j = 0; j + 1 < g[st].size(); ++j) {
					kk &= g[g[st][j]].size() == 1;
				}
				if (kk) {
					data.push_back(false);
					data.push_back(true);
					nxt = g[st].back();
				} else {
					ok = -2;
				}
			} else if (g[st].size() == 5) {
				sort(g[st].begin(), g[st].end(), [&](int u, int v) {return g[u].size() < g[v].size();});
				bool kk = true;
				for (int j = 0; j + 1 < g[st].size(); ++j) {
					kk &= g[g[st][j]].size() == 1;
				}
				if (kk) {
					data.push_back(true);
					data.push_back(true);
					nxt = g[st].back();
				} else {
					ok = -3;
				}
			} else {
				ok = -4;
			}
			for (auto x : g[st]) used[x] = true;
			used[st] = true;
			prv = st;
			st = nxt;
			if (st == -1) break;
		}
		for (int i = 0; i <= n; ++i) if (!used[i]) ok = -4;
		if (ok == 0) {
			if (data.size() > 2 * n) data.resize(2 * n);
			while (data.size() < 2 * n) data.push_back(false);
			auto sample = get_sample(2 * n);
			vector<bool> ret(2 * n);
			for (int i = 0; i < n; ++i) {
				if (!data[i]) ret[i] = !sample[i];
				else ret[i] = sample[i];
			}
			return ret;
		}
	}
	return vector(n, false);
	// assert(false);
}