#include<bits/stdc++.h>
using namespace std;

using ll = long long;

vector<int> A;

struct segtree {
	int n;
	vector<pair<int, int>> tr;
	vector<int> mod;

	pair<int, int> merge(pair<int, int> a, pair<int, int> b){
		if (a.first == b.first) return {a.first, a.second + b.second};
		if (a.first < b.first) return a;
		return b;
	}

	void build(int node, int l, int r) {
		if (l == r) {
			tr[node] = {0, 1};
		} else {
			int m = (l + r) / 2;
			build(node << 1, l, m);
			build(node << 1 | 1, m + 1, r);
			tr[node] = merge(tr[node << 1], tr[node << 1 | 1]);
		}
	}

	segtree() = default;
	segtree(int _n) : n(_n), tr(4 * _n), mod(4 * _n) {
		build(1, 0, n - 1);
	}

	void apply(int node, int x) {
		tr[node].first += x;
		mod[node] += x;
	}
	void push(int node) {
		apply(node << 1, mod[node]);
		apply(node << 1 | 1, mod[node]);
		mod[node] = 0;
	}

	void upd(int ql, int qr, int k, int node, int l, int r) {
		if (r < ql || qr < l) return;
		if (ql <= l && r <= qr) {
			apply(node, k);
			return;
		}
		int m = (l + r) / 2;
		push(node);
		upd(ql, qr, k, node << 1, l, m);
		upd(ql, qr, k, node << 1 | 1, m + 1, r);
		tr[node] = merge(tr[node << 1], tr[node << 1 | 1]);
	}

	void upd(int ql, int qr, int k) {
		upd(ql, qr, k, 1, 0, n - 1);
	}
};

ll solve(vector<int> a) {
	int n = a.size();
	int mx = *max_element(a.begin(), a.end());
	vector<vector<int>> occ(mx + 1);
	vector<int> cnt(mx + 1);
	segtree tr(n);
	ll ret = 0;
	auto upd = [&](int x, int t) -> void {
		if (occ[x].empty()) return;
		int i = occ[x].back();
		int j = x <= occ[x].size() ? occ[x][occ[x].size() - x] : n;
		int k = x < occ[x].size() ? occ[x][occ[x].size() - x - 1] : n;
		tr.upd(i, j - 1, t);
		tr.upd(k, n - 1, t);
	};
	for (int i = n - 1; i >= 0; --i) {
		upd(a[i], -1);
		occ[a[i]].push_back(i);
		upd(a[i], 1);
		auto [mn, cnt] = tr.tr[1];
		if (mn == 0) {
			ret += cnt - i;
		}
	}
	cout << endl;
	return ret;
}

void init(int n, int q, vector<int> a) {
	A = a;
}

ll query(int l, int r) {
	return solve(vector(A.begin() + l, A.begin() + r + 1));
}

// int main(){
// 	std::ios_base::sync_with_stdio(false);
// 	std::cin.tie(nullptr); std::cout.tie(nullptr);
// 	int n, q; std::cin >> n >> q;
// 	std::vector<int> input(n);
// 	for(int i = 0; i < n; i ++){
// 		std::cin >> input[i];
// 	}
// 	init(n, q, input);
// 	for(int i = 0; i < q; i ++){
// 		int l, r;
// 		std::cin >> l >> r;
// 		std::cout << query(l, r) << std::endl;
// 	}
// 	std::cout << std::endl;
// }
