#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

using ll = long long;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
    vector<vector<int>> ok(n, vector<int>(m, 0));
    auto d_ok {[&](int i, int j) -> bool {
        if (blocked[i][j]) return false;
        if (i == n - 1) return true;
        if (blocked[i + 1][j]) return false;
        return ok[i + 1][j];
    }};
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            ok[i][j] = d_ok(i, j);
        }
        for (int j = 1; j < m; j++) {
            if (!blocked[i][j - 1] && !blocked[i][j]) {
                ok[i][j] |= ok[i][j - 1];
            }
        }
        for (int j = m - 1; j > 0; j--) {
            if (!blocked[i][j - 1] && !blocked[i][j]) {
                ok[i][j - 1] |= ok[i][j];
            }
        }
    }
    for (int i = 0; i < n; i++) {
        int left = 0, right = 0;
        for (int j = k - 1; j >= 0; j--) {
            if (blocked[i][j]) break;
            if (d_ok(i, j)) left++;
        }
        for (int j = k + 1; j < m; j++) {
            if (blocked[i][j]) break;
            if (d_ok(i, j)) right++;
        }
        int l1 = k, r1 = k;
        if (!left && !right) {
            goDeeper(k);
            continue;
        }
        bool ok = 0;
        while (left > right) {
            int cur = l1;
            while (cur >= 0 && !blocked[i][cur] && !d_ok(i, cur)) cur--;
            if (cur < 0 || blocked[i][cur]) {
                goDeeper(l1);
                k = l1;
                ok = 1;
                break;
            }
            bool res = investigate(cur);
            if (res) {
                l1 = cur;
            } else {
                if (l1 != k) {
                    ok = 1;
                    goDeeper(l1);
                    k = l1;
                    break;
                } else {
                    break;
                }
            }
        }
        if (ok) continue;
        while (true) {
            int cur = l1;
            while (cur < m && !blocked[i][cur] && !d_ok(i, cur)) cur++;
            if (cur == m || blocked[i][cur]) {
                goDeeper(r1);
                k = r1;
                ok = 1;
                break;
            }
            bool res = investigate(cur);
            if (res) {
                r1 = cur;
            } else {
                if (r1 != k) {
                    ok = 1;
                    goDeeper(r1);
                    k = r1;
                    break;
                } else {
                    break;
                }
            }
        }
        if (ok) continue;
        while (true) {
            int cur = l1;
            while (cur >= 0 && !blocked[i][cur] && !d_ok(i, cur)) cur--;
            if (cur < 0 || blocked[i][cur]) {
                goDeeper(l1);
                k = l1;
                ok = 1;
                break;
            }
            bool res = investigate(cur);
            if (res) {
                l1 = cur;
            } else {
                if (l1 != k) {
                    ok = 1;
                    k = l1;
                    goDeeper(l1);
                    break;
                } else {
                    break;
                }
            }
        }
        if (ok) continue;
        goDeeper(k);
    }
}
