#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

using ll = long long;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
    vector<vector<int>> ok(n, vector<int>(m, 0));
    auto d_ok {[&](int i, int j) -> bool {
        if (blocked[i][j]) return false;
        if (i == n - 1) return true;
        if (blocked[i + 1][j]) return false;
        return ok[i + 1][j];
    }};
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            ok[i][j] = d_ok(i, j);
        }
        for (int j = 1; j < m; j++) {
            if (!blocked[i][j - 1] && !blocked[i][j]) {
                ok[i][j] |= ok[i][j - 1];
            }
        }
        for (int j = m - 1; j > 0; j--) {
            if (!blocked[i][j - 1] && !blocked[i][j]) {
                ok[i][j - 1] |= ok[i][j];
            }
        }
    }
    for (int i = 0; i < n; i++) {
        int left = 0, right = 0;
        vector<int> pos;
        for (int j = k - 1; j >= 0; j--) {
            if (blocked[i][j]) break;
            if (d_ok(i, j)) {
                left++;
                pos.push_back(j);
            }
        }
        reverse(pos.begin(), pos.end());
        for (int j = k + 1; j < m; j++) {
            if (blocked[i][j]) break;
            if (d_ok(i, j)) {
                right++;
                pos.push_back(j);
            }
        }
        if (!left && !right) {
            goDeeper(k);
            continue;
        }
        int fr;
        if (left >= right) {
            fr = pos[left - 1];
        } else {
            fr = pos[left];
        }
        bool frr = investigate(fr);
        if ((frr && left >= right) || (!frr && left < right)) {
            int l1 = 0, r1 = left - 1;
            if (!d_ok(i, k)) {
                r1--;
            }
            while (l1 <= r1) {
                int m1 = (l1 + r1) / 2;
                bool res = investigate(pos[m1]);
                if (res) {
                    r1 = m1 - 1;
                } else {
                    l1 = m1 + 1;
                }
            }
            k = pos[l1];
            goDeeper(k);
        } else {
            int l1 = left, r1 = pos.size() - 1;
            if (!d_ok(i, k)) {
                l1++;
            }
            while (l1 <= r1) {
                int m1 = (l1 + r1) / 2;
                bool res = investigate(pos[m1]);
                if (res) {
                    l1 = m1 + 1;
                } else {
                    r1 = m1 - 1;
                }
            }
            k = pos[r1];
            goDeeper(k);
        }
    }
}
