#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

const int K = 15, N = 220, SEED = 1234, ANS = 200 - K - 9;
int rng[N];

void add_hash(vector<bool> &data) {
    int thsh = 0;
    for (int i = 0; i < data.size(); i++) {
        if (data[i]) {
            thsh += rng[i];
        }
    }
    thsh = (thsh & ((1 << K) - 1));
    for (int i = K - 1; i >= 0; i--) {
        data.push_back(thsh & (1 << i));
    }
}

vector<pair<int, int>> encode(int n, vector<bool> data) {
    mt19937 mt(SEED);
    for (int i = 0; i < N; i++) {
        rng[i] = mt();
    }
    data.resize(ANS);
    add_hash(data);
    int zcnt = 0;
    for (int i = 0; i < data.size(); i++) {
        if (!data[i]) {
            zcnt++;
        }
    }
    vector<pair<int, int>> edge;
    for (int i = 0; i < zcnt; i++) {
        edge.emplace_back(i, i + 1);
    }
    int fre = zcnt + 1, nwcnt = 0;
    for (int i = 0; i < data.size(); i++) {
        if (!data[i]) nwcnt++;
        else edge.emplace_back(nwcnt, fre++);
    }
    edge.emplace_back(0, fre++);
    edge.emplace_back(fre - 2, fre++);
    edge.emplace_back(fre - 2, fre++);
    edge.emplace_back(fre - 3, fre++);
    edge.emplace_back(fre - 4, fre++);
    edge.emplace_back(zcnt, fre++);
    edge.emplace_back(fre - 2, fre++);
    edge.emplace_back(fre - 2, fre++);
    return edge;
}

bool check(vector<bool> data) {
    int n = data.size() - K;
    int hsh = 0;
    for (int i = 0; i < K; i++) {
        hsh <<= 1;
        hsh += data[n + i];
    }
    int thsh = 0;
    for (int i = 0; i < n; i++) {
        if (data[i]) {
            thsh += rng[i];
        }
    }
    return (thsh & ((1 << K) - 1)) == hsh;
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
    mt19937 mt(SEED);
    for (int i = 0; i < N; i++) {
        rng[i] = mt();
    }
    vector<bool> data;
    vector<vector<int>> g(n + 1);
    for (int i = 0; i < n; i++) {
        g[tree[i].first].push_back(tree[i].second);
        g[tree[i].second].push_back(tree[i].first);
    }
    int be, en;
    {
        auto dfs {[&](auto dfs, int s, int p) -> pair<int, int> {
            pair<int, int> res = {0, s};
            for (int i : g[s]) {
                if (i != p) {
                    auto rres = dfs(dfs, i, s);
                    res = max(res, make_pair(rres.x + 1, rres.y));
                }
            }
            return res;
        }};
        auto [d1, ff] = dfs(dfs, 0, -1);
        auto [d2, ss] = dfs(dfs, ff, -1);
        ff = g[ff][0];
        ss = g[ss][0];
        if (g[ss].size() < 4 && g[ff].size() < 4) {
            int nss = -1, nff = -1;
            for (int i : g[ss]) {
                if (g[i].size() >= 4) {
                    nss = i;
                }
            }
            for (int i : g[ff]) {
                if (g[i].size() >= 4) {
                    nff = i;
                }
            }
            if (nss != -1) {
                be = nss;
                en = ff;
            } else {
                be = nff;
                en = ss;
            }
        } else {
            if (g[ss].size() >= 4) {
                be = ss;
                en = ff;
            } else {
                be = ff;
                en = ss;
            }
        }
    }
    vector<int> dbe(n + 1), den(n + 1);
    {
        auto dfs {[&](auto dfs, int s, int p) -> void {
            if (p == -1) dbe[s] = 0;
            else dbe[s] = dbe[p] + 1;
            for (int i : g[s]) {
                if (i != p) {
                    dfs(dfs, i, s);
                }
            }
        }};
        dfs(dfs, be, -1);
    }
    {
        auto dfs {[&](auto dfs, int s, int p) -> void {
            if (p == -1) den[s] = 0;
            else den[s] = den[p] + 1;
            for (int i : g[s]) {
                if (i != p) {
                    dfs(dfs, i, s);
                }
            }
        }};
        dfs(dfs, en, -1);
    }
    vector<int> hru(dbe[en] + 1);
    for (int i = 0; i <= n; i++) {
        if (dbe[i] + den[i] == dbe[en]) {
            hru[dbe[i]] = g[i].size();
        }
    }
    for (int i = 2; i <= dbe[en] - 2; i++) {
        for (int j = 2; j < hru[i]; j++) {
            data.push_back(1);
        }
        data.push_back(0);
    }
    data.pop_back();
    if (data.size() == ANS + K) {
        data.resize(ANS);
        return data;
    }
    for (int i = 0; i < data.size(); i++) {
        auto ndata = data;
        ndata.erase(ndata.begin() + i);
        if (check(ndata)) {
            ndata.resize(ANS);
            return ndata;
        }
    }
}