#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct DSU {
    vector<int> p;
    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }
    int get(int x) {
        if (x == -1) return x;
        return p[x] == x ? x : p[x] = get(p[x]);
    }
    void merge(int x, int y) {
        p[get(y)] = get(x);
    }
};

int ans;

struct mst {
    vector<vector<int>> st;
    size_t sz;
    mst() = default;
    mst(vector<vector<int>> a) {
        sz = 1;
        while (sz < a.size()) sz <<= 1;
        st.resize(2 * sz);
        for (int i = 0; i < a.size(); i++) {
            st[sz + i] = a[i];
            // sort(st[sz + i].begin(), st[sz + i].end());
        }
        for (int i = sz - 1; i > 0; i--) {
            st[i].resize(st[2 * i].size() + st[2 * i + 1].size());
            merge(st[2 * i].begin(), st[2 * i].end(), st[2 * i + 1].begin(), st[2 * i + 1].end(), st[i].begin());
        }
    }
    int get(int l, int r, int v) {
        l += sz; r += sz;
        int res = 0;
        while (l <= r) {
            if (l & 1) {
                res += upper_bound(st[l].begin(), st[l].end(), v) - st[l].begin();
                l++;
            }
            if (~r & 1) {
                res += upper_bound(st[r].begin(), st[r].end(), v) - st[r].begin();
                r--;
            }
            l >>= 1;
            r >>= 1;
        }
        return res;
    }
};

mst st;

void init(int n, int q, const std::vector<int>& a) {
    DSU dsu(n);
    vector<int> prev(n, -1), nxt(n, n), bnd(n, -1);
    {
        vector<int> tmp(n + 1, -1);
        for (int i = 0; i < n; i++) {
            prev[i] = tmp[a[i]];
            tmp[a[i]] = i;
        }
    }
    {
        vector<int> tmp(n + 1, n);
        for (int i = n - 1; i >= 0; i--) {
            nxt[i] = tmp[a[i]];
            tmp[a[i]] = i;
        }
    }
    {
        vector<int> tmp(n + 1, n);
        for (int i = n - 1; i >= 0; i--) {
            if (tmp[a[i]] == n) {
                tmp[a[i]] = i;
                for (int j = 0; j < a[i] - 1 && tmp[a[i]] != -1; j++) {
                    tmp[a[i]] = prev[tmp[a[i]]];
                }
            } else {
                if (tmp[a[i]] != -1) {
                    tmp[a[i]] = prev[tmp[a[i]]];
                }
            }
            bnd[i] = tmp[a[i]];
        }
    }
    auto pr {[&](int i) -> int {
        if (i == -1) return -1;
        return prev[i];
    }};
    auto nx {[&](int i) -> int {
        if (i == n) return n;
        return nxt[i];
    }};
    vector<vector<int>> pos(n);
    bool zm = false;
    for (int i = 0; i < n; i++) {
        int bound = -1;
        int cur = i;
        if (prev[i] > 0) {
            dsu.merge(prev[i] - 1, prev[i]);
        } else if (prev[i] == 0) {
            zm = true;
        }
        int b = bnd[i];
        bound = max(bound, pr(bnd[i]));
        while (b > bound) {
            cur = dsu.get(cur - 1);
            if (!cur && zm) cur--;
            if (cur < b) {
                pos[b].push_back(i);
            }
            if (cur < 0) break;
            b = min(b, bnd[cur]);
            bound = max(bound, pr(bnd[cur]));
        }
    }
    st = mst(pos);
}

long long query(int l, int r) {
    return st.get(l, r, r);
}
