#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

bool investigate(int y);

void goDeeper(int y);

void solve(int n, int m, int k, const vector<vector<bool>> &blocked) {
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(m, vector<int>(m+1, 0)));
    vector<vector<vector<pii>>> to(n + 1, vector<vector<pii>>(m, vector<pii>(m+1)));
    vector<vector<vector<int>>> opt(n + 1, vector<vector<int>>(m, vector<int>(m+1, 0)));
    vector<vector<int>> left(n + 1, vector<int>(m, 0)), right(n + 1, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (blocked[i][j]) {
                continue;
            }
            if (j > 0 && !blocked[i][j-1]) {
                left[i][j] = left[i][j-1];
            } else {
                left[i][j] = j;
            }
        }
        for (int j = m-1; j >= 0; --j) {
            if (blocked[i][j]) {
                continue;
            }
            if (j < m - 1 && !blocked[i][j+1]) {
                right[i][j] = right[i][j+1];
            } else {
                right[i][j] = j+1;
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (blocked[i][j]) {
                continue;
            }
            if (j == 0 || blocked[i][j-1]) {
                for (int x = j; x < right[i][j]; ++x) {
                    to[i][x][x + 1] = mp(x, x + 1);
                    opt[i][x][x + 1] = x + 1;
                    if (i < n - 1 && blocked[i + 1][x]) {
                        dp[i][x][x + 1] = -1e9;
                    } else {
                        dp[i][x][x + 1] = dp[i + 1][left[i + 1][x]][right[i + 1][x]];
                    }
                }
                for (int l = right[i][j] - 1; l >= j; --l) {
                    for (int r = l + 2; r <= right[i][j]; ++r) {
                        opt[i][l][r] = opt[i][l][r-1];
                        if (dp[i][l][l + 1] < 0) {
                            to[i][l][r] = to[i][l + 1][r];
                            continue;
                        }
                        if (dp[i][r-1][r] < 0) {
                            to[i][l][r] = to[i][l][r - 1];
                            continue;
                        }
                        to[i][l][r] = mp(l, r);
                        while (opt[i][l][r] < r - 1) {
                            if (max(dp[i][l][opt[i][l][r]], dp[i][opt[i][l][r]][r]) >= max(dp[i][l][opt[i][l][r]+1], dp[i][opt[i][l][r]+1][r])) {
                                ++opt[i][l][r];
                            }
                        }
                        dp[i][l][r] = max(dp[i][l][opt[i][l][r]], dp[i][opt[i][l][r]][r]) + 1;
                    }
                }
            }
        }
    }
    int now = k;
    for (int i = 0; i < n; ++i) {
        int l = left[i][now];
        int r = right[i][now];
        while (r - l > 1) {
            if (to[i][l][r].f != l || to[i][l][r].s != r) {
                pii p = to[i][l][r];
                l = p.f;
                r = p.s;
                continue;
            }
            int mid = opt[i][l][r];
            if (mid <= now) {
                if (investigate(mid - 1)) {
                    r = mid;
                } else {
                    l = mid;
                }
            } else {
                if (investigate(mid)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
        }
        now = l;
        goDeeper(l);
    }
}

#ifdef LOCAL

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
//    freopen("in.txt", "r", stdin);
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}

#endif