#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
mt19937 rnd(12);
#endif
const int MAX_N = 200, M = 130;

vector<bool> change(vector<bool> data) {
    mt19937 rng(11);
    for (int i = 0; i < MAX_N * 2; ++i) {
        data[i] = (data[i] ^ (rng()&1));
    }
    return data;
}

vector<pair<int, int>> encode(int n, vector<bool> data) {
    data = change(data);
    vector<pair<int, int>> edges;
    vector<int> a(M);
    for (int i = 0; i < M; ++i) {
        edges.pb(mp(i, i + 1));
    }
    int ind = 0;
    int v = M + 1;
    for (int i = 1; i < M; ++i) {
        if ((i&(i-1)) == 0) {
            continue;
        }
        if (data[ind++]) {
            a[i] = 1;
            edges.pb(mp(v++, i));
        }
    }
    int l = 0;
    for (int i = 1; i < M; ++i) {
        if (i == (1<<l)) {
            int x = 0;
            for (int j = 0; j < M; ++j) {
                if (j&(1<<l)) {
                    x ^= a[j];
                }
            }
            if (x) {
                a[i] = 1;
                edges.pb(mp(v++, i));
            }
            ++l;
        }
    }
//    printv(a);
    edges.pb(mp(M, v++));
    edges.pb(mp(M, v++));
    while (v < n) {
        edges.pb(mp(v++, 0));
    }
    return edges;
}

vector<bool> decode(int n, vector<pii> edges) {
    vector<int> w;
    vector<vector<int>> graph(n + 1);
    for (auto &e : edges) {
        graph[e.f].pb(e.s);
        graph[e.s].pb(e.f);
    }
    int root1 = -1, root2 = -1;
    vector<int> dvis(n+1);
    for (int i = 0; i <= n; ++i) {
        dvis[i] = 2;
        for (auto &u : graph[i]) {
            if (graph[u].size() > 1) {
                --dvis[i];
            }
        }
    }
    for (int i = 0; i <= n; ++i) {
        int v = 0;
        int two = 0;
        for (auto &u : graph[i]) {
            if (dvis[u] > 0 && graph[u].size() <= 2) {
                ++v;
            }
        }
        v += two;
        if (v >= 2 && graph[i].size() <= v + 1) {
            if (v >= 4) {
                assert(root1 == -1);
                root1 = i;
            } else {
                assert(root2 == -1);
                root2 = i;
            }
        }
    }
    vector<int> way;
    auto dfs = [&](int v, int prev, auto &&self) -> bool {
        way.pb(v);
        if (v == root2) {
            return true;
        }
        for (auto &u : graph[v]) {
            if (prev != u) {
                if (self(u, v, self)) {
                    return true;
                }
            }
        }
        way.pop_back();
        return false;
    };
    dfs(root1, -1, dfs);
    vector<int> a = {0};
    for (int i = 1; i < way.size() - 1; ++i) {
        a.pb((graph[way[i]].size() - 2)&1);
    }
    int ind = 0;
    int LOG_N = 0;
    while ((1<<LOG_N) < a.size()) {
        ++LOG_N;
    }
    for (int l = 0; l < LOG_N; ++l) {
        int x = 0;
        for (int i = 1; i < a.size(); ++i) {
            if (i&(1<<l)) {
                x ^= (a[i]&1);
            }
        }
        if (x) {
            ind ^= (1<<l);
        }
    }
    a[ind] ^= 1;
    vector<bool> ans;
    for (int i = 0; i < a.size(); ++i) {
        if ((i&(i-1)) != 0) {
            ans.pb(a[i]&1);
        }
    }
//    for (int i = 0; i < ans.size(); ++i) {
//        cerr << ans[i] << ' ';
//    }
//    cerr << endl;
    while (ans.size() < MAX_N * 2) {
        ans.pb(false);
    }
    return change(ans);
}

#ifdef LOCAL
static void dfs(int u, vector<bool> &vis, const vector<vector<int>> &adj) {
    vis[u] = true;

    for (int to: adj[u]) {
        if (vis[to]) {
            continue;
        }

        dfs(to, vis, adj);
    }
}

static bool forms_tree(vector<pair<int, int>> edges, int n) {
    vector<vector<int>> adj(n);
    for (auto [u, v]: edges) {

        if (u < 0 || v < 0 || u >= n || v >= n) {
            return false;
        }
        if (u == v) {
            return false;
        }

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    vector<bool> vis(n, false);

    dfs(0, vis, adj);

    for (int i = 0; i < n; ++i) {
        if (!vis[i]) {
            return false;
        }
    }

    return true;
}

const int RANDOM_SEED = 0;
mt19937 random_generator(RANDOM_SEED);

static vector<pair<int, int>> corrupt(vector<pair<int, int>> edges, int n, int node_to_attach_to) {
    edges.push_back({node_to_attach_to, n});

    vector<int> permutation(n + 1);
    for (int i = 0; i <= n; ++i){
        permutation[i] = i;
    }

    shuffle(permutation.begin(), permutation.end(), random_generator);
    shuffle(edges.begin(), edges.end(), random_generator);

    for (auto &[u, v]: edges) {
        u = permutation[u];
        v = permutation[v];

        if (random_generator() % 2) {
            swap(u, v);
        }
    }

    return edges;
}

static int runTest() {
    int n = MAX_N;
    cout << "n: ";
//    cin >> n;

    int data_length = n * 2;
    cout << "data_length: ";
//    cin >> data_length;

    vector<bool> data(data_length);
    cout << "data: ";
    for (int i = 0; i < data_length; ++i) {
        char bit;
//        cin >> bit;
        bit = ('0' + (rnd()&1));
        data[i] = bit == '1';
    }

    vector<pair<int, int>> tree_edges = encode(n, data);

    assert(forms_tree(tree_edges, n));

    int min_prefix = 1e9;

    for (int node_to_attach_to = 0; node_to_attach_to < n; ++node_to_attach_to) {
        vector<pair<int, int>> corrupted_edges = corrupt(tree_edges, n, node_to_attach_to);

        vector<bool> decoded_data = decode(n, corrupted_edges);

        int correct_prefix = 0;
        while (correct_prefix < (int) std::min(decoded_data.size(), data.size())
               && decoded_data[correct_prefix] == data[correct_prefix]) {
            ++correct_prefix;
        }
        min_prefix = min(min_prefix, correct_prefix);
    }

    return min_prefix;
}

signed main() {
    freopen("in.txt", "r", stdin);
    cout << "t: ";
    int t;
    cin >> t;

    int min_bits_guessed = 1e9;
    for (int i = 0; i < t; i++) {
        int bits = runTest();
        cerr << "Guessed " << bits << " bits correctly in test #" << i << endl;

        min_bits_guessed = min(min_bits_guessed, bits);
    }
    cerr << endl;
    cerr << "Guessed a minimum of " << min_bits_guessed << " correctly" << endl;

    return 0;
}
#endif