#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int MAX_N = 3e5 + 11, NODESCNT = 2e7;


int n;
int num[MAX_N], NodesH = 0;
int ans = 0;

vector<pii> pts;

void init(int n_, int q, const vector<int> &a) {
    pts.reserve(1000000);
    ans = 0;
    n = n_;
    vector<vector<int>> rights(n);
    for (int i = 0; i < n; ++i) {
        rights[i].reserve(300);
    }
    memset(num, 0, sizeof(num));
    for (int c = 1; c <= 774; ++c) {
        int r = 0;
        int less = 0, bigger = 0, cnt = 0;
        auto add = [&](int x) {
            ++num[x];
            if (num[x] == 1) {
                ++cnt;
                less += x - 1;
            } else {
                less -= (num[x] <= x);
                bigger += (num[x] > x);
            }
        };
        auto rem = [&](int x) {
            --num[x];
            if (num[x] == 0) {
                --cnt;
                less -= x - 1;
            } else {
                less += (num[x] < x);
                bigger -= (num[x] >= x);
            }
        };
        for (int l = 0; l < n; ++l) {
            while (r < n && cnt <= c && (cnt < c || (bigger == 0 && less > 0))) {
                add(a[r++]);
            }
            if (bigger > 0 || cnt > c) {
                rem(a[--r]);
            }
            if (less == 0 && bigger == 0 && cnt == c) {
                pts.pb(mp(l, r));
                ++ans;
            }
            rem(a[l]);
        }
    }
//    Node *root = build(0, n);
//    for (int i = n - 1; i >= 0; --i) {
//        for (auto &r : rights[i]) {
//            root = update(root, 0, n, r-1, 1);
//        }
//        T[i] = root;
//    }
}

int query(int l, int r) {
    ++r;
    int ans = 0;
    for (auto &p : pts) {
        if (p.f >= l && p.s <= r) {
            ++ans;
        }
    }
    return ans;
}

#ifdef LOCAL
signed main(){
    freopen("in.txt", "r", stdin);
    int n, q; std::cin >> n >> q;
    std::vector<int> input(n);
    for(int i = 0; i < n; i ++){
//        std::cin >> input[i];
        input[i] = rnd() % n; ++input[i];
    }
    init(n, q, input);
    for(int i = 0; i < q; i ++){
        int l, r;
        std::cin >> l >> r;
        std::cout << query(l, r) << " ";
    }
    std::cout << std::endl;
}
#endif