#include"tunnels.h"
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll calc(ll i, ll l, ll r, ll we, ll mid, vector<vector<vector<vector<short>>>>& dp) {
	if (mid == we) {
		mid++;
	}
	if (mid > r) {
		return 1e7;
	}
	if (mid < we) {
		return max(dp[i][l][mid][mid], dp[i][mid + 1][r][we]);
	} else {
		return max(dp[i][l][mid - 1][we], dp[i][mid][r][mid]);
	}
}

void solve(ll n, ll m, ll k, const vector<vector<bool>>& blocked) {
	vector<vector<bool>> b = blocked;
	b.emplace_back(m, false);
	vector<vector<vector<vector<short>>>> dp(n + 1, vector(m + 1, vector(m + 1, vector(m + 1, (short)0))));
	vector<vector<vector<vector<short>>>> mid(n + 1, vector(m + 1, vector(m + 1, vector(m + 1, (short)0))));
	for (ll i = 0; i < m; i++) {
		dp[n][0][m - 1][i] = 1;
	}
	vector<vector<ll>> nopt(m, vector<ll>(m, 0));
	for (ll i = n - 1; i >= 0; i--) {
		vector<ll> pt(m, -1);
		vector<ll> nt(m, m);
		for (ll j = 0; j < m; j++) {
			if (j > 0) {
				pt[j] = pt[j - 1];
			}
			if (b[i + 1][j]) {
				pt[j] = j;
			}
		}
		for (ll j = m - 1; j >= 0; j--) {
			if (j < m - 1) {
				nt[j] = nt[j + 1];
			}
			if (b[i + 1][j]) {
				nt[j] = j;
			}
		}
		for (ll j = 0; j < m; j++) {
			if (pt[j] == j) {
				dp[i][j][j][j] = 0;
			} else {
				dp[i][j][j][j] = dp[i + 1][pt[j] + 1][nt[j] - 1][j];
			}
		}
		for (ll l = 0; l < m; l++) {
			for (ll we = 0; we < m; we++) {
				nopt[l][we] = l;
			}
		}
		for (ll len = 2; len <= m; len++) {
			for (ll l = 0; (l + len) - 1 < m; l++) {
				ll r = (l + len) - 1;
				ll nz = -1;
				bool bo = false;
				for (ll ni = l; ni <= r; ni++) {
					if (dp[i][ni][ni][ni] != 0) {
						if (nz != -1) {
							bo = true;
						}
						nz = ni;
					}
				}
				if (!bo) {
					if (nz == -1) {
						continue;
					}
					for (ll we = l; we <= r; we++) {
						dp[i][l][r][we] = dp[i][nz][nz][nz];
					}
					continue;
				}
				for (ll we = l; we <= r; we++) {
					while (calc(i, l, r, we, nopt[l][we], dp) >= calc(i, l, r, we, nopt[l][we] + 1, dp)) {
						nopt[l][we]++;
					}
					dp[i][l][r][we] = calc(i, l, r, we, nopt[l][we], dp) + 1;
					mid[i][l][r][we] = nopt[l][we];
				}
			}
		}
	}
	vector<ll> pt(m, -1);
	vector<ll> nt(m, m);
	for (ll j = 0; j < m; j++) {
		if (j > 0) {
			pt[j] = pt[j - 1];
		}
		if (b[0][j]) {
			pt[j] = j;
		}
	}
	for (ll j = m - 1; j >= 0; j--) {
		if (j < m - 1) {
			nt[j] = nt[j + 1];		
		}
		if (b[0][j]) { 
			nt[j] = j;
		}
	}
	ll ni = 0, nl = pt[k] + 1, nr = nt[k] - 1, nw = k;
	while (ni < n) {
		ll nz = -1;
		bool bo = false;
		for (ll i = nl; i <= nr; i++) {
			if (dp[ni][i][i][i] != 0) {
				if (nz != -1) {
					bo = true;
				}
				nz = i;
			}
		}
		if (!bo) {
			nl = nz;
			nr = nz;
		}
		if (nl == nr) {
			goDeeper(nl);
			ni++;
			nw = nl;
			vector<ll> pt(m, -1);
			vector<ll> nt(m, m);
			for (ll j = 0; j < m; j++) {
				if (j > 0) {
					pt[j] = pt[j - 1];
				}
				if (b[ni][j]) {
					pt[j] = j;
				}
			}
			for (ll j = m - 1; j >= 0; j--) {
				if (j < m - 1) {
					nt[j] = nt[j + 1];		
				}
				if (b[ni][j]) { 
					nt[j] = j;
				}
			}
			nl = pt[nw] + 1;
			nr = nt[nw] - 1;
			continue;
		}
		ll p = mid[ni][nl][nr][nw];
		bool b = investigate(p);
		if (b) {
			if (p < nw) {
				nr = p;
			} else {
				nl = p;
			}
			nw = p;
		} else {
			if (p < nw) {
				nl = p + 1;
			} else {
				nr = p - 1;
			}
		}
	}
}

#ifdef LOCAL

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
#endif
