#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll MB = 130, LOG = 9;

vector<pair<ll, ll>> encode(ll n, vector<bool> data) {
	mt19937 rnd(52);
	vector<pair<ll, ll>> ans;
	for (ll i = 0; i < 5; i++) {
		ans.emplace_back(0, i + 1);
	}
	ll nv = 1;
	ll nfn = 6;
	ll nu = 0;
	data.resize(MB);
	for (ll i = 0; i < LOG; i++) {
		bool now = false;
		for (ll j = 0; j < MB; j++) {
			if (!((i >> j) & 1)) {
				now = now != data[j];
			}
		}
		data.push_back(now);
	}
	while (nu < data.size() && nfn + 2 < n) {
		if (data[nu] != (rnd() % 2)) {
			ans.emplace_back(nv, nfn);
			nv = nfn;
			nfn++;
		} else {
			ans.emplace_back(nv, nfn);
			ans.emplace_back(nv, nfn + 1);
			nv = nfn;
			nfn += 2;
		}
		nu++;
	}
	while (nfn < n) {
		ans.emplace_back(0, nfn);
		nfn++;
	}
	return ans;
}

void dfs(ll v, ll p, vector<vector<ll>>& to, vector<ll>& sz) {
	for (auto i : to[v]) {
		if (i != p) {
			dfs(i, v, to, sz);
			sz[v] += sz[i];
		}
	}
}

vector<bool> decode(ll n, vector<pair<ll, ll>> tree) {
	mt19937 rnd(52);
	ll root = 0;
	ll ms = 0;
	vector<vector<ll>> to(n + 1);
	for (ll i = 0; i < n; i++) {
		to[tree[i].first].push_back(tree[i].second);
		to[tree[i].second].push_back(tree[i].first);
	}
	for (ll i = 0; i <= n; i++) {
		if (assign_max(ms, (ll)to[i].size())) {
			root = i;
		}
	}
	vector<ll> sz(n + 1, 1);
	dfs(root, root, to, sz);
	vector<bool> ans;
	ll nv = root;
	ll np = root;
	while (sz[nv] != 1) {
		if (nv != root) {
			if (to[nv].size() == 2) {
				ans.push_back(true != (rnd() % 2));
			} else {
				ans.push_back(false != (rnd() % 2));
			}
		}
		ll bs = 0, vbs = 0;
		for (auto i : to[nv]) {
			if (i != np) {
				if (assign_max(vbs, sz[i])) {
					bs = i;
				}
			}
		}
		np = nv;
		nv = bs;
	}
	if (ans.size() > MB + LOG) {
		ans.resize(MB + LOG);
	}
	vector<bool> fb, sb;
	for (ll i = 0; i < ans.size(); i++) {
		if (i < MB) {
			fb.push_back(ans[i]);
		} else {
			sb.push_back(ans[i]);
		}
	}
	ll ib = (1 << LOG) - 1;
	for (ll i = 0; i < LOG; i++) {
		bool now = false;
		for (ll j = 0; j < MB; j++) {
			if (!((j >> i) & 1)) {
				now = now != fb[j];
			}
		}
		if (now != sb[i]) {
			ib -= (1 << i);
		}
	}
	if (ib < MB) {
		fb[ib] = !fb[ib];
	}
	return fb;
}
