#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll MB = 116, LOG = 8;

vector<pair<ll, ll>> encode(ll n, vector<bool> data) {
	mt19937 rnd(69);
	vector<pair<ll, ll>> ans;
	for (ll i = 0; i < 5; i++) {
		ans.emplace_back(0, i + 1);
	}
	ll nv = 1;
	ll nfn = 6;
	ll nu = 0;
	data.resize(MB);
	for (ll i = 0; i < LOG; i++) {
		bool now = false;
		for (ll j = 0; j < MB; j++) {
			if (!((j >> i) & 1)) {
				now = now != data[j];
			}
		}
		data.push_back(now);
	}
	for (ll j = 0; j < data.size(); j++) {
		data[j] = data[j] != (rnd() % 2);
	}
	while (nu < data.size() && nfn + 1 < n) {
		if (data[nu]) {
			ans.emplace_back(nv, nfn);
			nv = nfn;
			nfn++;
		} else {
			ans.emplace_back(nv, nfn);
			ans.emplace_back(nv, nfn + 1);
			nv = nfn;
			nfn += 2;
		}
		nu++;
	}
	while (nfn < n) {
		ans.emplace_back(0, nfn);
		nfn++;
	}
	return ans;
}

void dfs(ll v, ll p, vector<vector<ll>>& to, vector<ll>& sz) {
	for (auto i : to[v]) {
		if (i != p) {
			dfs(i, v, to, sz);
			sz[v] += sz[i];
		}
	}
}

vector<bool> decode(ll n, vector<pair<ll, ll>> tree) {
	mt19937 rnd(69);
	ll root = 0;
	ll ms = 0;
	vector<vector<ll>> to(n + 1);
	for (ll i = 0; i < n; i++) {
		to[tree[i].first].push_back(tree[i].second);
		to[tree[i].second].push_back(tree[i].first);
	}
	for (ll i = 0; i <= n; i++) {
		if (assign_max(ms, (ll)to[i].size())) {
			root = i;
		}
	}
	vector<ll> sz(n + 1, 1);
	dfs(root, root, to, sz);
	vector<bool> ans;
	ll nv = root;
	ll np = root;
	while (sz[nv] != 1) {
		if (nv != root) {
			if (to[nv].size() == 2) {
				ans.push_back(true);
			} else {
				ans.push_back(false);
			}
		}
		ll bs = 0, vbs = 0;
		for (auto i : to[nv]) {
			if (i != np) {
				if (assign_max(vbs, sz[i])) {
					bs = i;
				}
			}
		}
		np = nv;
		nv = bs;
	}
	if (ans.size() > MB + LOG) {
		ans.resize(MB + LOG);
	}
	for (ll i = 0; i < ans.size(); i++) {
		ans[i] = ans[i] != (rnd() % 2);
	}
	vector<bool> fb, sb;
	for (ll i = 0; i < ans.size(); i++) {
		if (i < MB) {
			fb.push_back(ans[i]);
		} else {
			sb.push_back(ans[i]);
		}
	}
	ll ib = (1 << LOG) - 1;
	for (ll i = 0; i < LOG; i++) {
		bool now = false;
		for (ll j = 0; j < MB; j++) {
			if (!((j >> i) & 1)) {
				now = now != fb[j];
			}
		}
		if (now != sb[i]) {
			ib -= (1 << i);
		}
	}
	if (ib < MB) {
		fb[ib] = !fb[ib];
	}
	return fb;
}

#ifdef LOCAL
static void dfs(int u, vector<bool> &vis, const vector<vector<int>> &adj) {
    vis[u] = true;

    for (int to: adj[u]) {
        if (vis[to]) {
            continue;
        }

        dfs(to, vis, adj);
    }
}

static bool forms_tree(vector<pair<int, int>> edges, int n) {
    vector<vector<int>> adj(n);
    for (auto [u, v]: edges) {

        if (u < 0 || v < 0 || u >= n || v >= n) {
            return false;
        }
        if (u == v) {
            return false;
        }

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    vector<bool> vis(n, false);

    dfs(0, vis, adj);

    for (int i = 0; i < n; ++i) {
        if (!vis[i]) {
            return false;
        }
    }

    return true;
}

const int RANDOM_SEED = 0;
mt19937 random_generator(RANDOM_SEED);

static vector<pair<int, int>> corrupt(vector<pair<int, int>> edges, int n, int node_to_attach_to) {
    edges.push_back({node_to_attach_to, n});

    vector<int> permutation(n + 1);
    for (int i = 0; i <= n; ++i){
        permutation[i] = i;
    }

    shuffle(permutation.begin(), permutation.end(), random_generator);
    shuffle(edges.begin(), edges.end(), random_generator);

    for (auto &[u, v]: edges) {
        u = permutation[u];
        v = permutation[v];

        if (random_generator() % 2) {
            swap(u, v);
        }
    }

    return edges;
}

static int runTest() {
    int n;
    cout << "n: ";
    cin >> n;

    int data_length;
    cout << "data_length: ";
    cin >> data_length;

    vector<bool> data(data_length);
    cout << "data: ";
    for (int i = 0; i < data_length; ++i) {
        char bit;
        cin >> bit;

        data[i] = bit == '1';
    }

    vector<pair<int, int>> tree_edges = encode(n, data);

    assert(forms_tree(tree_edges, n));

    int min_prefix = 1e9;

    for (int node_to_attach_to = 0; node_to_attach_to < n; ++node_to_attach_to) {
        vector<pair<int, int>> corrupted_edges = corrupt(tree_edges, n, node_to_attach_to);

        vector<bool> decoded_data = decode(n, corrupted_edges);

        int correct_prefix = 0;
        while (correct_prefix < (int) std::min(decoded_data.size(), data.size())
            && decoded_data[correct_prefix] == data[correct_prefix]) {
            ++correct_prefix;
        }
        min_prefix = min(min_prefix, correct_prefix);
    }

    return min_prefix;
}

int main() {
    cout << "t: ";
    int t;
    cin >> t;

    int min_bits_guessed = 1e9;
    for (int i = 0; i < t; i++) {
        int bits = runTest();
        cerr << "Guessed " << bits << " bits correctly in test #" << i << endl;

        min_bits_guessed = min(min_bits_guessed, bits);
    }
    cerr << endl;
    cerr << "Guessed a minimum of " << min_bits_guessed << " correctly" << endl;

    return 0;
}
#endif
