#include "tunnels.h"
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<int>> dp(m + 1, vector<int>(m + 1, (int)1e9));
    vector<vector<int>> to(m + 1, vector<int>(m + 1));
    dp[0][0] = 0;
    for (int l = 1; l <= m; ++l) {
        dp[l][0] = ceil(log2(l));
        dp[0][l] = ceil(log2(l));
    }
    for (int l = 1; l <= m; ++l) {
        for (int r = 1; r <= m; ++r) {
            // cout << l << ' ' << r << endl;
            for (int i = 1; i <= l; i *= 2) {
                if (dp[l][r] > 1 + max((int)log2(i), dp[l - i][r])) {
                    dp[l][r] = 1 + max((int)log2(i), dp[l - i][r]);
                    to[l][r] = -(l - i + 1);
                }
            }
            for (int i = 1; i <= r; i *= 2) {
                if (dp[l][r] > 1 + max((int)log2(i), dp[l][r - i])) {
                    dp[l][r] = 1 + max((int)log2(i), dp[l][r - i]);
                    to[l][r] = r - i + 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) goDeeper(0);
    return;
    for (int i = 0; i < n; ++i) {
        bool in_left = 0;
        int L = k, R = m - k - 1;
        while (L > 0 && R > 0) {
            int t = to[L][R];
            bool tt = investigate(k + t);
            if (tt) {
                if (t < 0) {
                    in_left = 1;
                    R = L + 1;
                    L = abs(t);
                }
                else {
                    L = abs(t);
                    ++R;
                }
                break;
            }
            if (t < 0) {
                L = abs(t) - 1;
            }
            else {
                R = abs(t) - 1;
            }
        }
        if (L == 0) {
            R++;
        }
        else if (R == 0) {
            in_left = 1;
            R = L + 1;
        }
        while (R - L > 1) {
            int M = (L + R) / 2;
            int x = k + M;
            if (in_left) x = k - M;
            if (investigate(x)) L = M;
            else R = M;
        }
        int x = k + L;
        if (in_left) x = k - L;
        goDeeper(x);
        k = x;
    }
}


#ifdef LOCAL
static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
#endif