#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<bitset>
#include<stack>
#include<algorithm>
#include<ctime>
#include<random>
#include<unordered_map>
#include<unordered_set>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int N = 3e5 + 2;
const ll llinf = 1e18 + 1000;
struct segtree {
    struct node {
        int mx, cnt, add;
        ll ans, p;
        int l, r;
        node(int len) {
            mx = 0, cnt = len, add = 0, ans = 0, p = 0, l = -1, r = -1;
        }
    };
    vector<node> t;
    vector<int> ver;
    int n;
    segtree() {}
    segtree(int sz) {
        n = sz;
        t.push_back(node(n));
        ver.push_back(0);
    }
    void upd_mx(int v, int x) {
        t[v].mx += x;
        t[v].add += x;
    }
    void upd_ans(int v, int x) {
        t[v].ans += 1ll * t[v].cnt * x;
        t[v].p += x;
    }
    void push(int v, int l, int r) {
        int m = (l + r) >> 1;
        if (t[v].l == -1) t.push_back(node(m - l));
        else
            t.push_back(t[t[v].l]);
        t[v].l = t.size() - 1;
        if (t[v].r == -1)  t.push_back(node(r - m));
        else
            t.push_back(t[t[v].r]);
        t[v].r = t.size() - 1;
        upd_mx(t[v].l, t[v].add);
        upd_mx(t[v].r, t[v].add);
        if(t[t[v].l].mx == t[v].mx) upd_ans(t[v].l, t[v].p);
        if(t[t[v].r].mx == t[v].mx) upd_ans(t[v].r, t[v].p);
        t[v].add = 0;
        t[v].p = 0;
    }
    void count(int v) {
        t[v].mx = max(t[t[v].l].mx, t[t[v].r].mx);
        t[v].cnt = t[t[v].l].cnt * (t[t[v].l].mx == t[v].mx) + t[t[v].r].cnt * (t[t[v].r].mx == t[v].mx);
        t[v].ans = t[t[v].l].ans + t[t[v].r].ans;
    }
    int update_mx(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql || qr <= l) return v;
        if (ql <= l && r <= qr) {
            upd_mx(v, val);
            return v;
        }
        int m = (l + r) >> 1;
        push(v, l, r);
        update_mx(t[v].l, l, m, ql, qr, val);
        update_mx(t[v].r, m, r, ql, qr, val);
        count(v);
        return v;
    }
    void update_mx(int l, int r, int val) {
        ver.back() = update_mx(ver.back(), 0, n, l, r, val);
    }
    int update_ans(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql || qr <= l) return v;
        if (ql <= l && r <= qr) {
            upd_ans(v, val);
            return v;
        }
        int m = (l + r) >> 1;
        push(v, l, r);
        if (t[t[v].l].mx == t[v].mx) update_ans(t[v].l, l, m, ql, qr, val);
        if (t[t[v].r].mx == t[v].mx) update_ans(t[v].r, m, r, ql, qr, val);
        count(v);
        return v;
    }
    void update_ans(int i) {
        t.push_back(t[ver.back()]);
        ver.push_back(update_ans(t.size() - 1, 0, n, i + 1, n, 1));
    }
    ll get(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return 0;
        if (ql <= l && r <= qr) return t[v].ans;
        int m = (l + r) >> 1;
        push(v, l, r);
        return get(t[v].l, l, m, ql, qr) + get(t[v].r, m, r, ql, qr);
    }
    ll get(int i, int l, int r) {
        return get(ver[i], 0, n, l, r);
    }
};
segtree t;
struct st {
    int x, ty, l, r, val;
};
bool cmp(st a, st b) {
    return a.x < b.x || (a.x == b.x && a.ty < b.ty);
}
void init(int n, int q, const vector<int>& a) {
    vector<vector<int>> pos(n + 1, {-1});
    for (int i = 0; i < n; ++i) pos[a[i]].push_back(i);
    for (auto& i : pos) i.push_back({ n });
    vector<st> b;
    for (int x = 1; x <= n; ++x) {
        for (int i = 1; i + 1 < pos[x].size(); ++i) {
            if (x > 1) {
                int lg1 = pos[x][i - 1] + 1;
                int rg1 = pos[x][i];
                int lg2 = pos[x][i] + 1;
                int rg2 = pos[x][min((int)pos[x].size() - 1, i + x - 1)];
                b.push_back({ lg1, 1, lg2, rg2 + 1, -1 });
                b.push_back({ rg1 + 1, 1, lg2, rg2 + 1, 1 });
            }
            if (i + x < pos[x].size()) {
                int lg1 = 0;
                int rg1 = pos[x][i];
                int lg2 = pos[x][i + x] + 1;
                int rg2 = n;
                b.push_back({ lg1, 1, lg2, rg2 + 1, -1 });
                b.push_back({ rg1 + 1, 1, lg2, rg2 + 1, 1 });
            }
        }
    }
    for (int i = 0; i <= n; ++i) b.push_back({ i, 2, -1, -1, -1 });
    t = segtree(n + 1);
    sort(all(b), cmp);
    for (auto i : b) {
        if (i.ty == 1) {
            t.update_mx(i.l, i.r, i.val);
        } else {
            t.update_ans(i.x);
        }
    }
}
ll query(int l, int r) {
    return t.get(r + 1, l + 1, r + 2) - t.get(l, l + 1, r + 2);
}

//void solve() {
//    init(7, 3, { 1, 2, 1, 2, 3, 3, 3 });
//    cout << query(0, 3) << '\n';
//    cout << query(2, 6) << '\n';
//    cout << query(0, 6) << '\n';
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}