#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<bitset>
#include<stack>
#include<algorithm>
#include<ctime>
#include<random>
#include<unordered_map>
#include<unordered_set>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int N = 3e2 + 2;
const ll llinf = 1e18 + 1000;
struct segtree {
    struct node {
        int mx, cnt, add;
        node() {}
        node(int len) {
            mx = 0, cnt = len, add = 0;
        }
    };
    node t[N * 4];
    vector<int> ver;
    int n;
    segtree() {}
    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = node(r - l);
            return;
        }
        int m = (l + r) >> 1;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
    }
    segtree(int sz) {
        n = sz;
        build(0, 0, n);
    }
    void upd_mx(int v, int x) {
        t[v].mx += x;
        t[v].add += x;
    }
    void push(int v) {
        upd_mx(v * 2 + 1, t[v].add);
        upd_mx(v * 2 + 2, t[v].add);
        t[v].add = 0;
    }
    void count(int v) {
        t[v].mx = max(t[v * 2 + 1].mx, t[v * 2 + 2].mx);
        t[v].cnt = t[v * 2 + 1].cnt * (t[v * 2 + 1].mx == t[v].mx) + t[v * 2 + 2].cnt * (t[v * 2 + 2].mx == t[v].mx);
    }
    void update_mx(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql || qr <= l) return;
        if (ql <= l && r <= qr) {
            upd_mx(v, val);
            return;
        }
        int m = (l + r) >> 1;
        push(v);
        update_mx(v * 2 + 1, l, m, ql, qr, val);
        update_mx(v * 2 + 2, m, r, ql, qr, val);
        count(v);
    }
    void update_mx(int l, int r, int val) {
        update_mx(0, 0, n, l, r, val);
    }
    void update_ans(int v, int l, int r, int ql, int qr, vector<int> &a) {
        if (r <= ql || qr <= l) return;
        if (r - l == 1) {
            a.push_back(l);
            return;
        }
        int m = (l + r) >> 1;
        push(v);
        if (t[v * 2 + 1].mx == t[v].mx) update_ans(v * 2 + 1, l, m, ql, qr, a);
        if (t[v * 2 + 2].mx == t[v].mx) update_ans(v * 2 + 2, m, r, ql, qr, a);
        count(v);
    }
    vector<int> update_ans(int i) {
        vector<int> a;
        update_ans(0, 0, n, i + 1, n, a);
        return a;
    }
};
struct perssegtree {
    struct node {
        int sum, l, r;
        node() : sum(0), l(-1), r(-1) {}
    };
    int n;
    vector<node> t;
    vector<int> ver;
    perssegtree() {}
    perssegtree(int sz) {
        n = sz;
        t.push_back(node());
        ver.push_back(0);
    }
    int upd(int v, int l, int r, int i) {
        int u = t.size();
        t.push_back(v == -1 ? node() : t[v]);
        t[u].sum++;
        if (r - l == 1) return u;
        int m = (l + r) >> 1;
        if (i < m) t[u].l = upd(t[u].l, l, m, i);
        else
            t[u].r = upd(t[u].r, m, r, i);
        return u;
    }
    void upd(int i) {
        ver.back() = upd(ver.back(), 0, n, i);
    }
    void newroot() {
        t.push_back(t[ver.back()]);
        ver.push_back(t.size() - 1);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (v == -1 || r <= ql || qr <= l) return 0;
        if (ql <= l && r <= qr) return t[v].sum;
        int m = (l + r) >> 1;
        return get(t[v].l, l, m, ql, qr) + get(t[v].r, m, r, ql, qr);
    }
    int get(int i, int l, int r) {
        return get(ver[i], 0, n, l, r);
    }
};
segtree t;
perssegtree t2;
struct st {
    int x, ty, l, r, val;
};
bool cmp(st a, st b) {
    return a.x < b.x || (a.x == b.x && a.ty < b.ty);
}
void init(int n, int q, const vector<int>& a) {
    vector<vector<int>> pos(n + 1, {-1});
    for (int i = 0; i < n; ++i) pos[a[i]].push_back(i);
    for (auto& i : pos) i.push_back({ n });
    vector<st> b;
    for (int x = 1; x <= n; ++x) {
        for (int i = 1; i + 1 < pos[x].size(); ++i) {
            if (x > 1) {
                int lg1 = pos[x][i - 1] + 1;
                int rg1 = pos[x][i];
                int lg2 = pos[x][i] + 1;
                int rg2 = pos[x][min((int)pos[x].size() - 1, i + x - 1)];
                b.push_back({ lg1, 1, lg2, rg2 + 1, -1 });
                b.push_back({ rg1 + 1, 1, lg2, rg2 + 1, 1 });
            }
            if (i + x < pos[x].size()) {
                int lg1 = 0;
                int rg1 = pos[x][i];
                int lg2 = pos[x][i + x] + 1;
                int rg2 = n;
                b.push_back({ lg1, 1, lg2, rg2 + 1, -1 });
                b.push_back({ rg1 + 1, 1, lg2, rg2 + 1, 1 });
            }
        }
    }
    for (int i = 0; i <= n; ++i) b.push_back({ i, 2, -1, -1, -1 });
    t = segtree(n + 1);
    sort(all(b), cmp);
    vector<vector<int>> c(n + 1);
    for (auto i : b) {
        if (i.ty == 1) {
            t.update_mx(i.l, i.r, i.val);
        } else {
            c[i.x] = t.update_ans(i.x);
        }
    }
    t2 = perssegtree(n + 1);
    for (int i = 0; i < n; ++i) {
        t2.newroot();
        for (auto j : c[i]) t2.upd(j);
    }
    t2.newroot();
}
ll query(int l, int r) {
    ++r;
    return t2.get(r + 1, l, r + 1) - t2.get(l, l, r + 1);
}

//void solve() {
//    init(7, 3, { 1, 2, 1, 2, 3, 3, 3 });
//    cout << query(0, 3) << '\n';
//    cout << query(2, 6) << '\n';
//    cout << query(0, 6) << '\n';
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}