#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "tunnels.h"

using namespace std;
using ll = long long;
using ld = long double;

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

const int MAXN = 5001;
int id[MAXN][MAXN], dp[MAXN][MAXN];

struct Solver
{
	int ql, qr, l, r, qt;
	vector <pair<int, int>> inside;
	map<pair<int, int>, int> storage;
	vector <tuple<int, int, int>> cur;
	int what_next(int sl, int sr)
	{
		//return (sl + sr) >> 1;
		if (!storage.count({ sl,sr }))
			exit(-1);
		return storage[{sl, sr}];
	}
	int best()
	{
		return get<2>(cur[0]);
	}
	int coord(int t)
	{
		return inside[t].first;
	}
	void init()
	{
		for (size_t i = ql; i <= qr; i++)
		{
			if (dp[qt + 1][i] == -1)
				continue;
			inside.emplace_back(i, dp[qt + 1][i]);
		}
		int k = inside.size();
		for (size_t i = 0; i < k; i++)
		{
			cur.emplace_back(i, i + 1, inside[i].second);
		}
		while (cur.size() > 1)
		{
			int f = -1, fs = 1e9;
			for (size_t i = 1; i < k; i++)
			{
				if (fs > max(get<2>(cur[i - 1]), get<2>(cur[i])))
				{
					fs = i - 1;
				}
			}
			storage[{get<0>(cur[fs]), get<1>(cur[fs + 1])}] = get<0>(cur[fs + 1]);
			get<1>(cur[fs]) = get<1>(cur[fs + 1]);
			get<2>(cur[fs]) = max(get<2>(cur[fs]), get<2>(cur[fs + 1])) + 1;
			cur.erase(cur.begin() + fs + 1);
			k--;
		}
		l = 0;
		r = inside.size();
	}
	int where_next(int sl)
	{
		return inside[sl].first;
	}
};
vector <Solver> sol[MAXN];

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
	//auto blocked = blOcked;
	//blocked.push_back(vector<bool>(m, 0));
	memset(dp, -1, sizeof(dp));
	memset(id, -1, sizeof(id));
	for (size_t i = 0; i < m; i++)
	{
		dp[n][i] = 0;
		id[n][i] = -1;
	}
	for (int i = n - 1; i >= 0; i--)
	{
		for (size_t j = 0; j < m; j++)
		{
			if (blocked[i][j])
			{
				continue;
			}
			int k = j;
			while (k < m && !blocked[i][k])
				id[i][k] = sol[i].size(), k++;
			k--;
			sol[i].emplace_back();
			sol[i].back().qt = i;
			sol[i].back().ql = j;
			sol[i].back().qr = k;
			sol[i].back().init();
			k = j;
			while (k < m && !blocked[i][k])
				dp[i][k] = sol[i].back().best(), k++;
			j = k;
		}
	}
	int c = 0;
	while (id[c][k] != -1)
	{
		Solver& q = sol[c][id[c][k]];
		int sl = q.l, sr = q.r;
		while (sr - sl > 1)
		{
			int sm = q.what_next(sl, sr);
			int st = q.coord(sm);
			// < st or >= st
			if (k < st)
				if (investigate(st))
					sl = sm;
				else
					sr = sm;
			else
				if (investigate(st - 1))
					sr = sm;
				else
					sl = sm;
		}
		goDeeper(q.where_next(sl));
		k = q.where_next(sl);
		c++;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
