﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <algorithm>
#include <numeric>
#include "bits_and_tree.h"

using namespace std;
using ll = long long;
using ld = long double;

vector<pair<int, int>> encode(int n, vector<bool> data) {
	int v = 0, u = n - 1;
	vector<pair<int, int>> res;
	for (int i = 0; i < 5; i++, u--) {
		res.push_back({v, u});
	}
	int pos = 0;
	while (v + 1 <= u) {
		res.push_back({v, v + 1});
		v++;
		if (data[pos] == 1) {
			if (v < u - 1) {
				res.push_back({v, u}); u--;
				res.push_back({v, u}); u--;
			}
		}
		pos++;
	}
	while (u > v) {
		res.push_back({1, u});
		u--;
	}
	return res;
}

void calch(int v, int p, vector<vector<int>>& g, vector<int>& h) {
	h[v] = 0;
	for (int u : g[v]) {
		if (u == p) continue;
		calch(u, v, g, h);
		h[v] = max(h[v], h[u] + 1);
	}
}

void getres(int v, int p, vector<vector<int>>& g, vector<int>& h, vector<bool>& res) {
	if (2 <= g[v].size() && g[v].size() <= 3) res.push_back(0);
	if (4 <= g[v].size() && g[v].size() <= 5) res.push_back(1);
	int mxhu = -1;
	for (int u : g[v]) {
		if (u != p) {
			if (mxhu == -1 || h[u] > h[mxhu]) {
				mxhu = u;
			}
		}
	}
	if (mxhu >= 0) {
		getres(mxhu, v, g, h, res);
	}
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
	vector<vector<int>> g(n + 1);
	for (int i = 0; i < tree.size(); i++) {
		g[tree[i].first].push_back(tree[i].second);
		g[tree[i].second].push_back(tree[i].first);
	}
	int v = 0;
	n++;
	for (int i = 0; i < n; i++) {
		if (g[i].size() >= 6) v = i;
	}
	vector<int> h(n + 1, 0);
	calch(v, -1, g, h);
	vector<bool> res;
	getres(v, -1, g, h, res);
	return res;
}

//int main()
//{
//    std::cout << "Hello World!\n";
//}