﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <algorithm>
#include <random>
#include <numeric>
#include "bits_and_tree.h"

using namespace std;
using ll = long long;
using ld = long double;
const int SEED = 1254;

vector<pair<int, int>> encode(int n, vector<bool> data) {
	mt19937 rng(SEED);
	for (int i = 0; i < data.size(); i++) {
		data[i] = ((int)data[i]) ^ (rng() % 2);
	}
	int v = 0;
	int u = 1;
	vector<pair<int, int>> res;
	for (int i = 0; i < 4; i++) {
		res.push_back({v, u});
		res.push_back({u, u + 1});
		u += 2;
	}
	res.push_back({v, u}); 
	v = u; u++;
	int pos = 0, m = n;
	while (u < m) {
		if (data[pos] == 0) {
			res.push_back({v, u}); u++;
			if (u < m) {
				res.push_back({v, u}); u++;
			}
		} else {
			res.push_back({v, u});
			v = u; u++;
		}
		pos++;
	}
	for (int u = m; u < n; u++) {
		res.push_back({v, u});
		v = u;
	}
	return res;
}

void calch(int v, int p, vector<vector<int>>& g, vector<int>& h) {
	h[v] = 0;
	for (int u : g[v]) {
		if (u == p) continue;
		calch(u, v, g, h);
		h[v] = max(h[v], h[u] + 1);
	}
}

void getres(int v, int p, vector<vector<int>>& g, vector<int>& h, vector<bool>& res) {
	if (p >= 0) {
		int cnt = ((int)g[v].size() - 2) / 2;
		for (int i = 0; i < cnt; i++) res.push_back(0);
		res.push_back(1);
	}
	int mxhu = -1;
	for (int u : g[v]) {
		if (u != p) {
			if (mxhu == -1 || h[u] > h[mxhu]) {
				mxhu = u;
			}
		}
	}
	if (mxhu >= 0) {
		getres(mxhu, v, g, h, res);
	}
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
	vector<vector<int>> g(n + 1);
	for (int i = 0; i < tree.size(); i++) {
		g[tree[i].first].push_back(tree[i].second);
		g[tree[i].second].push_back(tree[i].first);
	}
	int v = -1, cntv = 0;
	n++;
	for (int i = 0; i < n; i++) {
		int cnt = 0;
		for (int u : g[i]) {
			if (g[u].size() == 2) cnt++;
		}
		if (cnt > cntv) {
			v = i;
			cntv = cnt;
		}
	}
	vector<int> h(n + 1, 0);
	calch(v, -1, g, h);
	vector<bool> res;
	getres(v, -1, g, h, res);
	mt19937 rng(SEED);
	for (int i = 0; i < res.size(); i++) {
		res[i] = ((int)res[i]) ^ (rng() % 2);
	}
	return res;
}

//int main()
//{
//    std::cout << "Hello World!\n";
//}