﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <algorithm>
#include <random>
#include <numeric>
#include "bits_and_tree.h"

using namespace std;
using ll = long long;
using ld = long double;
const int SEED = 36234;
const int P = 170, C = 7;
vector<pair<int, int>> encode(int n, vector<bool> data) {
	mt19937 rng(SEED);
	for (int i = 0; i < data.size(); i++) {
		data[i] = ((int)data[i]) ^ (rng() % 2);
	}
	data.resize(P);
	int x = 0, cnt1 = 1;
	for (int i = 0; i < P; i++) {
		if (data[i] == 0) {
			x ^= cnt1;
		} else {
			cnt1++;
		}
	}
	vector<bool> pred;
	for (int i = 0; i < C; i++) {
		pred.push_back((x >> i) & 1);
	}
	int v = 0;
	int u = 1;
	vector<pair<int, int>> res;
	for (int i = 0; i < 4; i++) {
		res.push_back({v, u});
		res.push_back({u, u + 1});
		u += 2;
	}
	res.push_back({v, u});
	v = u; u++;
	for (bool x : pred) {
		if (x == 1) {
			res.push_back({v, u}); u++;
			res.push_back({v, u}); u++;
		}
		res.push_back({v, u}); v = u; u++;
	}
	for (int pos = 0; pos < data.size(); pos++) {
		if (data[pos] == 0) {
			res.push_back({v, u}); u++;
		} else {
			res.push_back({v, u});
			v = u; u++;
		}
	}
	for (; u < n; u++) {
		res.push_back({v, u});
		v = u;
	}
	return res;
}

void calch(int v, int p, vector<vector<int>>& g, vector<int>& h) {
	h[v] = 0;
	for (int u : g[v]) {
		if (u == p) continue;
		calch(u, v, g, h);
		h[v] = max(h[v], h[u] + 1);
	}
}

void getres(int v, int p, vector<vector<int>>& g, vector<int>& h, vector<int>& ff) {
	if (p >= 0) {
		int cnt = ((int)g[v].size() - 2);
		ff.push_back(cnt);
	}
	int mxhu = -1;
	for (int u : g[v]) {
		if (u != p) {
			if (mxhu == -1 || h[u] > h[mxhu]) {
				mxhu = u;
			}
		}
	}
	if (mxhu >= 0) {
		getres(mxhu, v, g, h, ff);
	}
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
	vector<vector<int>> g(n + 1);
	for (int i = 0; i < tree.size(); i++) {
		g[tree[i].first].push_back(tree[i].second);
		g[tree[i].second].push_back(tree[i].first);
	}
	int v = -1, cntv = 0;
	n++;
	for (int i = 0; i < n; i++) {
		int cnt = 0;
		for (int u : g[i]) {
			if (g[u].size() == 2) cnt++;
		}
		if (cnt > cntv) {
			v = i;
			cntv = cnt;
		}
	}
	vector<int> h(n + 1, 0);
	calch(v, -1, g, h);
	vector<int> ff;
	getres(v, -1, g, h, ff);
	int x = 0;
	for (int i = 0; i < C; i++) {
		if (ff[i] >= 2) {
			x |= (1 << i);
		}
	}
	vector<int> r;
	for (int i = C; i < ff.size(); i++) {
		r.push_back(ff[i]);
	}
	vector<bool> res;
	int ost = P, nx = 0;
	for (int i = 0; ost > 0 && i < r.size(); i++) {
		for (int x = 0; x < r[i] && ost > 0; x++) {
			ost--;
			nx ^= i + 1;
			res.push_back(0);
		}
		if (ost > 0) {
			ost--;
			res.push_back(1);
		}
	}
	if (x != nx) {
		int ost = P + 1, nx = 0;
		vector<int> mr;
		for (int i = 0; ost > 0 && i < r.size(); i++) {
			mr.push_back(0);
			for (int x = 0; x < r[i] && ost > 0; x++) {
				ost--;
				nx ^= i + 1;
				mr.back()++;
			}
			if (ost > 0) {
				ost--;
				res.push_back(1);
			}
		}
		int pos = x ^ nx;
		mr[pos - 1]--;
		res.clear();
		for (int i = 0; i < mr.size(); i++) {
			for (int x = 0; x < mr[i]; x++) res.push_back(0);
			res.push_back(1);
		}
	}
	mt19937 rng(SEED);
	for (int i = 0; i < res.size(); i++) {
		res[i] = ((int)res[i]) ^ (rng() % 2);
	}
	return res;
}

//int main()
//{
//    std::cout << "Hello World!\n";
//}