#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <algorithm>
#include <numeric>
using namespace std;
typedef long long ll;

struct Node {
	int mx, mod, cnt;
	Node() : mx(0), mod(0), cnt(0) {}
	Node(int mx, int cnt) : mx(mx), mod(0), cnt(cnt) {};
	Node operator+(const Node& other) const {
		if (mx + mod > other.mx + other.mod) return Node(mx + mod, cnt);
		if (mx + mod < other.mx + other.mod) return Node(other.mx + other.mod, other.cnt);
		Node res = Node();
		res.mx = mx + mod;
		res.cnt = cnt + other.cnt;
		return res;
	}
};
const ll N = 1 << 19;
Node t[N * 2]{};
void push(int v) {
	t[v * 2].mod += t[v].mod;
	t[v * 2 + 1].mod += t[v].mod;
	t[v].mod = 0;
}
void upd(int lx, int rx, int d, int v = 1, int l = 0, int r = N) {
	if (lx <= l && r <= rx) {
		t[v].mod += d;
		return;
	}
	if (lx >= r || l >= rx) return;
	int m = (l + r) / 2;
	push(v);
	upd(lx, rx, d, v * 2, l, m);
	upd(lx, rx, d, v * 2 + 1, m, r);
	t[v] = t[v * 2] + t[v * 2 + 1];
}
Node get(int lx, int rx, int v = 1, int l = 0, int r = N) {
	if (lx <= l && r <= rx) return t[v];
	if (lx >= r || l >= rx) return Node();
	int m = (l + r) / 2;
	push(v);
	Node res = get(lx, rx, v * 2, l, m) + get(lx, rx, v * 2 + 1, m, r);
	t[v] = t[v * 2] + t[v * 2 + 1];
	return res;
}
ll res = 0;
void init(int n, int q, const vector<int>& a) {
	vector<int> nxt(n + 1, n);
	vector<int> cur(n + 1, n);
	vector<vector<int>> poss(n + 1, {-1});
	for (int i = 0; i < n; i++) {
		poss[a[i]].push_back(i);
	}
	vector<vector<array<int, 3>>> z(n + 2);
	for (int c = 1; c <= n; c++) {
		poss[c].push_back(n);
		vector<int>& p = poss[c];
		for (int i = 0; i + 1 < p.size(); i++) {
			z[p[i] + 1].push_back({p[i] + 1, p[i + 1], 1});
			z[p[i + 1]].push_back({p[i] + 1, p[i + 1], -1});
			if (i + c + 1 < p.size()) {
				z[p[i] + 1].push_back({p[i + c], p[i + c + 1], 1});
				z[p[i + 1] + 1].push_back({p[i + c], p[i + c + 1], -1});
			}
		}
	}
	for (int i = 0; i < n; i++) t[i + N] = Node(0, 1);
	for (int v = N - 1; v >= 1; v--) t[v] = t[v * 2] + t[v * 2 + 1];
	for (int l = 0; l < n; l++) {
		for (auto p : z[l]) {
			upd(p[0], p[1], p[2]);
		}
		Node x = get(l, n);
		if (x.mx + x.mod == n) res += x.cnt;
	}
}

ll query(int l, int r) {
	return res;
}

#ifdef _DEBUG
int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
#endif