/*#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<bool>> blck = blocked;
    vector<vector<int>> cnt(n, vector<int> (m, 0));
    for (int j = 0; j < m; j++) {
        if (!blocked[n - 1][j]) cnt[n - 1][j] = 1;
    }
    for (int i = n - 2; i >= 0; i--) {
        vector<int> stck;
        int curcnt = 0;
        for (int j = 0; j < m; j++) {
            if (blck[i][j]) {
                if (curcnt == 0) {
                    for (auto &x : stck) {
                        blck[i][x] = true;
                    }
                } else {
                    for (auto &x : stck) {
                        cnt[i][x] = curcnt;
                    }
                }
                stck.clear();
                curcnt = 0;
                continue;
            }
            if (!blck[i + 1][j]) {
                curcnt += cnt[i + 1][j];
            }
            stck.push_back(j);
        }
        if (curcnt == 0) {
            for (auto &x : stck) {
                blck[i][x] = true;
            }
        } else {
            for (auto &x : stck) {
                cnt[i][x] = curcnt;
            }
        }
    }
    int x = k;
    for (int i = 0; i < n; i++) {
        int l = x;
        for (; l > 0 && !blck[i][l - 1]; l--);
        int r = x;
        for (; r < m - 1 && !blck[i][r + 1]; r++);
        int curx = -1;
        vector<int> tmp;
        for (int j = l; j <= r; j++) {
            if (i == n - 1 || !blck[i + 1][j]) {
                if (j == x) curx = tmp.size();
                tmp.push_back(j);
            }
        }
        l = 0;
        r = tmp.size() - 1;
        while (r - l > 0) {
            int m = (l + r + 1) / 2;
            if (m == curx) {
                if (m != r) m++;
                else m--;
            }
            if (investigate(tmp[m])) {
                if (m < x) {
                    r = m;
                } else {
                    l = m;
                }
            } else {
                if (m < x) {
                    l = m + 1;
                } else {
                    r = m - 1;
                }
            }
        }
        goDeeper(tmp[l]);
        x = tmp[l];
    }
}*/
#include "tunnels.h"

using namespace std;

#define ld long double

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<bool>> blck = blocked;
    vector<vector<int>> cnt(n + 1, vector<int> (m, 0));
    for (int j = 0; j < m; j++) {
        cnt[n][j] = 1;
    }
    for (int j = 0; j < m; j++) {
        vector<int> stck;
        bool f = false;
        int curcnt = 0;
        for (int j = 0; j < m; j++) {
            if (blck[n - 1][j]) {
                if (f) {
                    f = false;
                    for (auto &x : stck) {
                        cnt[n - 1][x] = curcnt;
                    }
                    curcnt = 0;
                    stck.clear();
                    continue;
                }
                for (auto &x : stck) {
                    blck[n - 1][x] = true;
                }
                continue;
            }
            f = true;
            curcnt++;
            stck.push_back(j);
        }
        if (!f) {
            for (auto &x : stck) {
                blck[n - 1][x] = true;
            }
        } else {
            f = false;
            for (auto &x : stck) {
                cnt[n - 1][x] = curcnt;
            }
            stck.clear();
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        vector<int> stck;
        bool f = false;
        int curcnt = 0;
        for (int j = 0; j < m; j++) {
            if (blck[i][j]) {
                if (f) {
                    f = false;
                    for (auto &x : stck) {
                        cnt[i][x] = curcnt;
                    }
                    stck.clear();
                    continue;
                }
                for (auto &x : stck) {
                    blck[i][x] = true;
                }
                continue;
            }
            if (!blck[i + 1][j]) {
                f = true;
                curcnt += cnt[i + 1][j];
            }
            stck.push_back(j);
        }
        if (!f) {
            for (auto &x : stck) {
                blck[i][x] = true;
            }
        } else {
            f = false;
            for (auto &x : stck) {
                cnt[i][x] = curcnt;
            }
            stck.clear();
        }
    }
    int x = k;
    for (int i = 0; i < n; i++) {
        int l = x;
        for (; l > 0 && !blck[i][l - 1]; l--);
        int r = x;
        for (; r < m - 1 && !blck[i][r + 1]; r++);
        int curx = -1;
        vector<int> tmp;
        for (int j = l; j <= r; j++) {
            if (i == n - 1 || !blck[i + 1][j]) {
                if (j == x) curx = tmp.size();
                tmp.push_back(j);
            }
        }
        l = 0;
        r = tmp.size() - 1;
        int cursu = 0;
        for (auto &x : tmp) {
            if (i != n - 1) {
                cursu += cnt[i + 1][x];
            } else {
                cursu++;
            }
        }
        while (r - l > 0) {
            int m = l;
            int su = 0;
            for (; m < r && (cursu - su) > su; m++) {
                su += cnt[i + 1][tmp[m]];
            }
            if ((2 * su - cursu) > (cursu - (2 * (su - cnt[i + 1][tmp[m - 1]])))) {
                m--;
            }
            //int m = (l + r + 1) / 2;
            if (m <= curx) {
                m--;
            }
            if (investigate(tmp[m])) {
                if (m < x) {
                    cursu = su;
                    r = m;
                } else {
                    cursu = cursu - su;
                    l = m;
                }
            } else {
                if (m < x) {
                    cursu = cursu - su;
                    l = m + 1;
                } else {
                    cursu = su;
                    r = m - 1;
                }
            }
        }
        goDeeper(tmp[l]);
        x = tmp[l];
    }
}