#include <bits/stdc++.h>

using namespace std;

struct Segment_tree{
    struct Node{
        int l, r;
        int mi;
        int mod;
        Node() {};
        Node(int x, int ind) {
            l = ind;
            r = ind + 1;
            mi = x;
            mod = 0;
        }
        Node(Node le, Node ri) {
            l = le.l;
            r = ri.r;
            mi = min(le.mi, ri.mi);
            mod = 0;
        }
        void add_mod(int x) {
            mod += x;
        }
        void apply_mod() {
            mi += mod;
            mod = 0;
        }
    };
    vector<Node> tr;
    void build(int i, int l, int r) {
        if (r - l == 1) {
            tr[i] = Node(0, l);
            return;
        }
        int m = (l + r) / 2;
        build(2 * i + 1, l, m);
        build(2 * i + 2, m, r);
        tr[i] = Node(tr[2 * i + 1], tr[2 * i + 2]);
    }
    void push(int i) {
        if (tr[i].r - tr[i].l > 1) {
            tr[2 * i + 1].add_mod(tr[i].mod);
            tr[2 * i + 2].add_mod(tr[i].mod);
        }
        tr[i].apply_mod();
    }
    void add(int l, int r, int x, int i = 0) {
        push(i);
        if (tr[i].l >= r || tr[i].r <= l) {
            return;
        }
        if (l <= tr[i].l && tr[i].r <= r) {
            tr[i].add_mod(x);
            push(i);
            return;
        }
        add(l, r, x, 2 * i + 1);
        add(l, r, x, 2 * i + 2);
        tr[i] = Node(tr[2 * i + 1], tr[2 * i + 2]);
    }
    void get(int l, int r, int &a, int i = 0) {
        push(i);
        if (tr[i].r <= l || tr[i].l >= r || tr[i].mi > 0) return;
        if (tr[i].r - tr[i].l == 1) {
            //a.push_back(tr[i].l);
            a++;
            return;
        }
        get(l, r, a, 2 * i + 1);
        get(l, r, a, 2 * i + 2);
    }
    Segment_tree(int n) {
        tr.resize(4 * n);
        build(0, 0, n);
    }
};

//vector<pair<int, int>> fans;
int cnt;

void init(int N, int Q, const std::vector<int>& a) {
    vector<deque<int>> v(N + 1);
    for (int i = 0; i <= N; i++) {
        v[i].push_back(-1);
    }
    Segment_tree tr(N + 1);
    int le = 0;
    for (int i = 0; i < N; i++) {
        vector<int> l;
        tr.add(v[a[i]].back() + 1, i + 1, a[i]);
        tr.add(v[a[i]].front() + 1, i + 1, -1);
        v[a[i]].push_back(i);
        if (v[a[i]].size() > a[i]) {
            le = max(le, (int)(v[a[i]].front() + 1));
            v[a[i]].pop_front();
        }
        tr.get(le, i + 1, cnt);
        /*for (auto &j : l) {
            fans.push_back({j, i + 1});
        }*/
    }
}

long long query(int l, int r) {
    r++;
    /*int cnt = 0;
    for (auto &x : fans) {
        if (l <= x.first && x.second <= r) {
            cnt++;
        }
    }*/
    return cnt;
}
/*
int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
*/