#include "tunnels.h"

#include <bits/stdc++.h>

using namespace std;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
    vector<vector<int>> can_go(n + 1, vector<int>(m));
    can_go[n].assign(m, 1);
    for (int level = n - 1; level >= 0; --level) {
        for (int i = 0; i < m; ++i) {
            if (!blocked[level][i] && can_go[level + 1][i]) {
                can_go[level][i] = 1;
            }
            if (!blocked[level][i] && i > 0 && can_go[level][i - 1]) {
                can_go[level][i] = 1;
            }
        }
        for (int i = m - 2; i >= 0; --i) {
            if (!blocked[level][i] && can_go[level][i + 1]) {
                can_go[level][i] = 1;
            }
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(m));
    for (int level = n - 1; level >= 0; --level) {
        vector<int> nw;
        auto calc_for_nw = [&]() {
            if (nw.empty()) {
                return;
            }
            int cnt = nw.size();
            vector<vector<int>> dp_nw(cnt, vector<int>(cnt + 1));
            for (int i = 0; i < cnt; ++i) {
                dp_nw[i][i + 1] = dp[level + 1][nw[i]];
            }
            for (int l = cnt - 1; l >= 0; --l) {
                for (int r = l + 2; r <= cnt; ++r) {
                    dp_nw[l][r] = max(dp_nw[l][l + 1], dp_nw[l + 1][r]) + 1;
                    for (int m = l + 1; m < r; ++m) {
                        dp_nw[l][r] = min(dp_nw[l][r], max(dp_nw[l][m], dp_nw[m][r]) + 1);
                    }
                }
            }
            for (auto ind : nw) {
                dp[level][ind] = dp_nw[0][cnt];
            }
        };
        for (int i = 0; i < m; ++i) {
            if (blocked[level][i]) {
                calc_for_nw();
                nw.clear();
            } else if (can_go[level + 1][i]) {
                nw.push_back(i);
            }
        }
        calc_for_nw();
    }
    int level = 0;
    while (level < n) {
        vector<int> nw;
        for (int i = k - 1; i >= 0; --i) {
            if (blocked[level][i]) {
                break;
            }
            if (can_go[level + 1][i]) {
                nw.push_back(i);
            }
        }
        reverse(nw.begin(), nw.end());
        for (int i = k; i < m; ++i) {
            if (blocked[level][i]) {
                break;
            }
            if (can_go[level + 1][i]) {
                nw.push_back(i);
            }
        }
        int cnt = nw.size();
        vector<vector<int>> dp_nw(cnt, vector<int>(cnt + 1)), sep(cnt, vector<int>(cnt + 1));
        for (int i = 0; i < cnt; ++i) {
            dp_nw[i][i + 1] = dp[level + 1][nw[i]];
        }
        for (int l = cnt - 1; l >= 0; --l) {
            for (int r = l + 2; r <= cnt; ++r) {
                dp_nw[l][r] = max(dp_nw[l][l + 1], dp_nw[l + 1][r]) + 1;
                sep[l][r] = l + 1;
                for (int m = l + 1; m < r; ++m) {
                    if (max(dp_nw[l][m], dp_nw[m][r]) + 1 < dp_nw[l][r]) {
                        dp_nw[l][r] = max(dp_nw[l][m], dp_nw[m][r]) + 1;
                        sep[l][r] = m;
                    }
                }
            }
        }
        int l_nw = 0, r_nw = cnt;
        while (l_nw < r_nw - 1) {
            int md = sep[l_nw][r_nw];
            if (nw[md] <= k) {
                if (investigate(nw[md] - 1)) {
                    r_nw = md;
                } else {
                    l_nw = md;
                }
            } else {
                if (investigate(nw[md])) {
                    l_nw = md;
                } else {
                    r_nw = md;
                }
            }
        }
        goDeeper(nw[l_nw]);
        k = nw[l_nw];
        level++;
    }
}
