#include "c.h"

#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19;

int mn[R * 2], add[R * 2];

void push(int node) {
    if (add[node] != 0) {
        mn[node * 2] += add[node];
        add[node * 2] += add[node];
        mn[node * 2 + 1] += add[node];
        add[node * 2 + 1] += add[node];
    }
    add[node] = 0;
}

void add_to_segm(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        mn[node] += val;
        add[node] += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    add_to_segm(ql, qr, val, node * 2, nl, nm);
    add_to_segm(ql, qr, val, node * 2 + 1, nm, nr);
    mn[node] = min(mn[node * 2], mn[node * 2 + 1]);
}

vector<pair<int, int>> segms;

void get_segms(int ql, int node = 1, int nl = 0, int nr = R) {
    if (mn[node] > 0) {
        return;
    }
    if (nr <= ql) {
        return;
    }
    if (nl == nr - 1) {
        if (ql == nl) {
            return;
        }
        segms.emplace_back(ql, nl);
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    get_segms(ql, node * 2, nl, nm);
    get_segms(ql, node * 2 + 1, nm, nr);
    mn[node] = min(mn[node * 2], mn[node * 2 + 1]);
}

void init(int n, int q, const vector<int> &a) {
    add_to_segm(n + 1, R, 1);
    vector<vector<int>> pos(n + 1);
    for (int i = 0; i < n; ++i) {
        pos[a[i]].push_back(i);
    }
    for (int i = n - 1; i >= 0; --i) {
        int p = lower_bound(pos[a[i]].begin(), pos[a[i]].end(), i) - pos[a[i]].begin();
        if (p + 1 < (int)pos[a[i]].size()) {
            if (p + 1 + a[i] <= (int)pos[a[i]].size()) {
                add_to_segm(pos[a[i]][p + 1] + 1, pos[a[i]][p + a[i]] + 1, -1);
                if (p + 1 + a[i] < (int)pos[a[i]].size()) {
                    add_to_segm(pos[a[i]][p + 1 + a[i]] + 1, R, -1);
                }
            } else {
                add_to_segm(pos[a[i]][p + 1] + 1, R, -1);
            }
        }
        if (p + a[i] <= (int)pos[a[i]].size()) {
            add_to_segm(i + 1, pos[a[i]][p + a[i] - 1] + 1, 1);
            if (p + a[i] < (int)pos[a[i]].size()) {
                add_to_segm(pos[a[i]][p + a[i]], R, 1);
            }
        } else {
            add_to_segm(i + 1, R, 1);
        }
        get_segms(i);
    }
}

long long query(int l, int r) {
    r++;
    long long ans = 0;
    for (auto [ll, rr] : segms) {
        if (l <= ll && rr <= r) {
            ans++;
        }
    }
    return ans;
}
