#include "tunnels.h"
#include <bits/stdc++.h>
#include <cassert>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<int>> used(n, vector<int>(m, 0));
    auto dfs = [&](int i, int j, auto&&self) -> void {
        used[i][j] = 1;
        if (i - 1 >= 0 && !blocked[i - 1][j] && !used[i - 1][j]) self(i - 1, j, self);
        if (j + 1 < m && !blocked[i][j + 1] && !used[i][j + 1]) self(i, j + 1, self);
        if (j - 1 >= 0 && !blocked[i][j - 1] && !used[i][j - 1]) self(i, j - 1, self);
    };
    for (int j = 0; j < m; j++) if (!used[n - 1][j] && !blocked[n - 1][j]) dfs(n - 1, j, dfs);
    int row = 0, col = k;
    while (row < n) {
        assert(!blocked[row][col]);
        vector<int> poss;
        for (int jj = col - 1; jj >= 0; jj--) {
            if (blocked[row][jj]) break;
            if (row == n - 1) {
                poss.pb(jj);
                continue;
            }
            if (used[row + 1][jj]) poss.pb(jj);
        }
        reverse(all(poss)); 
        if (row == n - 1) poss.pb(col);
        else if (used[row + 1][col]) poss.pb(col);
        for (int jj = col + 1; jj < m; jj++) {
            if (blocked[row][jj]) break;
            if (row == n - 1) {
                poss.pb(jj); continue;
            }
            if (used[row + 1][jj]) poss.pb(jj);
        }
        sort(all(poss));

        vector<vector<int>> dp(sz(poss), vector<int>(sz(poss), 1e9)), optq(sz(poss), vector<int>(sz(poss)));
        for (int i = 0; i < sz(poss); i++) dp[i][i] = 0;
        for (int len = 2; len <= sz(poss); len++) {
            for (int i = 0; i + len - 1 < sz(poss); i++) {
                for (int jj = i; jj <= i + len - 1; jj++) {
                    if (poss[jj] == col) continue;
                    int worst = 0;
                    if (poss[jj] > col) worst = max(dp[jj][i + len - 1], (jj - 1 < i ? 0 : dp[i][jj - 1]));
                    else worst = max(dp[i][jj], (jj + 1 > i + len - 1 ? 0 : dp[jj + 1][i + len - 1]));
                    if (dp[i][i + len - 1] > worst + 1) {
                        dp[i][i + len - 1] = worst + 1;
                        optq[i][i + len - 1] = jj;
                    }
                }
            }
        }

        int L = 0, R = sz(poss) - 1;
        int took = 0;
        while (R - L >= 1) {
            int mid = optq[L][R];
            took++;
            assert(poss[mid] != col);
            if (investigate(poss[mid])) {
                if (poss[mid] > col) {
                    L = mid;
                } else {
                    R = mid;
                }
            } else {
                if (poss[mid] > col) {
                    R = mid - 1;
                } else {
                    L = mid + 1;
                }
            }
        }
        //if (sz(poss) >= 2) assert((1 << took) >= sz(poss) && (1 << (took - 1)) < sz(poss));
        if (row + 1 < n) assert(!blocked[row + 1][poss[L]] && used[row + 1][poss[L]]);
        col = poss[L];
        row++;
        goDeeper(col);
    }
    return;
}