#include "tunnels.h"
#include <bits/stdc++.h>
#include <cassert>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<int>> used(n, vector<int>(m, 0));
    used.pb(vector<int>(m + 1, 1));
    auto dfs = [&](int i, int j, auto&&self) -> void {
        used[i][j] = 1;
        if (i - 1 >= 0 && !blocked[i - 1][j] && !used[i - 1][j]) self(i - 1, j, self);
        if (j + 1 < m && !blocked[i][j + 1] && !used[i][j + 1]) self(i, j + 1, self);
        if (j - 1 >= 0 && !blocked[i][j - 1] && !used[i][j - 1]) self(i, j - 1, self);
    };
    for (int j = 0; j < m; j++) if (!used[n - 1][j] && !blocked[n - 1][j]) dfs(n - 1, j, dfs);
    //int i = 0, j = k;
    vector<vector<int>> dp_final(n, vector<int>(m, 1e9));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            if (!used[i][j]) continue;
            vector<int> poss;
            for (int jj = j - 1; jj >= 0; jj--) {
                if (!used[i][jj]) break;
                if (used[i + 1][jj]) poss.pb(jj);
            }
            reverse(all(poss));
            if (used[i + 1][j]) poss.pb(j);
            for (int jj = j + 1; jj < m; jj++) {
                if (!used[i][jj]) break;
                if (used[i + 1][jj]) poss.pb(jj);
            }

            vector<vector<int>> dp(sz(poss), vector<int>(sz(poss), 1e9)), opt(sz(poss), vector<int>(sz(poss)));
            for (int jj = 0; jj < sz(poss); jj++) { dp[jj][jj] = (i + 1 == n ? 0 : dp_final[i + 1][poss[jj]]); opt[jj][jj] = jj; }
            for (int len = 2; len <= sz(poss); len++) {
                for (int jj = 0; jj + len - 1 < sz(poss); jj++) {
                    auto relax = [&](int ps) {
                        if (poss[ps] == j) return;
                        if (poss[ps] > j) {
                            if (dp[jj][jj + len - 1] > 1 + max(dp[ps][jj + len - 1], (ps - 1 < jj ? 0 : dp[jj][ps - 1]))) {
                                dp[jj][jj + len - 1] = 1 + max(dp[ps][jj + len - 1], (ps - 1 < jj ? 0 : dp[jj][ps - 1]));
                                opt[jj][jj + len - 1] = ps;
                            }
                            //dp[jj][jj + len - 1] = min(dp[jj][jj + len - 1], max())
                        } else {
                            if (dp[jj][jj + len - 1] > 1 + max(dp[jj][ps], (ps + 1 > jj + len - 1 ? 0 : dp[ps + 1][jj + len - 1]))) {
                                dp[jj][jj + len - 1] = 1 + max(dp[jj][ps], (ps + 1 > jj + len - 1 ? 0 : dp[ps + 1][jj + len - 1]));
                                opt[jj][jj + len - 1] = ps;
                            }
                        }
                    };  
                    for (int PS = jj; PS <= jj + len - 1; PS++) relax(PS);
                    relax(jj); relax(jj + len - 1); relax((jj + jj + len - 1) / 2);
                    //relax(opt[jj + 1][jj + len - 1]); relax(opt[jj][jj + len - 2]);
                    for (int dlt = -1; dlt <= 1; dlt++) {
                        if (opt[jj + 1][jj + len - 1] + dlt >= jj && opt[jj + 1][jj + len - 1] + dlt <= jj + len - 1) {
                            relax(opt[jj + 1][jj + len - 1] + dlt);
                        }
                        if (opt[jj][jj + len - 2] + dlt >= jj && opt[jj][jj + len - 2] + dlt <= jj + len - 1) {
                            relax(opt[jj][jj + len - 2] + dlt);
                        }
                    }
                }
            }
            dp_final[i][j] = dp[0][sz(poss) - 1];
        }
    }
   // return;

    int row = 0, col = k;
    while (row < n) {
        assert(!blocked[row][col]);
        vector<int> poss;
        for (int jj = col - 1; jj >= 0; jj--) {
            if (blocked[row][jj]) break;
            if (row == n - 1) {
                poss.pb(jj);
                continue;
            }
            if (used[row + 1][jj]) poss.pb(jj);
        }
        reverse(all(poss)); 
        if (row == n - 1) poss.pb(col);
        else if (used[row + 1][col]) poss.pb(col);
        for (int jj = col + 1; jj < m; jj++) {
            if (blocked[row][jj]) break;
            if (row == n - 1) {
                poss.pb(jj); continue;
            }
            if (used[row + 1][jj]) poss.pb(jj);
        }
        sort(all(poss));

        vector<vector<int>> dp(sz(poss), vector<int>(sz(poss), 1e9)), optq(sz(poss), vector<int>(sz(poss)));
        for (int i = 0; i < sz(poss); i++) dp[i][i] = (i == n - 1 ? 0 : dp_final[i + 1][poss[i]]);
        for (int len = 2; len <= sz(poss); len++) {
            for (int i = 0; i + len - 1 < sz(poss); i++) {
                for (int jj = i; jj <= i + len - 1; jj++) {
                    if (poss[jj] == col) continue;
                    int worst = 0;
                    if (poss[jj] > col) worst = max(dp[jj][i + len - 1], (jj - 1 < i ? 0 : dp[i][jj - 1]));
                    else worst = max(dp[i][jj], (jj + 1 > i + len - 1 ? 0 : dp[jj + 1][i + len - 1]));
                    if (dp[i][i + len - 1] > worst + 1) {
                        dp[i][i + len - 1] = worst + 1;
                        optq[i][i + len - 1] = jj;
                    }
                }
            }
        }

        int L = 0, R = sz(poss) - 1;
        int took = 0;
        while (R - L >= 1) {
            int mid = optq[L][R];
            took++;
            assert(poss[mid] != col);
            if (investigate(poss[mid])) {
                if (poss[mid] > col) {
                    L = mid;
                } else {
                    R = mid;
                }
            } else {
                if (poss[mid] > col) {
                    R = mid - 1;
                } else {
                    L = mid + 1;
                }
            }
        }
        //if (sz(poss) >= 2) assert((1 << took) >= sz(poss) && (1 << (took - 1)) < sz(poss));
        if (row + 1 < n) assert(!blocked[row + 1][poss[L]] && used[row + 1][poss[L]]);
        col = poss[L];
        row++;
        goDeeper(col);
    }
    return;
}