#include <bits/stdc++.h>
#include <cassert>
using namespace std;
using ll = long long;

vector<pair<int, int>> segs;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct node {
    int sm{0}, tl, tr;
    node* l = nullptr, *r = nullptr;
    node() = default;
    node(int sm_, int tl_, int tr_) {
        sm = sm_; tl = tl_; tr = tr_;
    }
};

int getsum(node* v, int r) {
    if (v == nullptr || v->tl >= r) return 0;
    if (v->tr <= r) return v->sm;
    return getsum(v->l, r) + getsum(v->r, r);
}

node* update(node* v, int pos) {
    node* neww = new node(v->sm + 1, v->tl, v->tr);
    if (v->tl + 1 == v->tr) {
        return neww;
    }
    int tm = (v->tl + v->tr) >> 1;
    if (pos < tm) {
        if (v->l == nullptr) {
            v->l = new node(0, v->tl, tm);
        }
        neww->l = update(v->l, pos);
        neww->r = v->r;
    } else {
        if (v->r == nullptr) {
            v->r = new node(0, tm, v->tr);
        }
        neww->r = update(v->r, pos);
        neww->l = v->l;
    }
    return neww;
}

vector<node*> roots;

void init(int N, int Q, const vector<int> &a) {
    vector<vector<ll>> rnum(N + 1);
    vector<int> cnt(N + 1);
    for (int u : a) cnt[u]++;
    for (int x = 1; x <= N; x++) {
        rnum[x].assign(min(x, cnt[x]), 0);
        ll xr = 0;
        for (int j = 0; j < min(x - 1, sz(rnum[x])); j++) {
            rnum[x][j] = rnd() % 1000000000000000;
            xr ^= rnum[x][j];
        }
        if (rnum[x].size() == x) {
            rnum[x][x - 1] = xr;
        }
    }
    int n = N;
    vector<int> curcnt(N + 1, 0);
    vector<ll> pref(N + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] ^ rnum[a[i]][curcnt[a[i]] % sz(rnum[a[i]])];
        curcnt[a[i]]++;
    }

    map<ll, vector<int>> poss;
    poss[pref[n]].pb(n);
    set<int> st;
    curcnt.assign(n + 1, 0);
    vector<vector<int>> pos(n + 1);
    for (int i = 0; i < n; i++) pos[a[i]].pb(i);
    vector<int> id(n + 1);
    for (int i =0; i <= n; i++) id[i] = sz(pos[i]) - 1;
    for (int i = n - 1; i >= 0; i--) {
        if (curcnt[a[i]] > a[i]) {
            st.erase(pos[a[i]][id[a[i]]]);
            id[a[i]]--;
        }
        curcnt[a[i]]++;
        if (curcnt[a[i]] > a[i]) {
            st.insert(pos[a[i]][id[a[i]]]);
        }
        if (poss.find(pref[i]) != poss.end()) {
            int I = sz(poss[pref[i]]) - 1;
            while (I >= 0 && poss[pref[i]][I] <= (st.empty() ? n : *st.begin())) {
                segs.pb({i, poss[pref[i]][I] - 1});
                I--;
            }
        }   
        poss[pref[i]].pb(i);
    }

    reverse(all(segs));
    int idd = 0;
    roots.resize(n + 1, 0);
    roots[0] = new node(0, 0, n);
    for (int i = 0; i < n; i++) {
        node* cur = roots[i];
        while (idd < sz(segs) && segs[idd].first == i) {
            cur = update(cur, segs[idd++].second);
        }
        roots[i + 1] = cur;
    }
}

ll query(int l, int r) {
    return getsum(roots[r + 1], r + 1) - getsum(roots[l], r + 1);
}