#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include "tunnels.h"
using namespace std;
//bool investigate(int s);
//void goDeeper(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& bl) {
	vector<vector<int>> t(n, vector<int>(m));
	queue<pair<int, int>> q;
	for (int i = 0; i < m; ++i) {
		if (!bl[n - 1][i]) {
			q.push({ n - 1, i });
			t[n - 1][i] = 1;
		}
	}
	while (!q.empty()) {
		auto xy = q.front();
		q.pop();
		if (xy.first > 0) {
			if (!bl[xy.first - 1][xy.second]) {
				if (!t[xy.first - 1][xy.second]) {
					q.push({ xy.first - 1, xy.second });
					t[xy.first - 1][xy.second] = 1;
				}
			}
		}
		if (xy.second > 0) {
			if (!bl[xy.first][xy.second - 1]) {
				if (!t[xy.first][xy.second - 1]) {
					q.push({ xy.first, xy.second - 1 });
					t[xy.first][xy.second - 1] = 1;
				}
			}
		}
		if (xy.second < m - 1) {
			if (!bl[xy.first][xy.second + 1]) {
				if (!t[xy.first][xy.second + 1]) {
					q.push({ xy.first, xy.second + 1 });
					t[xy.first][xy.second + 1] = 1;
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		vector<int> ls, mr;
		int x = k - 1;
		while (x >= 0 && !bl[i][x]) {
			if (i == n - 1 || t[i + 1][x]) {
				ls.push_back(x);
			}
			--x;
		}
		reverse(ls.begin(), ls.end());
		x = k + 1;
		while (x < m && !bl[i][x]) {
			if (i == n - 1 || t[i + 1][x]) {
				mr.push_back(x);
			}
			++x;
		}
		int lt = -1, rt = mr.size();
		bool fl = 1;
		if (mr.empty()) {
			rt = ls.size();
			fl = 0;
		}
		else if (!ls.empty()) {
			int xt = ls.size() + mr.size();
			xt /= 2;
			if (ls.size() > mr.size()) {
				if (investigate(ls[xt])) {
					rt = xt;
					fl = 0;
				}
				else {
					rt = mr.size();
				}
			}
			else {
				if (investigate(mr[xt - ls.size()])) {
					lt = xt - ls.size();
				}
				else {
					rt = ls.size();
					fl = 0;
				}
			}
		}
		if (i != n - 1 && !t[i + 1][k]) {
			if (fl) {
				lt = 0;
			}
			else {
				rt = ls.size() - 1;
			}
		}
		if (fl) {
			while (rt - lt > 1) {
				int md = (lt + rt) / 2;
				if (investigate(mr[md])) {
					lt = md;
				}
				else {
					rt = md;
				}
			}
			if (lt == -1) {
				goDeeper(k);
			}
			else {
				goDeeper(mr[lt]);
				k = mr[lt];
			}
		}
		else {
			while (rt - lt > 1) {
				int md = (lt + rt) / 2;
				if (investigate(ls[md])) {
					rt = md;
				}
				else {
					lt = md;
				}
			}
			if (rt == ls.size()) {
				goDeeper(k);
			}
			else {
				goDeeper(ls[rt]);
				k = ls[rt];
			}
		}
	}
}
/*
//#include "tunnels.h"

//#include <iostream>

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
	std::cin >> n >> m >> k;

	blocked.resize(n);
	for (int i = 0; i < n; i++)
	{
		blocked[i].resize(m);
		for (int j = 0; j < m; j++)
		{
			char c;
			std::cin >> c;
			blocked[i][j] = c == '1';
		}
	}
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
	std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

	while (currY != y)
	{
		if (currY < y) currY++;
		else currY--;

		if (blocked[currX][currY])
		{
			std::cout << "Passing through blocked chamber." << std::endl;
			exit(0);
		}
	}
}

bool investigate(int y)
{
	numQueries++;
	std::cout << "Investigating: " << y << std::endl;
	goTo(y);
	std::cout << "Enter 0/1:" << std::endl;
	bool ans;
	std::cin >> ans;
	return ans;
}

void goDeeper(int y)
{
	std::cout << "Going deeper: " << y << std::endl;

	if (currX == n)
	{
		std::cout << "Already in the treasure room." << std::endl;
		exit(0);
	}

	goTo(y);
	currX++;

	if (currX == n) return;

	if (blocked[currX][currY])
	{
		std::cout << "Went deeper into a blocked chamber." << std::endl;
		exit(0);
	}
}

int main()
{
	input();

	currX = 0;
	currY = k;

	if (blocked[currX][currY])
	{
		std::cout << "Starting chamber is blocked." << std::endl;
		exit(0);
	}

	solve(n, m, k, blocked);

	if (currX < n)
	{
		std::cout << "Did not reach the treasure room." << std::endl;
		exit(0);
	}

	std::cout << "Reached the treasure room." << std::endl;

	std::cout << "Number of investigations: " << numQueries << std::endl;

	return 0;
}
//*/