#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

const int INF = 1e9;
void solve(int n, int m, int k, const vector<vector<bool> > &blocked) {
    vector<vi> Reach(n + 1, vi(m, 0));
    Reach[n] = vi(m, 1);

    for(int i = n - 1; i >= 0; --i) {
        for(int j = 0; j < m; ++j) {
            if(!blocked[i][j]) {
                Reach[i][j] |= Reach[i + 1][j];
                if(j)
                    Reach[i][j] |= Reach[i][j - 1];
            }
        }
        for(int j = m - 2; j >= 0; --j) {
            if(!blocked[i][j])
                Reach[i][j] |= Reach[i][j + 1];
        }
    }

    vector<vi> DP(m, vi(m, INF));
    vector<vi> Tip(m, vi(m, 0)), PozQ(m, vi(m, 0));
    DP[0][0] = 0;

    for(int i = 1; i < m; ++i) {
        DP[0][i] = DP[i][0] = 31 - __builtin_clz(i + 1);
        //cerr << "Pt " << i << " " << DP[0][i] << "\n";
    }

    for(int l1 = 0; l1 < m; ++l1) {
        for(int l2 = 0; l2 < m; ++l2) {
            if(!l1 && !l2) continue;
            for(int i = 0; i < l1; ++i) {
                int v = max(DP[i][0], DP[l1 - 1 - i][l2]);
                if(DP[l1][l2] > v) {
                    DP[l1][l2] = v;
                    Tip[l1][l2] = 0;
                    PozQ[l1][l2] = i;
                }
            }
            for(int i = 0; i < l2; ++i) {
                int v = max(DP[0][i], DP[l1][l2 - 1 - i]);
                if(DP[l1][l2] > v) {
                    DP[l1][l2] = v;
                    Tip[l1][l2] = 1;
                    PozQ[l1][l2] = i;
                }
            }
        }
    }

    auto play = [&](int niv, int p) -> int {
        ///returns next position in layer niv + 1(and calls goDeeper)
        int l1_orig = 0, l2_orig = 0;
        while(p - l1_orig > 0 && !blocked[niv][p - l1_orig - 1]) ++l1_orig;
        while(p + l2_orig + 1 < m && !blocked[niv][p + l2_orig + 1]) ++l2_orig;
        int l1 = 0, l2 = 0;
        vi PozL1, PozL2, PozL;
        for(int j = p - l1_orig; j < p; ++j) {
            if(Reach[niv][j] && Reach[niv + 1][j]) {
                PozL1.push_back(j);
                PozL.push_back(j);
            }
        }
        PozL.push_back(p);
        int p_reach = (int)PozL.size() - 1;
        for(int j = p + l2_orig; j > p; --j) {
            if(Reach[niv][j] && Reach[niv + 1][j]) {
                PozL2.push_back(j);
                PozL.push_back(j);
            }
        }
        sort(PozL.begin(), PozL.end());

        l1 = (int)PozL1.size(); l2 = (int)PozL2.size();


        while(l1 || l2) {
            int tip = Tip[l1][l2], poz_rel = PozQ[l1][l2];
            int poz_query = 0, i = poz_rel;
            if(!tip) {
                poz_query = p_reach - l1 + poz_rel;
            } else {
                poz_query = p_reach + l2 - poz_rel;
            }
            int v = investigate(PozL[poz_query]);
            if(v) {
                if(!tip) {
                    l1 = i; l2 = 0; p_reach = poz_query;
                } else {
                    l1 = 0; l2 = i; p_reach = poz_query;
                }
            } else {
                if(!tip) {
                    l1 -= i + 1;
                } else {
                    l2 -= i + 1;
                }
            }
        }

        /// should have remained with a single p

        assert(!l1 && !l2);
        goDeeper(PozL[p_reach]);
        return PozL[p_reach];
    };

    int p = k;
    for(int i = 0; i < n; ++i) {
        p = play(i, p);
    }
}

//int main() {
//    cin.tie(0);
//    ios_base::sync_with_stdio(0);
//
//    return 0;
//}