#include <bits/stdc++.h>

using namespace std;

#define int ll

using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

const int CDebug = 0;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int PRIM1 = 113;

int nr1 = 10, nr2 = 13;
int V_BASE = 3;

struct tree {
    int n;
    vector<vi> L;
    vector<ii> E;

    tree(int N) : n(N), L(N) {}

    void add_node(int p) {
        ++n;
        L.resize(n);
        add_edge(n - 1, p);
    }

    void afis() {
        if(CDebug)printf("ARBORE cu %d NODURI %d muchii\n", n, E.size());
        for(auto [u, v] : E) {
            if(CDebug)printf("%d %d\n", u, v);
        }
    }

    int get_hsh(int baza) {
        function<int(int, int)> dfs = [&](int u, int p) {
            vi V;
            int nr_nonfrz = 0;
            for(auto it : L[u]) {
                if(it == p) continue;
                V.push_back(dfs(it, u));
                nr_nonfrz += L[it].size() != 1;
            }
            sort(V.begin(), V.end());
            int val1 = baza + nr_nonfrz, val2 = baza + nr_nonfrz;
            for(auto it : V) {
                val1 = (1ll * val1 * PRIM1 % MOD1 + it % MOD1 + (it ^ val1) + val1) % MOD1;
                val2 = (1ll * val2 * PRIM1 % MOD2 + it % MOD2 + (it ^ val2) + val2) % MOD2;
                //val = (1ll * val * PRIM1 + (it ^ val) + val + 3) % MOD * (it + 1);
            }
            return val1 ^ (val2 << 30);
        };
        return dfs(0, -1);
    }

    void add_edge(int u, int v) {
        L[u].push_back(v);
        L[v].push_back(u);
        E.push_back({u, v});
    }

    vector<tree> modif1() {
        vector<tree> Re;
        for(int i = 0; i < n; ++i) {
            tree copie_eu = *this;
            copie_eu.add_node(i);
            Re.push_back(copie_eu);
        }
        return Re;
    }

    void resize(int n2) {
        n = n2;
        L.resize(n2);
    }

    vi get_lant(int u0, int u1) {
        vi S;
        int ok = 0; vi re;
        function<void(int, int)> dfs = [&](int u, int p) {
            S.push_back(u);
            if(u == u1) {
                re = S;
                ok = 1;
                return;
            }
            if(ok) return;
            for(auto it : L[u]) {
                if(it == p) continue;
                dfs(it, u);
            }
            S.pop_back();
        };
        dfs(u0, -1);
        return re;
    }

    tree extract(int u, vi evita) {
        ///va extrage subarborele fara a trece prin "evita"
        tree nou(1);
        function<void(int, int, int)> dfs = [&](int u, int p, int codu) {
            for(auto it : L[u]) {
                int ok = 1;
                for(auto it2 : evita) if(it == it2) ok = 0;
                if(it == p) ok = 0;
                if(!ok) continue;

                int codit = nou.n;
                nou.add_node(codu);
                dfs(it, u, codit);
            }
        };
        dfs(u, -1, 0);
        return nou;
    }
};

vector<tree> get_base(int v) {
    vector<tree> A{tree(1)};
    
    vector<tree> base;
    int len_tot = 0;
    for(int len = 2; len <= v; ++len) {
        vector<pair<int, tree> > B;
        for(auto t0 : A) {
            auto M = t0.modif1();
            for(auto it : M)
                B.push_back({it.get_hsh(0), it});
        }
        vector<tree> A2, A3;
        sort(B.begin(), B.end(), [&](auto a, auto b) { return a.first < b.first; });
        for(int i = 0; i < (int)B.size(); ++i) {
            if(!i || B[i].first != B[i - 1].first) A2.push_back(B[i].second);
        }
        len_tot += A2.size();
        for(auto &[val, tree] : B)
            val = tree.get_hsh(1);
        sort(B.begin(), B.end(), [&](auto a, auto b) { return a.first < b.first; });
        for(auto it : A2) base.push_back(it);
        for(int i = 0; i < (int)B.size(); ++i) {
            if(!i || B[i].first != B[i - 1].first) A3.push_back(B[i].second);
        }
        A = A3;
    }
    vector<pair<int, tree> > B;
    for(auto it : base)
        B.push_back({it.get_hsh(0), it});
    base.clear();
    sort(B.begin(), B.end(), [&](auto a, auto b) { return a.first < b.first; });
    for(int i = 0; i < (int)B.size(); ++i) {
        if(!i || B[i].first != B[i - 1].first) base.push_back(B[i].second);
    }

    return base;
}


vector<ii> encode(int n, vector<bool> data) {
    int nr_noduri = 0;

    tree Re(nr1 + 1);
    int nr_ramase = n - nr1 - nr2 - 2;
    for(int i = 0; i < nr1; ++i) {
        Re.add_edge(i, nr1);
    }


    vector<tree> base = get_base(V_BASE);
    sort(base.begin(), base.end(), [&](auto a, auto b) { return a.n < b.n; });

    int CNT = (int)base.size();
    while(CNT & (CNT - 1)) {
        --CNT;
        base.pop_back();
    }
    int len = 31 - __builtin_clz(CNT); /// atatia biti odata

    int poz_data = 0;

    int ult_nod = nr1;
    while(nr_ramase >= V_BASE) {
        int nr = 0;
        for(int i = 0; i < len; ++i) {
            nr = (nr << 1) + data[poz_data];
            ++poz_data;
        }
        tree acum = base[nr];

        nr_ramase -= acum.n;

        int u0 = Re.n;
        Re.resize(Re.n + acum.n);
        Re.add_edge(u0, ult_nod);
        for(auto [a, b] : acum.E) {
            Re.add_edge(a + u0, b + u0);
        }
        ult_nod = u0;
    }
    Re.add_node(ult_nod); // ultimul
    ult_nod = Re.n - 1;
    while(Re.n < n) Re.add_node(ult_nod);

    Re.afis();
    return Re.E;
}

vector<bool> decode(int n, vector<ii> E) {
    tree T(n);
    for(auto [u, v] : E) {
        T.add_edge(u, v);
    }
    vi Imp;
    for(int i = 0; i < n; ++i) {
        if(T.L[i].size() >= nr1) Imp.push_back(i);
    }
    sort(Imp.begin(), Imp.end(), [&](auto a, auto b) { return T.L[a].size() < T.L[b].size(); });
    assert(Imp.size() == 2);

    int u0 = Imp[0], u1 = Imp[1];
    vi Ord = T.get_lant(u0, u1);
    
    ///COd pt baza:
    vector<tree> base = get_base(V_BASE);
    sort(base.begin(), base.end(), [&](auto a, auto b) { return a.n < b.n; });

    int CNT = (int)base.size();
    while(CNT & (CNT - 1)) {
        --CNT;
        base.pop_back();
    }
    int len = 31 - __builtin_clz(CNT); /// atatia biti odata

    ///extragere in sine
    vector<bool> Re;
    if(CDebug)cout << "FOLOSESC O BAZA CU " << CNT << "\n";
    for(int i = 1; i + 1 < Ord.size(); ++i) {
        auto arb2 = T.extract(Ord[i], vi{Ord[i - 1], Ord[i + 1]});
        int val = -1, hsh = arb2.get_hsh(0);
        for(int j = 0; j < CNT; ++j) {
            if(base[j].get_hsh(0) == hsh) {
                assert(val == -1);
                val = j;
            }
        }
        if(CDebug)cout << "Am gasit un " << val << endl;

        for(int j = 0; j < len; ++j)
            Re.push_back(!!(val & (1 << (len - 1 - j))));
    }

    return Re;
}

//signed main() {
//    int n;
//    cin >> n;
//    string s;
//    cin >> s;
//    vector<bool> data;
//    for(auto it : s) data.push_back(it=='1');
//    auto V = encode(n, data);
//    decode(n, V);
//    return 0;
//}