#include <bits/stdc++.h>

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

struct AIB2D {
    int n;
    vector<vi> P, V;
    AIB2D() {}
    AIB2D(int N) : n(N + 1), P(N + 1, {0}), V(N + 1) {}

    void fake_update(int x, int y) {
        ++x; ++y;
        while(x < n) {
            P[x].push_back(y);
            x += x & -x;
        }
    }

    void init() {
        for(int i = 1; i < n; ++i) {
            P[i].push_back(0);
            sort(P[i].begin(), P[i].end());
            P[i].resize(unique(P[i].begin(), P[i].end()) - P[i].begin());
            V[i].resize(P[i].size(), 0);
        }
    }

    int get_p(int x, int y) {
        return upper_bound(P[x].begin(), P[x].end(), y) - P[x].begin() - 1;
    }

    void update(int x, int y, int v) {
        ++x; ++y;
        while(x < n) {
            int c = get_p(x, y);
            while(c < P[x].size()) {
                V[x][c] += v;
                c += c & -c;
            }
            x += x & -x;
        }
    }

    int query(int x, int y) {
        ++x; ++y;
        int re = 0;
        while(x) {
            int c = get_p(x, y);
            while(c > 0) {
                re += V[x][c];
                c -= c & -c;
            }
            x -= x & -x;
        }
        return re;
    }
};

struct AINT {
    int n;
    vi Mi, Lz;

    AINT(int N) : n(N), Mi(4 * N, 0), Lz(4 * N, 0) {}

    void prop(int u, int s, int d) {
        if(!Lz[u]) return;
        Mi[u] += Lz[u];
        if(s != d) {
            Lz[u << 1] += Lz[u];
            Lz[u << 1 | 1] += Lz[u];
        }
        Lz[u] = 0;
    }

    void update(int l, int r, int v, int u, int s, int d) {
        prop(u, s, d);
        if(d < l || r < s) return;
        if(l <= s && d <= r) {
            Lz[u] += v;
            prop(u, s, d);
            return;
        }
        update(l, r, v, u << 1, s, (s + d) >> 1);
        update(l, r, v, u << 1 | 1, ((s + d) >> 1) + 1, d);
        Mi[u] = min(Mi[u << 1], Mi[u << 1 | 1]);
    }

    void update(int l, int r, int v) { update(l, r, v, 1, 0, n - 1); }

    void extract(vi &Re, int lim, int u, int s, int d) {
        prop(u, s, d);
        if(Mi[u]) return;
        if(s > lim) return;
        if(s == d) {
            Re.push_back(s);
            return;
        }
        extract(Re, lim, u << 1, s, (s + d) >> 1);
        extract(Re, lim, u << 1 | 1, ((s + d) >> 1) + 1, d);
    }
    void extract(vi &Re, int lim) {
        extract(Re, lim, 1, 0, n - 1);
    }
};

vector<ii> Re;
AIB2D SolRe;

void init(int n, int q, const vi &A) {
    vector<vi> Poz(n + 1);
    for(int i = 0; i < n; ++i) {
        Poz[A[i]].push_back(i);
    }
    vi Nr(n, 0);

    vector<vector<ii> > Seg(n + 1);

    AINT Sol(n);

    for(int i = 0; i < n; ++i) {
        /// Apare A[i] care trebuie modificat
        int v = A[i];
        ++Nr[v];
        for(auto [st, dr] : Seg[v]) Sol.update(st, dr, -1);
        Seg[v].clear();
        if(Nr[v] >= v) {
            int p1 = Poz[v][Nr[v] - v];
            Seg[v].push_back({p1 + 1, i}); /// asta nu
            if(Nr[v] > v) {
                int p2 = Poz[v][Nr[v] - v - 1];
                Seg[v].push_back({0, p2}); /// asta nu
            }
        } else {
            Seg[v].push_back({0, i}); // nimic nu prea poti
        }
        for(auto [st, dr] : Seg[v]) Sol.update(st, dr, 1);

        vi PozBun;
        Sol.extract(PozBun, i);
        for(auto it : PozBun) {
            Re.push_back({it, i});
            //cerr << it << " " << i << "\n";
        }
    }
    SolRe = AIB2D(n);
    for(auto [l, r] : Re)
        SolRe.fake_update(l, r);

    SolRe.init();

    for(auto [l, r] : Re)
        SolRe.update(l, r, 1);
//    cerr << "Sunt " << Re.size() << " segmente bune\n";
}

ll query(int l, int r) {
 //   int re = 0;
 //   for(auto [st, dr] : Re)
 //       if(st >= l && dr <= r) ++re;
    int re_AIB = SolRe.query(r, r) - SolRe.query(l - 1, r) 
        - SolRe.query(r, l - 1) + SolRe.query(l - 1, l - 1);
//    assert(re_AIB == re);
    return re_AIB;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vi A(n);
    for(int i = 0; i < n; ++i) {
        cin >> A[i];
    }

    init(n, q, A);

    for(int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        cout << query(l, r) << "\n";
    }
    return 0;
}