#include "tunnels.h"
//void goDeeper(int s);
//bool investigate(int s);

#include <vector>
#include <algorithm>

namespace __Sol__ {
  using ll = long long;

  bool good( int ans, int query, int entry ) {
    // return (query - ans) * (ll)(query - entry) <= 0;
    if( ans <= query && query <= entry ) return true;
    if( ans >= query && query >= entry ) return true;
    return false;
  }

  int get_next( const std::vector<bool> &blocked, int entry ) {
    // first, get ranges;
    int left = entry; {
      while( left >= 0 && !blocked[left] )
        left--;
      left++;
    }

    int right = entry; {
      while( right < (int)blocked.size() && !blocked[right] )
        right++;
      right--;
    }

    std::vector<int> variante;
    for( int i = left; i <= right; i++ )
      variante.push_back( i );

    while( (int)variante.size() > 1 ){
      int best = left, nbest = -1;
      for( int query : variante ){
        int cnt[2] = {0, 0};

        for( int ans : variante )
          cnt[good( ans, query, entry )]++;

        int cand = std::min( cnt[0], cnt[1] );
        if( cand > nbest ){
          nbest = cand;
          best = query;
        }
      }

      bool qans = investigate( best );
      variante.erase( std::remove_if( variante.begin(), variante.end(), [&]( int ans ) -> bool {
        return good( ans, best, entry ) != qans;
      }), variante.end() );
    }

    return variante.front();
  }

  void solve( int n, int m, int start, const std::vector<std::vector<bool>>& blocked ) {
    for( int i = 0; i < n; i++ )
      goDeeper( start = get_next( blocked[i], start ) );
  }
}

void solve( int n, int m, int k, const std::vector<std::vector<bool>>& blocked ) {
  return __Sol__::solve( n, m, k, blocked );
}

