//#include "self_desc.h"

// void init(int N, int Q, const std::vector<int>& a);
// long long query(int l, int r);

#include <vector>
#include <algorithm>
#include <map>
#include <cassert>

//#include <iostream>

namespace __Sol__ {
  using ll = long long;
  template<class T> using vec = std::vector<T>;

  // problem --> fenwick doesnt work
  // AINT2D dinamic????
  // O(Nlog2N) memorie ---- 1G -- nope
  // aici baieti cred ca se baga MO
  // sqrt(500k) * 800k -- REALLY slow

  // ce penala era asta offline

  // AINT(AIB) -- ai nevoie doar de prefixle la una dintre dimensiuni
  // ca de obicei o belesti ca nu ai memorie!!!!!!

  // cea mai mare structureala din viata mea hands down
  // --- baleere -> tii cate de deasupra ta sunt bune
  // --- range +/-, cu conditia ca - mereu da - la un + de dinainte
  // asta inseamna ca toate lazy-urile sunt pozitive si au semnificatia
  // de dezactivari --> pentru un nod cand dai push cu lazy-ul din parinte
  // lazy(delta, de cate ori ai adaugat inca o linie noua si ai avut min=0 in nod)
  // ar trebuii sa poti sa reconstruiesti totul
  // doamne ajuta
  // macar sa mearga pe subtask-ul offline gen

  struct Node {
    int min, cntmin;
    int delta, good_jumps;
    ll good_up;

    Node(): min(0), cntmin(1), delta(0), good_jumps(0), good_up(0) {}

    //inline __attribute__((always_inline))
    void add_delta( int __delta ) {
      min += __delta;
      delta += __delta;
    }

    //inline __attribute__((always_inline))
    void add_jumps( int minval, int jumps ) {
      if( min != minval )
        return;

      good_jumps += jumps;
      good_up += jumps * (ll)cntmin;
    }

    void push( Node &left, Node &right ) {
      if( delta ){
        left.add_delta( delta );
        right.add_delta( delta );
        delta = 0;
      }

      if( good_jumps ){
        left.add_jumps( min, good_jumps );
        right.add_jumps( min, good_jumps );
        good_jumps = 0;
      }
    }

    void pull( const Node &left, const Node &right ) {
      assert( delta == 0 );
      assert( good_jumps == 0 );

      // basically wtf
      min = std::min( left.min, right.min );
      cntmin = 0;
      if( left.min == min ) cntmin += left.cntmin;
      if( right.min == min ) cntmin += right.cntmin;

      good_up = left.good_up + right.good_up;
    }
  };

  struct AINT {
    vec<Node> aint;
    int aintn;

    AINT( int n ) {
      aintn = 1;
      while( aintn < n )
        aintn <<= 1;

      aint.assign( 2 * aintn, Node() );
      for( int i = aintn - 1; i--; )
        aint[i].pull( aint[i * 2 + 1], aint[i * 2 + 2] );
    }

    template<class CB> void walk( int qst, int qdr, CB &&cb ) {
      // printf( "qst = %d, qdr = %d\n", qst, qdr );
      // assert( qst <= qdr );
      // assert( 0 <= qst && qst < aintn );
      // assert( 0 <= qdr && qdr < aintn );
      walk( 0, 0, aintn - 1, qst, qdr, cb );
    }

    template<class CB> void walk( int root, int rl, int rr, int qst, int qdr, CB &&cb ) {
      int mij = (rl + rr) >> 1;

      if( qst == rl && qdr == rr ){
        cb( root, rl, rr );
        return;
      }

      aint[root].push( aint[root * 2 + 1], aint[root * 2 + 2] );

      if( qdr <= mij ){
        walk( root * 2 + 1, rl, mij, qst, qdr, cb );
      }else if( qst > mij ){
        walk( root * 2 + 2, mij+1, rr, qst, qdr, cb );
      }else{
        walk( root * 2 + 1, rl, mij, qst, mij, cb );
        walk( root * 2 + 2, mij+1, rr, mij+1, qdr, cb );
      }

      aint[root].pull( aint[root * 2 + 1], aint[root * 2 + 2] );
    }

    ll query( int st, int dr ) {
      ll ret = 0;
      walk( st, dr, [&]( int root, int rl, int rr ) -> void {
        ret += aint[root].good_up;
      });

      return ret;
    }

    void jump( int st, int dr ) {
      walk( st, dr, [&]( int root, int rl, int rr ) -> void {
        aint[root].add_jumps( 0, +1 );
      });
    }

    void add_range( int st, int dr, int delta ) {
      walk( st, dr, [&]( int root, int rl, int rr ) -> void {
        aint[root].add_delta( delta );
      });
    }
  };

  struct Rect {
    int x1, x2, y1, y2;
    Rect( int a, int b, int c, int d ): x1(a), x2(b), y1(c), y2(d) {}
  };

  vec<Rect> get_rect( int n, int q, const vec<int> &v ) {
    vec<vec<int>> poz(n + 1);

    for( int val = 1; val <= n; val++ )
      poz[val].push_back( -1 );
    for( int i = 0; i < n; i++ )
      poz[v[i]].push_back( i );
    for( int val = 1; val <= n; val++ )
      poz[val].push_back( n );

    // add +1 to all rectangles that make you angry
    vec<Rect> ret;
    for( int val = 1; val <= n; val++ ){ // because yeah
      if( poz[val].empty() ) continue;

      // firstly, ranges that don't contain you are all good
      // now ranges that contain the right ammount of appearances of you

      if( val >= 2 ){ // [1, val - 1]
        for( int i = 1; i < (int)poz[val].size() - 1; i++ ){
          int last = n;
          if( i + val - 1 < (int)poz[val].size() )
            last = poz[val][i + val - 1];

          ret.emplace_back( poz[val][i - 1] + 1, poz[val][i], poz[val][i], last - 1 );
        }
      }

      { // [val+1, ..]
        for( int i = 1; i + val < (int)poz[val].size() - 1; i++ )
          ret.emplace_back( poz[val][i - 1] + 1, poz[val][i], poz[val][i + val], n - 1 );
      }
    }

    return ret;
  }

  struct Event {
    int x, y1, y2, delta;
  };

  ll ret = 0;
  void init( int n, int q, const vec<int> &v ) {
    vec<Rect> rect = get_rect( n, q, v );

    if( false ){
      vec<vec<bool>> mat(n, vec<bool>(n, true));
      for( auto [x1, x2, y1, y2]: rect )
        for( int x = x1; x <= x2; x++ )
          for( int y = y1; y <= y2; y++ )
            mat[x][y] = false;

      // for( int st = 0; st < n; st++ ){
      //   for( int dr = 0; dr < n; dr++ )
      //     printf( "%d ", int(mat[st][dr]) );
      //   printf( "\n" );
      // }


      ret = 0;
      for( int st = 0; st < n; st++ )
        for( int dr = st; dr < n; dr++ )
          ret += mat[st][dr];

      return;
    }

    vec<Event> evt;
    for( auto [x1, x2, y1, y2]: rect ){
      evt.push_back({ x1,     y1, y2, +1 });
      evt.push_back({ x2 + 1, y1, y2, -1 });
    }

    std::sort( evt.begin(), evt.end(), []( const Event &a, const Event &b ) -> bool {
      return a.x < b.x;
    } );

    AINT zile(n);

    int eidx = 0;
    for( int time = 0; time <= n; time++ ){
      if( time == n )
        ret += zile.query( 0, n - 1 );

      while( eidx < (int)evt.size() && evt[eidx].x <= time ){
        auto [_, y1, y2, delta] = evt[eidx];
        zile.add_range( y1, y2, delta );
        eidx++;
      }

      zile.jump( 0, n - 1 );
    }

    // printf( "ret = %lld bad ranges \n", ret );
    // printf( "actually %lld good ranges \n", ret - (n * (ll)(n - 1) / 2) );

    ret -= (n * (ll)(n - 1) / 2);
  }

  ll query( int st, int dr ) {
    return ret; // [0, n - 1] subtask
  }
}

void init(int N, int Q, const std::vector<int>& a) { __Sol__::init( N, Q, a ); }
long long query(int l, int r) { return __Sol__::query( l, r ); }

// Lgrader.cpp
#ifndef EVAL
#include<iostream>
#include<vector>

int main(){
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr); std::cout.tie(nullptr);
  int n, q; std::cin >> n >> q;
  std::vector<int> input(n);
  for(int i = 0; i < n; i ++){
    std::cin >> input[i];
  }
  init(n, q, input);
  for(int i = 0; i < q; i ++){
    int l, r;
    std::cin >> l >> r;
    std::cout << query(l, r) << " ";
  }
  std::cout << std::endl;
}
#endif
