#include <bits/stdc++.h>

#include "tunnels.h"

using namespace std;

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const int MAX_N = 5000 + 2;
const int INF = 1e9 + 2;
bool possibleExits[MAX_N];

int NN, MM;

int clearDir(int x, int y, const vector<vector<bool>>& blocked, int dX,
             vector<int>& saving) {
    x += dX;
    int cnt = 0;
    bool isOk = true;
    while (x >= 0 && x < MM) {
        if (!isOk) {
            possibleExits[x] = false;
        } else if (blocked[y][x]) {
            isOk = false;
            possibleExits[x] = false;
        } else if (y < NN - 1 && blocked[y + 1][x]) {
            possibleExits[x] = false;
        } else {
            possibleExits[x] = true;
            cnt++;
            saving.push_back(x);
        }
        x += dX;
    }
    return cnt;
}
int findDir(int x, int y, int dx) {
    x += dx;
    while (x >= 0 && x < MM) {
        if (possibleExits[x]) return x;
        x += dx;
    }
    return -1;
}

int binary(const vector<int>& v) {
    int l = 1, r = v.size() - 1, mid, ans = 0;
    while (l <= r) {
        mid = (l + r) / 2;

        if (investigate(v[mid])) {
            ans = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }

    return v[ans];
}

void solve(int N, int M, int k, const vector<vector<bool>>& blocked) {
    NN = N;
    MM = M;

    int currentX = k, currentY = 0;
    while (currentY <= NN) {
        vector<int> lefties, righties;
        int leftPossible = clearDir(currentX, currentY, blocked, -1, lefties);
        int rightPossible = clearDir(currentX, currentY, blocked, 1, righties);

        if (leftPossible == 0 && rightPossible == 0) {
            goDeeper(currentX);
            currentY++;
            continue;
        }
        if (leftPossible > 0) {
            int leftX = findDir(currentX, currentY, -1);
            if ((rightPossible == 0 && currentY < N - 1 &&
                 blocked[currentY + 1][currentX]) ||
                investigate(leftX)) {  // we're going left
                currentX = binary(lefties);
            } else {
                if (rightPossible > 0) {
                    int rightX = findDir(currentX, currentY, 1);
                    if ((leftPossible == 0 && currentY < N - 1 &&
                         blocked[currentY + 1][currentX]) ||
                        investigate(rightX)) {  // we're going right
                        currentX = binary(righties);
                    }
                }
            }
        } else if (rightPossible > 0) {
            int rightX = findDir(currentX, currentY, 1);
            if ((currentY < N - 1 && blocked[currentY + 1][currentX]) ||
                investigate(rightX)) {  // we're going right
                currentX = binary(righties);
            }
        }
        goDeeper(currentX);
        currentY++;
        continue;
    }
}