#include <bits/stdc++.h>

#include "tunnels.h"

using namespace std;

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const int MAX_N = 5000 + 2;
const int INF = 1e9 + 2;

int NN, MM;

void getPositions(int x, int y, int dx, const vector<vector<bool>>& blocked, vector<int>& v) {
    while (x >= 0 && x < MM) {
        if (blocked[y][x]) break;
        if (y < NN - 1 && blocked[y + 1][x]) {
            x += dx;
            continue;
        }
        v.push_back(x);
        x += dx;
    }
}

void solve(int N, int M, int k, const vector<vector<bool>>& blocked) {
    NN = N;
    MM = M;

    int currentX = k, currentY = 0;
    while (currentY < NN) {
        vector<int> pos;
        getPositions(currentX, currentY, -1, blocked, pos);
        getPositions(currentX + 1, currentY, 1, blocked, pos);
        sort(pos.begin(), pos.end());

        if (pos.size() == 1) {
            currentX = pos[0];
            currentY++;
            goDeeper(currentX);
            continue;
        }

        int posCurrent = 0;
        for (int i = 0; i < pos.size(); i++) {
            if (pos[i] == currentX) {
                posCurrent = i;
                break;
            }
        }

        int l = 0, r = pos.size() - 1, mid, ans = currentX;

        while (l <= r) {
            mid = (l + r) / 2;
            if (l == r) break;
            if (pos[mid] == currentX) {
                if ((l + r) % 2 == 0) {
                    mid--;
                    if (mid < l) mid = posCurrent + 1;
                    if (mid > r) {
                        break;
                    }
                } else {
                    mid++;
                    if (mid > r) mid = posCurrent - 1;
                    if (mid < l) break;
                }
            }
            if (investigate(pos[mid])) {
                ans = pos[mid];
                if (currentX < pos[mid]) {
                    l = mid + 1;
                } else {
                    r = mid - 1;
                }
            } else {
                if (currentX < pos[mid]) {
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
            }
        }

        currentX = ans;
        currentY++;
        goDeeper(currentX);
    }
}