# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;
# include "bits_and_tree.h"
//# include "Lgrader.cpp"

const int MAX=211;
const int D=50;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int,int>> edges;
    vector<int> red;
    int last=data[0],br=0;
    for(int i=0;i<min((int)data.size()-1,D);i++)
    {
        if(data[i]==last) br++;
        else
        {
            red.push_back(br);
            br=1;
            last=data[i];
        }
    }
    if(br>0)
    {
        red.push_back(br);
    }
    if(data[0]) red[0]++;


    int ct=0;
    vector<int> diam;
    for(int i=0;i<(int)red.size();i++)
    {
        if((int)diam.size()!=0) edges.push_back({diam.back(),++ct});
        diam.push_back(ct);

        for(int t=1;t<=red[i]*2;t++) edges.push_back({diam.back(),++ct});
    }

    int p1=++ct,p2=++ct;
    edges.push_back({p1,p2});
    edges.push_back({p2,diam[0]});
    last=diam.back();
    while(edges.size()<n-1)
    {
        edges.push_back({last,++ct});
        last=ct;
    }

    //cout<<ct<<"->"<<edges.size()<<"\n";
    return edges;

}

vector<int> adj[MAX];
bool on_diam[MAX];

void reset(int n)
{
    for(int i=0;i<=n;i++)
    {
        adj[i].clear();
        on_diam[i]=0;
    }
}

int dist[MAX];
int from[MAX];

///! par=-1

void reset_dist(int n)
{
    for(int i=0;i<=n;i++)
    {
        from[i]=-1;
        dist[i]=0;
    }
}

void dfs_dist(int curr, int par)
{
    for(int nxt: adj[curr])
    {
        if(nxt==par) continue;

        dist[nxt]=dist[curr]+1;
        from[nxt]=curr;
        dfs_dist(nxt,curr);
    }
}

vector<int> find_diam(int n)
{
    reset_dist(n);
    dfs_dist(0,-1);

    int u=0;
    for(int i=0;i<=n;i++) if(dist[i]>dist[u]) u=i;

    reset_dist(n);
    dfs_dist(u,-1);
    int v=0;
    for(int i=0;i<=n;i++) if(dist[i]>dist[v]) v=i;

    vector<int> ve;
    int curr=v;
    while(curr!=-1)
    {
        ve.push_back(curr);
        curr=from[curr];
    }
    reverse(ve.begin(),ve.end());
    return ve;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    reset(n);
    for(pair<int,int> pa:tree)
    {
        int u=pa.first,v=pa.second;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    vector<int> diam=find_diam(n);
    for(int u: diam) on_diam[u]=1;

    vector<int> red;
    for(int u: diam)
    {
        int c=0;
        for(int nxt: adj[u])
        {
            if(!on_diam[nxt]) c++;
        }
        red.push_back(c/2);
    }

    int cntb=0,cnte=0;
    for(int i=0;i<(int)red.size();i++)
    {
        if(red[i]==0) cntb++;
        else break;
    }
    for(int i=(int)red.size()-1;i>=0;i--)
    {
        if(red[i]==0) cnte++;
        else break;
    }
    if(cnte>cntb) reverse(red.begin(),red.end());

    vector<int> real_red;
    for(int i=0;i<(int)red.size();i++)
    {
        if(red[i]==0) continue;
        while(i<(int)red.size() and red[i]!=0)
        {
            real_red.push_back(red[i]);
            i++;
        }
        break;
    }

    //cout<<real_red.size()<<"\n";
    //for(int x: real_red) cout<<x<<" ";
    //cout<<"\n";

    int cnt=0;
    int last=1;
    for(int i=0;i<(int)real_red.size();i++) cnt+=real_red[i];
    if(cnt!=n)
    {
        real_red[real_red.size()-1]--;
        last=0;
    }

    vector<bool> fin;
    for(int x: real_red)
    {
        last^=1;
        for(int t=1;t<=x;t++) fin.push_back(last);
    }

    return fin;
}

