# include <iostream>
# include <vector>
# include <algorithm>
# include <cmath>
# include <deque>
# include <set>
# include <cassert>
using namespace std;

const int INF=1e9;
const int MAXA=1e6+11;
const int MAX=3e5+11;

int _N,m;
int A[MAX];
deque<int> pos[MAX];
vector<pair<int,int>> res;

vector<int> tree[MAXA*4];

void build(int v=1, int l=0, int r=m-1)
{
    tree[v].reserve(r-l+1);
    if(l==r)
    {
        tree[v].push_back(res[l].second);
        return ;
    }

    int mid=(l+r)/2;
    build(v*2,l,mid);
    build(v*2+1,mid+1,r);
    for(int i=l;i<=r;i++) tree[v].push_back(res[i].second);
    sort(tree[v].begin(),tree[v].end());
}

int solve(int le, int ri, int x, int v=1, int l=0, int r=m-1)
{
    if(r<le or ri<l) return 0;
    if(le<=l and r<=ri) return upper_bound(tree[v].begin(),tree[v].end(),x)-tree[v].begin();

    int mid=(l+r)/2;
    return solve(le,ri,x,v*2,l,mid)+solve(le,ri,x,v*2+1,mid+1,r);
}

void init(int N, int Q, const std::vector<int>& a)
{
    _N=N;
    for(int i=1;i<=N;i++)
    {
        A[i]=a[i-1];
        pos[A[i]].push_back(i);
    }

    int sz=N;
    int S=(int)sqrt(sz)*2+1;

    set<pair<int,int>> s;
    for(int i=1;i<=_N;i++)
    {
        if((int)pos[i].size()>0) s.insert({pos[i][0],i});
    }

    int ans=0;
    for(int i=1;i<=N;i++)
    {
        auto it=s.begin();
        int cnt=0,mx=0;
        for(int t=1;t<=S;t++)
        {
            if(it==s.end()) break;
            pair<int,int> pa=*it;

            if((int)pos[pa.second].size()<pa.second) break;
            int P=pos[pa.second][pa.second-1];
            mx=max(mx,P);
            cnt+=pa.second;

            //cout<<"->"<<i<<" "<<cnt<<" "<<mx<<"\n";

            if(cnt==mx-i+1)
            {
                res.push_back({i,mx});
                ans++;
                //cout<<i<<" "<<cnt<<" "<<mx<<"\n";
            }

            it++;
        }

        s.erase({i,A[i]});
        pos[A[i]].pop_front();
        if((int)pos[A[i]].size()>0) s.insert({pos[A[i]][0],A[i]});

        //cout<<i<<"->"<<ans<<"\n";
    }

    if(ans>1e6) assert(0);
    m=ans;
    build();
}

int cnt[MAX];

long long query(int l, int r)
{
    l++;r++;

    pair<int,int> P1={l,-INF},P2={r,INF};

    int L=lower_bound(res.begin(),res.end(),P1)-res.begin();
    int R=upper_bound(res.begin(),res.end(),P2)-res.begin()-1;
    if(L>R) return 0;
    return solve(L,R,r);
}

