#include "tunnels.h"
#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

const int MAXN = 5e3 + 10;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    if(m != 2)
    {
        int from = -1;
        int cur = k;

        int level = 0;

        while(level < n)
        {
            if(1 <= cur && from != cur - 1 && investigate(cur - 1))
            {
                cur = cur - 1;
                from = cur + 1;
                continue;
            }

            if(cur <= m - 2 && from != cur + 1 && investigate(cur + 1))
            {
                cur = cur + 1;
                from = cur - 1;
                continue;
            }

            from = -1;
            goDeeper(cur);
            level++;
        }

        return;

        int from = -1;
        int cur = k;

        for(int level = 0; level < n; level++)
        {
            int toleft = cur;
            int toright = m - 1 - cur;

            int left, right, mid;

            left = cur;
            right = m;

            while(right - left > 1)
            {
                mid = left + (right - left) / 2;

                if(investigate(mid))
                    left = mid;
                else
                {
                    right = mid;
                }
            }

            if(left != cur)
            {
                cur = left;
                goDeeper(cur);
                continue;
            }
            
            left = -1;
            right = cur;

            while(right - left > 1)
            {
                mid = left + (right - left) / 2;

                if(investigate(mid))
                    right = mid;
                else
                {
                    left = mid;
                }
                
            }

            if(right != cur)
            {
                cur = right;
                goDeeper(cur);
                continue;
            }

            
            goDeeper(cur);
        }

        return;
    }
        

    int cur = k;

    for(int level = 0; level < n; level++)
    {
        //cout << "Currently on level : " << level << " in chamber " << cur << endl;
        if(blocked[level][!cur])
        {
            goDeeper(cur);
            continue;
        }

        if(level == n - 1)
        {
            if(investigate(!cur))
                goDeeper(!cur);
            else
                goDeeper(cur);
                
            continue;
        }
        
        if(blocked[level + 1][cur])
        {
            cur = !cur;
            goDeeper(cur);
            continue;
        }

        if(blocked[level + 1][!cur])
        {
            goDeeper(cur);
            continue;
        }

        if(investigate(!cur))
        {
            cur = !cur;
            goDeeper(cur);
            continue;
        }
        else
        {
            goDeeper(cur);
            continue;
        }
    }
}