#include "bits_and_tree.h"
#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector < pair < int, int > > edges;

    if(data[0] == 1)
    {
        for(int i = 1; i < n; i++)
        {
            edges.push_back({0, i});
        }
    }
    else
    {
        for(int i = 1; i < n; i++)
        {
            edges.push_back({i - 1, i});
        }
    }

    return edges;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> edges)
{
    vector < int > deg(n + 1, 0);

    for(pair < int, int > e : edges)
    {
        int u = e.first;
        int v = e.second;

        deg[u]++;
        deg[v]++;
    }

    int maxdeg = 0;

    for(int i = 0; i <= n; i++)
    {
        maxdeg = max(maxdeg, deg[i]);
    }

    if(maxdeg >= n - 1)
        return {1};
    
    return {0};
}