#include "bits_and_tree.h"
#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

std::vector<std::pair<int, int>> encode(int _n, std::vector<bool> data)
{
    vector < pair < int, int > > edges;

    int val = 0;

    for(int i = 0; i < data.size(); i++)
    {
        if(2 * (val + data[i] * (1 << i)) > _n)
            break;

        val += data[i] * (1 << i);
    }

    //cout << "Value : " << val << endl;

    int needs = (val + 1) * 2;

    for(int i = 1; i <= needs; i++)
    {
        edges.push_back({0, i});
    }

    for(int i = needs + 1; i < _n; i++)
    {
        edges.push_back({i - 1, i});
    }

    return edges;
}

std::vector<bool> decode(int _n, std::vector<std::pair<int, int>> edges)
{
    vector < int > deg(_n + 1, 0);

    for(pair < int, int > e : edges)
    {
        int u = e.first;
        int v = e.second;

        deg[u]++;
        deg[v]++;
    }

    int maxdeg = 0;

    for(int i = 0; i <= _n; i++)
    {
        maxdeg = max(maxdeg, deg[i]);
    }

    int val = (maxdeg - 2) / 2;

    //cout << "Found value : " << val << endl;

    vector < bool > ans;

    for(int i = 0; i < 2 * _n; i++)
    {
        ans.push_back((bool)(val & (1 << i)));
    }

    return ans;
}