#include <bits/stdc++.h>
#include "bits_and_tree.h"

using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    int bits = 0;
    int _n = n;

    while (_n)
    {
        bits++;
        _n /= 2;
    }

    vector < pair <int, int> > ret;

    for (int i = 0; i < data.size(); i++)
    {
        int u = 0;
        int curr = bits - 1;

        for (int q = i; q <= i + bits - 1; q++)
        {
            if (data[q])
            {
                u += (1 << curr);
            }

            curr--;
        }

        int v = 0;

        curr = bits - 1;

        for (int q = i + bits; q <= i + bits + bits - 1; q++)
        {
            if (data[q])
            {
                v += (1 << curr);
            }
        }

        ret.push_back({u, v});
    }

    while (ret.size() < n - 1)
    {
        ret.push_back({rand() % n, rand() % n});
    }

    return ret;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    int bits = 0;
    int _n = n;

    while (_n)
    {
        bits++;
        _n /= 2;
    }

    vector <bool> ret;

    for (int i = 0; i < tree.size(); i++)
    {
        int u = tree[i].first, v = tree[i].second;

        for (int q = bits - 1; q >= 0; q--)
        {
            if (u & (1 << q))
            {
                ret.push_back(1);
            }
            else
            {
                ret.push_back(0);
            }
        }

        for (int q = bits - 1; q >= 0; q--)
        {
            if (v & (1 << q))
            {
                ret.push_back(1);
            }
            else
            {
                ret.push_back(0);
            }
        }
    }

    return ret;
}