#include "tunnels.h"

#include <iostream>

static int n, m, k;
static std::vector<std::vector<bool>> blocked;
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    int level = 0, tek = k;
    while(level < n){
        int l = -1, r = -1;
        for(int i = tek; i < m; i ++){
            if(blocked[level][i]){
                r = i - 1;
                break;
            }
        }
        for(int i = tek; i >= 0; i --){
            if(blocked[level][i]){
                l = i + 1;
                break;
            }
        }
        if(l == -1){
            l = 0;
        }
        if(r == -1){
            r = m - 1;
        }
        if(level <= n - 2){
            while(blocked[level + 1][l]){
                l ++;
            }
            while(blocked[level + 1][r]){
                r --;
            }
        }
        std :: cout << l << " " << r << std :: endl;
        if(r - l == 0){
            goDeeper(tek);
            level++;
            tek = tek;
            continue;
        }
        int dvL, dvR;
        if(tek < m - 1 && blocked[level][tek + 1] == false){
            dvL = tek;
            dvR = r;
            int s = tek + 1;
            int f = investigate(s);
            if(f){
                if(dvR == s ? f : investigate(dvR)){
                    goDeeper(dvR);
                    level++;
                    tek = dvR;
                    continue;
                }
                while(dvL < dvR - 1){
                    int m1 = (dvL + dvR)/2;
                    if(investigate(m1)){
                        dvL = m1;
                    }else{
                        dvR = m1;
                    }
                }
                goDeeper(dvL);
                level++;
                tek = dvL;
                continue;
            }
        }else{
            if(tek >= 1 && blocked[level][tek - 1] == false){
                dvR = tek;
                dvL = l;
                if(investigate(dvL)){
                    goDeeper(dvL);
                    level++;
                    tek = dvL;
                    continue;
                }
                while(dvL < dvR - 1){
                    int m1 = (dvL + dvR)/2;
                    if(investigate(m1)){
                        dvR = m1;
                    }else{
                        dvL = m1;
                    }
                }
                goDeeper(dvR);
                level++;
                tek = dvR;
                continue;
            }
            goDeeper(tek);
            level++;
            tek = tek;
            continue;

        }

    }

}
static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
