#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 205;

vector<int> g[maxn];

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }

    int root = 0;
    int cnt = 0;

    g[root].push_back(++cnt);
    g[root].push_back(++cnt);
    g[root].push_back(++cnt);
    g[root].push_back(++cnt);

    bool isOne = false;

    for (int i = 0; i < min(2 * n, 40); ++i)
    {
        int child0 = cnt + 1;
        int child1 = cnt + 2;

        g[root].push_back(child0);
        g[root].push_back(child1);
        if (isOne) g[root].push_back(++cnt);

        if (data[i] == '0')
        {
            root = child0;
            isOne = false;
        }
        else
        {
            isOne = true;
            root = child1;
        }
    }

    vector<pair<int, int>> edges;

    for (int i = 0; i < n; ++i)
    {
        for (auto to : g[i])
        {
            edges.push_back({i, to});
        }
    }

    return edges;
}

vector<int> newG[maxn];
int deg[maxn];

vector<bool> v;

void dfs(int node)
{
    //cout << "on " << node << endl;
    int maxDeg = 0;

    for (auto to : newG[node])
    {
        maxDeg = max(maxDeg, deg[to]);
    }

    if (maxDeg >= 4)
    {
        v.push_back(true);
    }
    else
    {
        v.push_back(true);
    }

    for (auto to : newG[node])
    {
        if (deg[to] == maxDeg) dfs(to);
    }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    for (int i = 0; i <= n; ++i)
    {
        newG[i].clear();
        deg[i] = 0;
    }

    int root = -1;

    for (auto [x, y] : tree)
    {
        newG[x].push_back(y);
        newG[y].push_back(x);
        ++deg[x];
        ++deg[y];
    }

    for (int i = 0; i <= n; ++i)
    {
        if (deg[i] > 5)
        {
            root = i;
            break;
        }
    }

    dfs(root);
    while (v.size() < 2 * n) v.push_back(false);

    return v;
}
