#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 205;

vector<int> g[maxn];

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int, int>> edges;

    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }

    int cnt = 0;
    int root = 0;

    for (int i = 0; i < 20; ++i)
    {
        if (data[i] == 0)
        {
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);

            if (i == 0)
            {
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
            }
        }
        else
        {
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);
            g[root].push_back(++cnt);

            if (i == 0)
            {
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
                g[root].push_back(++cnt);
            }
        }

        root = cnt;
    }

    while (true)
    {
        ++cnt;
        if (cnt == 200) break;
        g[cnt - 1].push_back(cnt);
    }

    for (int i = 0; i < 200; ++i)
    {
        for (auto to : g[i])
        {
            edges.push_back({i, to});
        }
    }

    return edges;
}

vector<int> newG[maxn];
int deg[maxn];
bool visited[maxn];
vector<bool> v;

void dfs(int node, int par)
{
    //cout << node << " " << deg[node] << endl;
    visited[node] = true;

    if (par == -1)
    {
        if (deg[node] >= 15) v.push_back(0);
        else v.push_back(1);
    }
    else
    {
        if (deg[node] >= 8)
        {
            v.push_back(0);
        }
        else
        {
            v.push_back(1);
        }
    }

    int maxDeg = 0;

    for (auto to : newG[node])
    {
        if (!visited[to]) maxDeg = max(maxDeg, deg[to]);
    }

    for (auto to : newG[node])
    {
        if (!visited[to] && deg[to] == maxDeg)
        {
            dfs(to, node);
            break;
        }
    }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    v.clear();

    for (int i = 0; i <= n; ++i)
    {
        newG[i].clear();
        deg[i] = 0;
        visited[i] = false;
    }

    int root = -1;

    for (auto [x, y] : tree)
    {
        newG[x].push_back(y);
        newG[y].push_back(x);
        ++deg[x];
        ++deg[y];
    }

    int curr = *max_element(deg, deg + n + 1);

    for (int i = 0; i <= n; ++i)
    {
        if (curr == deg[i])
        {
            root = i;
            break;
        }
    }

    dfs(root, -1);

    //cout << "NOW " <<endl;
    //for (auto x : v) cout << x;
    //cout << endl;

    while (v.size() < 2 * n) v.push_back(false);

    return v;
}
