#include <bits/stdc++.h>

using namespace std;

const int maxn = 300005;
const int inf = 1e9 + 7;
const int BLOCK_SIZE = 500;

int n, q;
int a[maxn];

vector<int> positions[maxn];
int cntOcc[maxn];
int whichOcc[maxn];
bool added[maxn];

int whichBlock(int pos)
{
    return (pos - 1) / BLOCK_SIZE + 1;
}

struct BLOCK
{
    int l, r, id;
    int ans = 0;
    unordered_map<int, int> cnt;

    void init(int idx)
    {
        id = idx;
        l = (id - 1) * BLOCK_SIZE + 1;
        r = min(n, id * BLOCK_SIZE);

        for (int j = l; j <= r; ++j)
        {
            ++cnt[a[j]];
        }
    }

    void solveForBlock()
    {
        for (int i = l; i <= r; ++i)
        {
            for (int j = i; j <= r; ++j)
            {
                cntOcc[a[j]] = 0;
                added[a[j]] = false;
            }

            int bad = 0;
            int expectedSum = 0;

            for (int j = i; j <= r; ++j)
            {
                ++cntOcc[a[j]];

                if (!added[a[j]])
                {
                    added[a[j]] = true;
                    ++bad;
                    expectedSum += a[j];
                }

                if (expectedSum > r - i + 1) break;
                if (cntOcc[a[j]] > a[j]) break;

                if (cntOcc[a[j]] == a[j])
                {
                    --bad;
                    if (bad == 0) ++ans;
                }
            }
        }
    }
};

int cntBuckets;
BLOCK buckets[maxn / BLOCK_SIZE];

void init(int N, int Q, const std::vector<int>& arr)
{
    n = N;
    q = Q;
    cntBuckets = (n - 1) / BLOCK_SIZE + 1;

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = arr[i];
    }

    for (int i = 1; i <= cntBuckets; ++i)
    {
        buckets[i].init(i);
        buckets[i].solveForBlock();
    }
}

long long query(int l, int r)
{
    ++l;
    ++r;

    long long ans = 0;

    for (int i = 1; i <= cntBuckets; ++i)
    {
        ans += buckets[i].ans;
        //cout << "BLOCK " << i << " -> " << buckets[i].ans << endl;
    }

    for (int i = 1; i <= cntBuckets; ++i)
    {
        unordered_map<int, int> between;
        int badBetween = 0;

        for (int j = i + 1; j <= cntBuckets; ++j)
        {
            int posI = buckets[i].l;

            for (int k = buckets[i].r; k >= buckets[i].r; --k)
            {
                if (between.find(a[k]) != between.end() && between[a[k]] == a[k])
                {
                    posI = k + 1;
                    break;
                }
            }

            int posJ = buckets[j].r;

            for (int k = buckets[j].l; k <= buckets[j].r; ++k)
            {
                if (between.find(a[k]) != between.end() && between[a[k]] == a[k])
                {
                    posJ = k - 1;
                    break;
                }
            }

            /*cout << "NOW " << i << " " << j << " :: " << posI << " " << posJ << endl;
            for (auto [element, c] : between)
            {
                cout << "BETWEEN " << element << " " << c << endl;
            }*/

            unordered_map<int, int> cntBetweenAdd;
            unordered_map<int, int> newElements;
            int bad = badBetween;

            for (int k = buckets[i].r; k >= posI; --k)
            {
                if (between.find(a[k]) != between.end())
                {
                    ++cntBetweenAdd[a[k]];
                    if (cntBetweenAdd[a[k]] + between[a[k]] == a[k]) --bad;
                    if (between[a[k]] + cntBetweenAdd[a[k]] > a[k]) break;
                }
                else
                {
                    ++newElements[a[k]];
                    if (newElements[a[k]] == 1) ++bad;
                    if (newElements[a[k]] == a[k]) --bad;
                    if (newElements[a[k]] > a[k]) break;
                }

                //cout << "on " << k << " " << bad << endl;

                unordered_map<int, int> cntBetweenAdd2 = cntBetweenAdd;
                unordered_map<int, int> newElements2 = newElements;
                int bad2 = bad;

                for (int h = buckets[j].l; h <= posJ; ++h)
                {
                    if (between.find(a[h]) != between.end())
                    {
                        ++cntBetweenAdd2[a[h]];
                        if (cntBetweenAdd2[a[h]] + between[a[h]] == a[h]) --bad2;
                        if (between[a[h]] + cntBetweenAdd2[a[h]] > a[h]) break;
                    }
                    else
                    {
                        ++newElements2[a[h]];
                        if (newElements2[a[h]] == 1) ++bad2;
                        if (newElements2[a[h]] == a[h]) --bad2;
                        if (newElements2[a[h]] > a[h]) break;
                    }

                    //cout << "now " << h << " " << bad2 << endl;

                    if (bad2 == 0)
                    {
                        //cout << "ADD " << k << " " << h << endl;
                        ++ans;
                    }
                }
            }

            for (int k = buckets[j].l; k <= buckets[j].r; ++k)
            {
                ++between[a[k]];
                if (between[a[k]] == 1) ++badBetween;
                if (between[a[k]] == a[k]) --badBetween;
                if (between[a[k]] > a[k]) break;
            }
        }
    }

    return ans;
}

int main()
{
    std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;

    return 0;
}
