#include <bits/stdc++.h>

using namespace std;

const int maxn = 300005;
const int inf = 1e9 + 7;
const int BLOCK_SIZE = 300;

int n, q;
int a[maxn];

vector<int> positions[maxn];
int cntOcc[maxn];
int whichOcc[maxn];
bool added[maxn];

int whichBlock(int pos)
{
    return (pos - 1) / BLOCK_SIZE + 1;
}

struct BLOCK
{
    int l, r, id;
    int ans = 0;
    unordered_map<int, int> cnt;

    void init(int idx)
    {
        id = idx;
        l = (id - 1) * BLOCK_SIZE + 1;
        r = min(n, id * BLOCK_SIZE);

        for (int j = l; j <= r; ++j)
        {
            ++cnt[a[j]];
        }
    }

    void solveForBlock()
    {
        for (int i = l; i <= r; ++i)
        {
            for (int j = i; j <= r; ++j)
            {
                cntOcc[a[j]] = 0;
                added[a[j]] = false;
            }

            int bad = 0;
            int expectedSum = 0;

            for (int j = i; j <= r; ++j)
            {
                ++cntOcc[a[j]];

                if (!added[a[j]])
                {
                    added[a[j]] = true;
                    ++bad;
                    expectedSum += a[j];
                }

                if (expectedSum > r - i + 1) break;
                if (cntOcc[a[j]] > a[j]) break;

                if (cntOcc[a[j]] == a[j])
                {
                    --bad;
                    if (bad == 0) ++ans;
                }
            }
        }
    }
};

int cntBuckets;
BLOCK buckets[maxn / BLOCK_SIZE + 50];

void init(int N, int Q, const std::vector<int>& arr)
{
    n = N;
    q = Q;
    cntBuckets = (n - 1) / BLOCK_SIZE + 1;

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = arr[i];
    }

    for (int i = 1; i <= cntBuckets; ++i)
    {
        buckets[i].init(i);
        buckets[i].solveForBlock();
    }
}

long long query(int l, int r)
{
    ++l;
    ++r;

    long long ans = 0;

    for (int i = 1; i <= cntBuckets; ++i)
    {
        ans += buckets[i].ans;
        //cout << "BLOCK " << i << " -> " << buckets[i].ans << endl;
    }

    for (int i = 1; i <= cntBuckets; ++i)
    {
        unordered_map<int, int> between;
        int badBetween = 0;

        for (int j = i + 1; j <= cntBuckets; ++j)
        {
            int posI = buckets[i].l;

            for (int k = buckets[i].r; k >= buckets[i].r; --k)
            {
                if (between.find(a[k]) != between.end() && between[a[k]] == a[k])
                {
                    posI = k + 1;
                    break;
                }
            }

            int posJ = buckets[j].r;

            for (int k = buckets[j].l; k <= buckets[j].r; ++k)
            {
                if (between.find(a[k]) != between.end() && between[a[k]] == a[k])
                {
                    posJ = k - 1;
                    break;
                }
            }

            unordered_map<int, int> betweenCopy = between;

            for (int k = buckets[i].r; k >= posI; --k)
            {
                ++betweenCopy[a[k]];
                if (betweenCopy[a[k]] > a[k]) break;

                unordered_map<int, int> betweenCopy2 = betweenCopy;

                for (int h = buckets[j].l; h <= posJ; ++h)
                {
                    ++betweenCopy2[a[h]];
                    if (betweenCopy2[a[h]] > a[h]) break;

                    bool flag = false;

                    for (auto [x, y] : betweenCopy2)
                    {
                        if (x != y)
                        {
                            flag =true;
                            break;
                        }
                    }

                    if (flag) continue;
                    ++ans;
                }
            }

            for (int k = buckets[j].l; k <= buckets[j].r; ++k)
            {
                ++between[a[k]];
                if (between[a[k]] == 1) ++badBetween;
                if (between[a[k]] == a[k]) --badBetween;
                if (between[a[k]] > a[k]) break;
            }
        }
    }

    return ans;
}