#include<bits/stdc++.h>
#include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    /// Make blocks
    //printf("comment 1\n");
    vector<pair<int,int>> blocks[n + 1];
    vector<vector<int>> paths[n + 1];
    vector<bool> visited[n + 1];
    for(int i = 0; i < n; i++) {
        int s = 0;
        for(int j = 0; j < m; j++) {
            if(blocked[i][j]) {
                if(j - 1 >= s) blocks[i].push_back({s, j - 1});
                s = j + 1;
            }
        }
        if(m - 1 >= s) blocks[i].push_back({s, m - 1});
        paths[i].insert(paths[i].begin(),blocks[i].size(),{});
        visited[i].insert(visited[i].begin(),blocks[i].size(),false);
    }
    blocks[n].push_back({0, m - 1});
    visited[n].push_back(false);
    paths[n].push_back({});

    /// Construct paths
    //printf("comment 2\n");
    queue<pair<int,int>> q;
    q.push({n, 0});
    while(!q.empty()) {
        pair<int,int> curr = q.front();
        q.pop();
        //printf("consider %d %d\n",curr.first,curr.second);
        if(curr.first == 0) continue;
        pair<int,int> b_curr = blocks[curr.first][curr.second];
        //printf("got bounds [%d,%d]\n",b_curr.first,b_curr.second);
        bool passed = false;
        for(int i = 0; i < blocks[curr.first - 1].size(); i++) {
            //printf("try %d %d\n", curr.first - 1, i);
            pair<int,int> b_it = blocks[curr.first - 1][i];
            //printf("got bounds [%d,%d]\n",b_it.first,b_it.second);
            if((b_curr.first <= b_it.first && b_it.first <= b_curr.second) ||
               (b_it.first <= b_curr.first && b_curr.first <= b_it.second)) {
                passed = true;
                paths[curr.first - 1][i].push_back(curr.second);
                //printf("add path from (%d,%d) to (%d,%d)\n",curr.first - 1,i,curr.first,curr.second);
                if(!visited[curr.first - 1][i]) q.push({curr.first - 1, i});
                visited[curr.first - 1][i] = true;
                //printf("checked visit\n");
                continue;
               }
            if(passed) break;
        }
    }

    /// Traverse down
    //printf("comment 3\n");
    int curr, entry = k;
    for(int i = 0; i < blocks[0].size(); i++) {
        if(blocks[0][i].first <= k && blocks[0][i].second >= k) {
            curr = i;
            break;
        }
    }
    for(int i = 0; i < n; i++) {
        while(i == n - 1);
        pair<int,int> b_curr = blocks[i][curr];
        paths[i][curr];

        //printf("enter block (%d,%d) [%d,%d]\n",i,curr,b_curr.first,b_curr.second);

        vector<int> pos;
        bool passed = false;
        for(int j: paths[i][curr]) {
            pair<int,int> b_it = blocks[i + 1][j];
            int s = max(b_curr.first,b_it.first);
            int e = min(b_curr.second,b_it.second);
            for(int f = s; f <= e; f++) pos.push_back(f);
            if(passed) break;
        }
        //for(int h:pos) printf("%d ",h);
        //printf("\n");
        int top = pos.size() - 1, bot = 0;
        if(entry < pos[bot]) entry = pos[bot];
        if(entry > pos[top]) entry = pos[top];
        int stop = pos.size() - 1, sbot = 0;
        while(top > bot) {
            //printf("search from %d to %d\n",bot,top);
            int mid = (stop + sbot) / 2;
            if (pos[mid] == entry) mid++;
            //printf("probe %d\n", mid);
            bool res = investigate(pos[mid]);
            if(pos[mid] < entry) {
                if(res) {
                    top = mid;
                    stop = mid - 1;
                }
                else {
                    bot = mid + 1;
                    sbot = bot;
                }
            }
            else {
                if(res) {
                    bot = mid;
                    sbot = mid + 1;
                }
                else {
                    top = mid - 1;
                    stop = top;
                }
            }
        }
        goDeeper(pos[top]);
        for(int j = 0; j < blocks[i + 1].size(); j++) {
            if(blocks[i + 1][j].first <= pos[top] && blocks[i + 1][j].second >= pos[top]) {
                curr = j;
                entry = pos[top];
                break;
            }
        }
    }
}