#include <bits/stdc++.h>
#include "tunnels.h"
#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

bool isValid(int x, int y, int m, const std::vector<std::vector<bool>>& blocked)
{
    if (y < 0 || y >= m || blocked[x][y])
        return false;

    return true;
}

void ChooseDirection(const int n, const int m, int &direction, int &x, int &y, const std::vector<std::vector<bool>>& blocked)
{
    bool isValidLeft = isValid(x, y-1, m, blocked);
    bool isValidRight = isValid(x, y+1, m, blocked);

    if (!isValidLeft && !isValidRight)
    {
        direction = -1; //down
        return;
    }

    if (isValidLeft && !isValidRight)
    {
        direction = 1; //left
        return;
    }

    if (!isValidLeft && isValidRight)
    {
        direction = 2; //right
        return;
    }

    direction = (investigate(y-1)?1:2);
    if (direction == 0)
        y--;

}

int FindExit(const int n, const int m, bool direction, int l, int r, const std::vector<std::vector<bool>>& blocked)
{
    int mid, ans = (direction?l:r);

    if (direction == 0)
        r--;
    else
        l++;
    while (l <= r)
    {
        mid = (l+r)/2;

        bool hasAppeared = investigate(mid);
        if (hasAppeared)
        {
            if (direction == 0) //left
            {
                r = mid-1;
            }

            else
            {
                l = mid+1;
            }

            ans = mid;
        }

        else
        {
            if (direction == 0)
            {
                l = mid+1;
            }

            else
            {
                r = mid-1;
            }
        }
    }

    return ans;
}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    goDeeper(k);

    int currY = k;
    for (int i = 1; i < n; i++)
    {
        int direction = 0; // to be determined
        ChooseDirection(n, m, direction, i, currY, blocked);

        if (direction == -1)
        {
            goDeeper(currY);
            continue;
        }

        int l, r;
        if (direction == 1)
        {
            l = 0;
            r = currY;
        }

        else
        {
            l = currY;
            r = m-1;
        }
        currY = FindExit(n, m, (direction==1?0:1), l, r, blocked);

        goDeeper(currY);
    }
}
