#include <bits/stdc++.h>
#include "bits_and_tree.h"
#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    int limit = n-1;
    vector <pair <int, int>> tree;
    int currNode = 4;
    for (int i = 0; i < 4; i++)
    {
        tree.emplace_back(i, currNode);
        limit--;
    }

    currNode = 5;
    tree.emplace_back(4, 5);
    int i = 0;
    bool currBit = 0;
    while (true)
    {
        bool bit = data[i];
        int edges = 0;

        if (bit != currBit)
            edges = 2;

        else
            edges = 1;

        if (edges > limit)
        {
            for (int j = 0; j < limit; j++)
            {
                tree.emplace_back(4, currNode+j+1);
                limit--;
            }
        }

        if (limit == 0)
            break;

        for (int j = 0; j < edges; j++)
        {
            tree.emplace_back(currNode, currNode+j+1);
            limit--;
        }

        currNode = currNode+1;
        currBit = bit;
    }

    cout << tree.size() << endl;
    return tree;

}


std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    vector <int> graph[500];
    bool used[500];

    for (auto [v, u]:tree)
    {
        graph[v].push_back(u);
        graph[u].push_back(v);
    }

    int root = -1;
    n++;

    for (int i = 0; i < n; i++)
    {
        if (graph[i].size() > 4)
            root = i;

        used[i] = false;
    }

    int currNode;
    for (int child:graph[root])
    {
        used[child] = true;
        if (graph[child].size() == 1)
            continue;

        bool isFake = true;
        for (int i = 0; i < graph[child].size(); i++)
        {
            int grandChild = graph[child][i];
            if (used[grandChild])
                continue;

            if (graph[grandChild].size() > 1)
            {
                isFake = false;
                break;
            }
        }

        if (isFake == false)
        {
            currNode = child;
        }
    }
    queue <int> q;
    q.push(currNode);
    used[currNode] = used[root] = true;
    vector <bool> bits;
    int currBit = 0;

    while (!q.empty())
    {
        currNode = q.front();
        q.pop();

        int sz = graph[currNode].size()-1;

        if (sz >= 2)
            currBit ^= 1;

        bits.push_back(currBit);

        for (int child:graph[currNode])
        {
            if (used[child])
                continue;

            used[child] = true;

            if (graph[child].size() == 1)
                continue;

            bool hasFake = true;
            for (int i = 0; i < graph[child].size(); i++)
            {
                int grandChild = graph[child][i];
                if (used[grandChild])
                    continue;

                if (graph[grandChild].size() > 1)
                {
                    hasFake = false;
                    break;
                }
            }

            if (hasFake == false)
            {
                q.push(child);
            }
        }
    }

    return bits;
}
