#include <iostream>
#include <map>
#include <vector>

const int maxn = 5 + 3e5;
int tree[maxn * 4];
int cnt[maxn], n, q, sz;
std::vector<int> arr;

void build(int v, int l, int r) {
  if (l == r) {
    tree[v] = arr[l];
    return;
  }
  int mid = (l + r) / 2;
  build(v * 2, l, mid);
  build(v * 2 + 1, mid + 1, r);
  tree[v] = tree[v * 2] ^ tree[v * 2 + 1];
}

void init(int _n, int _q, const std::vector<int> &a) {
  n = _n, q = _q;
  arr.push_back(-1);
  for (int i = 0; i < a.size(); i++) {
    if (a[i] % 2 == 0)
      arr.push_back(a[i]);
    else
      arr.push_back(a[i]), arr.push_back(a[i]);
  }
  sz = arr.size();
  build(1, 1, sz);
}

int squery(int v, int l, int r, int ql, int qr) {
  if (l > qr || r < ql)
    return 0;
  if (l >= ql && r <= qr)
    return tree[v];
  int mid = (l + r) / 2;
  return squery(v * 2, l, mid, ql, qr) ^ squery(v * 2 + 1, mid + 1, r, ql, qr);
}

long long query(int l, int r) {
  long long ans = 0;
  l++, r++;
  for (int i = l; i <= sz; i++)
    for (int j = i; j <= sz; j++)
      if (squery(1, 1, sz, i, j) == 0)
        ans++;
  return (ans / n - 1);
}
