#include "tunnels.h"
#include "tunnels.cpp"

#include <iostream>

static int nn, mm, k;
static std::vector<std::vector<bool>> blocked;

vector<int> poss;

static void input()
{
    std::cin >> nn >> mm >> k;

    blocked.resize(nn);
    for (int i = 0; i < nn; i++)
    {
        blocked[i].resize(mm);
        for (int j = 0; j < mm; j++)
        {
            char c;
            c='0';
            blocked[i][j] = c == '1';
        }
    }

    poss.push_back(k);
    for(int i=1;i<=nn;i++)poss.push_back(rand()%mm);

    for(int i:poss)cout<<i<<" ";
    cout<<":\n";
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    
    if(y>=min(poss[currX],poss[currX+1]) and y<=max(poss[currX],poss[currX+1]))return true;
    else return false;

    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == nn)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    if(poss[currX+1]!=y){
        cout<<poss[currX+1]<<" "<<y<<"\n";
        cout<<"Nope\n";
        exit(0);
    }
    currX++;

    if (currX == nn) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(nn, mm, k, blocked);

    if (currX < nn)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
