#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

const long long mod[2]={1000000007,1000000009};
long long power[MAXN][2];

int n,q,a[MAXN],cnt[MAXN],fr[MAXN];
long long ans;

void calc(){
    power[0][0]=power[0][1]=1;
    
    for(int i=1;i<=n;i++){
        for(int f=0;f<2;f++)power[i][f]=(long long) (power[i-1][f]*(n+1))%mod[f];
    }
}

struct hesh{
    long long h[2];

    void add(int x,long long y){
        h[0]+=power[x][0]*y; h[0]+=mod[0]*mod[0]; h[0]%=mod[0];
        h[1]+=power[x][1]*y; h[1]+=mod[1]*mod[1]; h[1]%=mod[1];
    }

    inline friend bool operator == (hesh fr,hesh sc){
        return fr.h[0]==sc.h[0] and fr.h[1]==sc.h[1];
    }

    inline friend bool operator < (hesh fr,hesh sc){
        if(fr.h[0]!=sc.h[0])return fr.h[0]<sc.h[0];
        return fr.h[1]<sc.h[1];
    }
}zero;

map<hesh, vector<int> > mp;
hesh curr[MAXN];
vector< pair<int,int> > all;

struct MergeSort{
    vector<int> tree[4*1000000];

    void mergev(int x,int y,int z){
        int pt=0;
        tree[x].reserve(int(tree[y].size())+int(tree[z].size()));

        for(int i:tree[y]){
            while(pt<tree[z].size() and tree[z][pt]<i){
                tree[x].push_back(tree[z][pt]);
                pt++;
            }

            tree[x].push_back(i);
        }

        while(pt<tree[z].size()){
            tree[x].push_back(tree[z][pt]);
            pt++;
        }
    }

    void build(int v,int l,int r){
        if(l==r){
            tree[v]={all[l].second};
        }else{
            int tt=(l+r)/2;

            build(2*v,l,tt);
            build(2*v+1,tt+1,r);

            mergev(v,2*v,2*v+1);
        }
    }

    int bin(int v,int val){
        int l=-1,r=tree[v].size(),tt;

        while(l+1<r){
            tt=(l+r)/2;
            if(tree[v][tt]<=val){
                l=tt;
            }else{
                r=tt;
            }
        }

        return l+1;
    }

    int query(int v,int l,int r,int ll,int rr,int val){
        if(ll>rr)return 0;
        if(l==ll and r==rr)return bin(v,val);

        int tt=(l+r)/2;
        return query(2*v,l,tt,ll,min(tt,rr),val) + query(2*v+1,tt+1,r,max(tt+1,ll),rr,val);
    }
}tree;

void solve(int l,int r){
    if(l==r){
        if(a[l]==1)all.push_back({l,l});
        return;
    }

    int mid=(l+r)/2;
    solve(l,mid);
    solve(mid+1,r);

    mp.clear();
    int pt=l;

    for(int i=mid;i>=l;i--){
        cnt[a[i]]++;
        if(cnt[a[i]]==1)fr[a[i]]=i;

        if(cnt[a[i]]>a[i]){
            pt=i+1;
            break;
        }

        if(i<mid)curr[i]=curr[i+1];
        else curr[i]=zero;

        if(cnt[a[i]]!=a[i])curr[i].add(a[i],1);
        else curr[i].add(a[i],-(a[i]-1));

        mp[curr[i]].push_back(i);
    }

    for(int i=mid;i>=l;i--)cnt[a[i]]=0;

    for(int i=mid+1;i<=r;i++){
        cnt[a[i]]++;
        if(cnt[a[i]]>a[i])break;

        if(cnt[a[i]]==a[i]){
            while(pt<=fr[a[i]]){
                mp[curr[pt]].pop_back();
                pt++;
            }
        }

        if(i>mid+1)curr[i]=curr[i-1];
        else curr[i]=zero;

        if(cnt[a[i]]==1){
            curr[i].add(a[i],a[i]-1);
        }else{
            curr[i].add(a[i],-1);
        }

        for(int f:mp[curr[i]]){
            all.push_back({f,i});
        }
    }

    for(int i=l;i<=r;i++){
        fr[a[i]]=0; cnt[a[i]]=0;
    }
}

void init(int N, int Q, const std::vector<int>& A){
    n=N; q=Q;

    for(int i=1;i<=n;i++){
        a[i]=A[i-1];
    }
    calc();

    solve(1,n);

    sort(all.begin(),all.end());
    tree.build(1,0,all.size()-1);
}

long long query(int l, int r){
    l++; r++;

    int lt=-1,rt=all.size(),tt;

    while(lt+1<rt){
        tt=(lt+rt)/2;
        if(all[tt].first>=l){
            rt=tt;
        }else{
            lt=tt;
        }
    }

    int from=rt;

    lt=-1; rt=all.size();

    while(lt+1<rt){
        tt=(lt+rt)/2;
        if(all[tt].first<=r){
            lt=tt;
        }else{
            rt=tt;
        }
    }

    int to=lt;
    
    return tree.query(1,0,all.size()-1,from,to,r);
}

/*int main(){
    init(7,3,{1,2,1,2,3,3,3});
    cout<<query(0,6)<<"\n";

    return 0;
}*/