/*
    Zvunq ti alo
    i repetiram dumite pred ogledalo
*/

#include "bits_and_tree.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>

const int MAXN = 500;

int cnt;
std::vector <std::pair <int,int>> sol;
void represent(int node, int val)
{
    if (val & 1)
    {
        if (val == 1)
        {
            return;
        }
        
        sol.push_back({node, ++cnt});
        for (int i = 1 ; i < val ; ++i)
        {
            sol.push_back({cnt, cnt + 1});
            cnt++;
        }
        
        return;
    }
    
    sol.push_back({node, ++cnt});
    for (int i = 1 ; i < val / 2 ; ++i)
    {
        sol.push_back({cnt, cnt + 1});
        cnt++;
    }

    sol.push_back({node, ++cnt});
    for (int i = 1 ; i < val / 2 ; ++i)
    {
        sol.push_back({cnt, cnt + 1});
        cnt++;
    }
}

std::vector <std::pair <int,int>> encode(int n, std::vector <bool> data)
{
    sol.clear();
    int cntOnes = 0;
    while (data.size() > 205)
    {
        data.pop_back();
    }

    for (int i = 0 ; i < data.size() ; ++i)
    {
        cntOnes += data[i];
    }

    int firstNeigh = 6;
    int secondNeigh = 8;
    // if (cntOnes >= 106)
    // {
    //     firstNeigh++;
    //     secondNeigh++;
    //     for (int i = 0 ; i < n ; ++i)
    //     {
    //         data[i] = (1 ^ data[i]);
    //     }
    // }

    data.push_back(1);
    cnt = 0;

    for (int i = 1 ; i < firstNeigh ; ++i)
    {
        sol.push_back({0, ++cnt});
    }

    for (int i = 1 ; i < secondNeigh ; ++i)
    {
        sol.push_back({n - 1, n - 1 - i});
    }
 
    int last = 0;
    int ptr = 0;
    int prev = 0;

    while (cnt < n - secondNeigh - 1)
    {
        while (data[ptr] == 0)
        {
            ptr++;
        }

        // std::cout << "ptr: " << ptr << '\n';
        int len = std::max(1, ptr - last + 1);
        while (len + 1 - (len == 0) + cnt >= n - secondNeigh)
        {
            len--;
        }

        if (len == 0)
        {
            break;
        }

        // std::cout << "\nlen: " << len << ' ' << prev << ' ' << cnt << ' ' << n - secondNeigh << '\n';
        cnt++;
        sol.push_back({prev, cnt});
        prev = cnt;

        represent(cnt, len);
        last = ptr + 1;
        ptr++;
    }

    sol.push_back({prev, n - 1});
    // std::cout << "here: " << sol.size() << '\n';
    // while (sol.size() > n - 1)
    // {
    //     sol.pop_back();
    // }

    assert(sol.size() == n - 1);
    return sol;
}

int n;
bool onPath[MAXN];
std::vector <int> path;
std::vector <int> g[MAXN];

bool findPath(int node, int p, int s)
{
    if (node == s)
    {
        return true;
    }

    for (const int &u : g[node])
    {
        if (u == p)
        {
            continue;
        }

        if (findPath(u, node, s))
        {
            path.push_back(node);
            onPath[node] = true;
            return true;
        }
    }

    return false;
}

int findMAX(int node, int p)
{
    // // std::cout << "find max: " << node << ' ' << p << '\n';
    int res = 0;
    for (const int &u : g[node])
    {
        if (u == p)
        {
            continue;
        }

        assert(!onPath[u]);
        res = std::max(res, findMAX(u, node));
    }

    return res + 1;
}

std::vector <bool> decode(int N, std::vector <std::pair <int,int>> edges)
{
    n = N + 1;
    path.clear();
    for (int i = 0 ; i < MAXN ; ++i)
    {
        onPath[i] = false;
        g[i].clear();
    }

    for (const auto &[u, v] : edges)
    {
        g[u + 1].push_back(v + 1);
        g[v + 1].push_back(u + 1);
        // // std::cout << "edge: " << u + 1 << ' ' << v + 1 << '\n';
    }

    std::vector <int> candidates;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (g[i].size() >= 6)
        {
            candidates.push_back(i);
        }
    }

    // // std::cout << "candidates\n";
    // for (const int &u : candidates)
    // {
    // // std::cout << u << ' ';
    // }

    //     // std::cout << '\n';
    assert(candidates.size() == 2);
    bool flipped = false;
    int start = candidates[0];
    int end = candidates[1];

    if (g[start].size() > g[end].size())
    {
        std::swap(start, end);
    }

    if (g[start].size() + g[end].size() >= 16)
    {
        flipped = true;
    }

    // // std::cout << "here: " << start << ' ' << end << " = " << g[start].size() << ' ' << g[end].size() << '\n';
    assert(findPath(start, 0, end));
    path.pop_back();
    std::reverse(path.begin(), path.end());

    // // std::cout << "path\n";
    // for (int i = 0 ; i < path.size() ; ++i)
    // {
    //     // std::cout << path[i] << ' ';
    // }

    // // std::cout << '\n';

    onPath[start] = onPath[end] = true;
    std::vector <bool> data;
    for (const int &u : path)
    {
        // std::cout << "here: " << u << ' ' << g[u].size() << '\n';
        std::vector <int> lens;
        for (const int &v : g[u])
        {
            if (!onPath[v])
            {
                lens.push_back(findMAX(v, u));
            }
        }

        // std::cout << "lens:\n";
        // for (int i = 0 ; i < lens.size() ; ++i)
        // {
        //     std::cout << lens[i] << ' ';
        // }

        // std::cout << '\n';
        int num = 0;
        if (lens.empty())
        {
            num = 1;
        } else if (lens.size() == 1)
        {
            num = lens[0] - (lens[0] % 2 == 0 || lens[0] == 1);
        } else if (lens.size() == 2)
        {
            if (lens[0] + lens[1] <= 3)
            {
                num = 2;
            } else if (lens[0] == 1 || lens[1] == 1)
            {
                num = lens[0] + lens[1] - 1;
            } else
            {
                num = 2 * std::min(lens[0], lens[1]);
            }
        } else
        {
            assert(lens.size() == 3);
            num = lens[0] + lens[1] + lens[2] - 1;
        }

        // std::cout << "num: " << num << ' ' << data.size() << '\n';
        for (int j = 1 ; j < num ; ++j)
        {
            data.push_back(0);
        }

        data.push_back(1);
    }

    if (flipped)
    {
        for (int i = 0 ; i < data.size() ; ++i)
        {
            data[i] = (data[i] ^ 1);
        }
    }

    while (data.size() < 2 * n)
    {
        data.push_back(0);
    }

    // // std::cout << "done\n";
    return data;
}