/*
    Zvunq ti alo
    i repetiram dumite pred ogledalo
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
const llong TIME = std::chrono::steady_clock::now().time_since_epoch().count();
const int MAXN = 300000 + 10;


int n;
struct Fenwick
{
    int tree[MAXN];
    void reset()
    {
        std::fill(tree + 1, tree + 1 + n, 0);
    }

    void build(int a[])
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            if (i + (i & (-i)) <= n)
            {
                tree[i + (i & (-i))] += tree[i];
            }
        }
    }

    void update(int idx, int val)
    {
        for (; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }
    }
};

struct LinkedList
{
	int prev[MAXN];
	int next[MAXN];

	void build()
	{
		for (int i = 1 ; i <= n ; ++i)
		{
			prev[i] = i - 1;
			next[i] = i + 1;
		}
	}

	void erase(int idx)
	{
		prev[next[idx]] = prev[idx];
		next[prev[idx]] = next[idx];
	}
};

int last[MAXN];
int prev[MAXN];
std::vector <std::pair <int,int>> ranges;
// std::mt19937 rng(69420);
std::vector <int> indices[MAXN];
LinkedList list;

int a[MAXN];
void init(int N, int Q, const std::vector <int> &vals)
{
    n = N;
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = vals[i - 1];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        indices[i].push_back(0);
    }

	for (int i = 1 ; i <= n ; ++i)
	{
		prev[i] = last[a[i]];
		last[a[i]] = i;
	}

	list.build();
	for (int i = 1 ; i <= n ; ++i)
	{
		indices[a[i]].push_back(i);
		if (prev[i] != 0)
		{
			list.erase(prev[i]);
		}

		int bad = 0;
		int from = i;
		int idx = i;

		while (idx > bad && from > bad)
		{
			if (indices[a[idx]].size() - 1 < a[idx])
			{
				break;
			}

			from = std::min(from, indices[a[idx]][indices[a[idx]].size() - a[idx]]);
			bad = std::max(bad, indices[a[idx]][indices[a[idx]].size() - a[idx] - 1]);
			if (list.prev[idx] < from && bad < from)
			{
				ranges.push_back({from, i});
			}

			idx = list.prev[idx];
		}
	}
}

llong query(int l, int r)
{
	l++; r++;
	// return cnt[r + 1] - cnt[l];
	int res = 0;
	for (const auto &[x, y] : ranges)
	{
		res += (x >= l && y <= r);
	}

	return res;
}