#include <bits/stdc++.h>
#include "bits_and_tree.h"
using namespace std;

const int maxn = 202;
int m, used[maxn];
vector <int> v[maxn];

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector <pair <int, int>> res;
    if (data[0] == 1)
    {
        int i;
        for (i=1; i<n; ++i)
            res.push_back({i-1,i});
    }
    else
    {
        int i;
        for (i=1; i<n; ++i)
            res.push_back({0,i});
    }
    return res;
}

void bfs(int ver)
{
    used[ver] = 0;
    queue <int> q;
    q.push(ver);
    int e, nb, i, len;

    while (!q.empty())
    {
        e = q.front(); q.pop();
        len = (int)(v[e].size());
        for (i=0; i<len; ++i)
        {
            nb = v[e][i];
            if (!used[nb])
            {
                used[nb] = used[e] + 1;
                q.push(nb);
            }
        }
    }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    int i, x, y;
    for (i=0; i<=n; ++i)
        v[i].clear();
    for (i=0; i<n; ++i)
    {
        x = tree[i].first;
        y = tree[i].second;
        v[x].push_back(y);
        v[y].push_back(x);
    }

    memset(used, 0, sizeof(used));
    bfs(0);
    int maxd = 0, ver;
    for (i=1; i<=n; ++i)
    {
        if (used[i] > maxd)
        {
            maxd = used[i];
            ver = i;
        }
    }

    memset(used, 0, sizeof(used));
    bfs(ver);
    int diameter = 0;
    for (i=0; i<=n; ++i)
    {
        if (used[i] > diameter)
            diameter = used[i];
    }

    vector <bool> ans;
    if (diameter > 3)
        ans.push_back(true);
    else
        ans.push_back(false);
    //cout << ans[0] << endl << endl;
    return ans;
}