#include <bits/stdc++.h>
#include "bits_and_tree.h"
using namespace std;

const int maxn = 202;
int m, used[maxn];
vector <int> v[maxn];

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    int maxnum = n/2;
    int i, past = 1, num = 1, len = (int)(data.size());
    for (i=0; i<len; ++i)
    {
        num *= 2;
        num += (int)(data[i]);

        if (num > maxnum)
            break;
        past = num;
    }
    num = past;

    int not_on_star = (num+1)*2-2;
    vector <pair <int, int>> res;
    for (i=1; i<n-not_on_star; ++i)
    {
        res.push_back({0,i});
        //cout << "0 -> " << i << '\n' ;
    }
    for (i=n-1-not_on_star; i<n-1; ++i)
    {
        res.push_back({i,i+1});
        //cout << i << " -> " << i+1 << '\n' ;
    }
    return res;
}

void bfs(int ver)
{
    used[ver] = 0;
    queue <int> q;
    q.push(ver);
    int e, nb, i, len;

    while (!q.empty())
    {
        e = q.front(); q.pop();
        len = (int)(v[e].size());
        for (i=0; i<len; ++i)
        {
            nb = v[e][i];
            if (!used[nb])
            {
                used[nb] = used[e] + 1;
                q.push(nb);
            }
        }
    }
}

string to_2(int num)
{
    //cout << num << " " ;
    string res = "";
    int p;
    do
    {
        p = (num&1);
        num >>= 1;
        res = (char)(p+'0') + res;
    }while(num);
    //cout << res << '\n' ;
    return res;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    int i, x, y;
    for (i=0; i<=n; ++i)
        v[i].clear();
    for (i=0; i<n; ++i)
    {
        x = tree[i].first;
        y = tree[i].second;
        v[x].push_back(y);
        v[y].push_back(x);
    }

    memset(used, 0, sizeof(used));
    bfs(0);
    int maxd = 0, ver;
    for (i=1; i<=n; ++i)
    {
        if (used[i] > maxd)
        {
            maxd = used[i];
            ver = i;
        }
    }

    memset(used, 0, sizeof(used));
    bfs(ver);
    int diameter = 0;
    for (i=0; i<=n; ++i)
    {
        if (used[i] > diameter)
            diameter = used[i];
    }

    int num = (diameter/2)-1;
    string s = to_2(num);
    vector <bool> ans;
    int len = (int)(s.size());
    for (i=1; i<len; ++i)
    {
        if (s[i] == '0')
            ans.push_back(false);
        else
            ans.push_back(true);
    }
    return ans;
}
