#include<bits/stdc++.h>
#include"tunnels.h"

using namespace std;

const int MAXN=5005, MAXM=5005;

int N, M, K;
bool tabl[MAXN][MAXM];
bool dost[MAXN][MAXM];

void dfs(int x, int y)
{
    if(dost[x][y] || tabl[x][y]) return;
    dost[x][y]=1;
    if(x>0) dfs(x-1, y);
    if(y>0) dfs(x, y-1);
    if(y<M-1) dfs(x, y+1);
}

void fill_dost()
{
    for(int j=0; j<M; j++) dost[N][j]=1;
    for(int j=0; j<M; j++)
    {
        if(!tabl[N-1][j]) dfs(N-1, j);
    }
}

vector<int> tunnels[MAXN];

void get_tunnels()
{
    for(int i=N; i>0; i--)
    {
        for(int j=0; j<M; j++)
        {
            if(dost[i][j] && dost[i-1][j]) tunnels[i].push_back(j);
        }
    }
}

int Le[MAXN][MAXM], Ri[MAXN][MAXM];

void calc_brds()
{
    for(int i=0; i<N; i++)
    {
        if(dost[i][0]) Le[i][0]=-1;
        else Le[i][0]=0;
        for(int j=1; j<M; j++)
        {
            if(!dost[i][j]) Le[i][j]=j;
            else Le[i][j]=Le[i][j-1];
        }

        if(dost[i][M-1]) Ri[i][M-1]=M;
        else Ri[i][M-1]=M-1;
        for(int j=M-2; j>=0; j--)
        {
            if(!dost[i][j]) Ri[i][j]=j;
            else Ri[i][j]=Ri[i][j+1];
        }
    }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    N=n;
    M=m;
    K=k;
    for(int i=0; i<N; i++)
    {
        for(int j=0; j<M; j++)
        {
            tabl[i][j]=blocked[i][j];
        }
    }
    fill_dost();
    get_tunnels();
    calc_brds();
/**
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cout<<dost[i][j];
        }
        cout<<endl;
    }
    cout<<endl;
    for(int i=0; i<n; i++)
    {
        cout<<endl;
        cout<<tunnels[i+1].size()<<endl;
        for(int j=0; j<tunnels[i+1].size(); j++) cout<<tunnels[i+1][j]<<" ";
        cout<<endl;
    }*/
    int pos=k;
    for(int i=0; i<=n-1; i++)
    {
        int grLe=Le[i][pos]+1, grRi=Ri[i][pos]-1;
        int Lg=m+1, Rg=-1;
        for(int j=0; j<tunnels[i+1].size(); j++)
        {
            int ps=tunnels[i+1][j];
            if(ps>=grLe && j<Lg) Lg=j;
            if(ps<=grRi && j>Rg) Rg=j;
        }
        cout<<grLe<<" "<<grRi<<endl;
        cout<<Lg<<" "<<Rg<<endl;
        while(Lg!=Rg)
        {
            int mid=(Lg+Rg)/2;
            if(pos<=tunnels[i+1][mid])
            {
                bool vprs=investigate(tunnels[i+1][mid+1]);
                if(vprs==1) Lg=mid+1;
                else Rg=mid;
            }
            else
            {
                bool vprs=investigate(tunnels[i+1][mid]);
                if(vprs==1) Rg=mid;
                else Lg=mid+1;
            }
        }
        pos=tunnels[i+1][Lg];
        goDeeper(pos);
    }

    /**cout<<endl;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cout<<dost[i][j];
        }
        cout<<endl;
    }
    cout<<endl;

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cout<<Le[i][j]<<" ";
        }
        cout<<endl;
    }
    cout<<endl;

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cout<<Ri[i][j]<<" ";
        }
        cout<<endl;
    }
    cout<<endl;
    for(int i=0; i<n; i++)
    {
        cout<<endl;
        cout<<tunnels[i+1].size()<<endl;
        for(int j=0; j<tunnels[i+1].size(); j++) cout<<tunnels[i+1][j]<<" ";
        cout<<endl;
    }*/
}
