#include<bits/stdc++.h>
#include "tunnels.h"

using namespace std;
typedef long long ll;

const int MAXN = 5010;

int dp_block[MAXN][MAXN], dp_free[MAXN][MAXN];
pair < int, bool > step_block[MAXN][MAXN], step_free[MAXN][MAXN];
int bin_dp[MAXN];

bool is_viable[MAXN][MAXN];

void solve(int n, int m, int k, const vector< vector<bool > > &blocked)
{
    bin_dp[0] = 0;
    for (int i = 1; i <= m; i ++)
    {
        bin_dp[i] = bin_dp[i / 2] + 1;
    }

    for (int i = 0; i <= m; i ++)
        for (int j = 0; j <= m; j ++)
        {
            if (i == 0 && j == 0)
            {
                dp_free[i][j] = 0;
                step_free[i][j] = {0, 0};
                continue;
            }

            if (i == 0)
            {
                dp_free[i][j] = bin_dp[j];
                step_free[i][j] = {(1 + j) / 2, 1};
                continue;
            }

            if (j == 0)
            {
                dp_free[i][j] = bin_dp[i];
                step_free[i][j] = {(1 + i) / 2 , 0};
                continue;
            }

            dp_free[i][j] = 1e6;

            for (int d = 1; d <= i; d ++) /// this could be binary searched
            {
                int cur = dp_free[d - 1][j];
                cur = max(cur, bin_dp[i - d]);

                if (cur < dp_free[i][j])
                {
                    dp_free[i][j] = cur;
                    step_free[i][j] = {d, 0};
                }
            }

            for (int d = 1; d <= j; d ++)
            {
                int cur = dp_free[i][d - 1];
                cur = max(cur, bin_dp[j - d]);

                if (cur < dp_free[i][j])
                {
                    dp_free[i][j] = cur;
                    step_free[i][j] = {d, -1};
                }
            }
        }


    for (int i = 0; i <= m; i ++)
        for (int j = 0; j <= m; j ++)
        {
            if (i == 0 && j == 0)
            {
                dp_block[i][j] = 1e6 + 10; /// this case is impossible
                step_block[i][j] = {0, 0};
                continue;
            }

            if (i == 0)
            {
                dp_block[i][j] = bin_dp[j - 1]; /// we can start from one to the left
                step_block[i][j] = {(j + 2) / 2, 1};
                continue;
            }

            if (j == 0)
            {
                dp_block[i][j] = bin_dp[i];
                step_block[i][j] = {(i + 2) / 2, 0};
                continue;
            }
            dp_block[i][j] = 1e6;

            for (int d = 1; d <= i; d ++) /// this could be binary searched
            {
                int cur = dp_block[d - 1][j];
                cur = max(cur, bin_dp[i - d]);

                if (cur < dp_block[i][j])
                {
                    dp_block[i][j] = cur;
                    step_block[i][j] = {d, 0};
                }
            }

            for (int d = 1; d <= j; d ++)
            {
                int cur = dp_block[i][d - 1];
                cur = max(cur, bin_dp[j - d]);

                if (cur < dp_block[i][j])
                {
                    dp_block[i][j] = cur;
                    step_block[i][j] = {d, -1};
                }
            }
        }






    ///cout << from_dp[m / 2][m].first << " " << from_dp[m / 2][m].second << endl;


    for (int j = 0; j < m; j ++)
        is_viable[n][j] = true;

    for (int i = n - 1; i >= 0; i --)
    {
        for (int j = 0; j < m; j ++)
        {
            if (blocked[i][j])
                is_viable[i][j] = false;
            else
                is_viable[i][j] = is_viable[i + 1][j];
        }
        for (int j = 1; j < m; j ++)
        {
            if (blocked[i][j])
                continue;
            if (is_viable[i][j - 1] == true)
                is_viable[i][j] = true;
        }

        for (int j = m - 2; j >= 0; j --)
        {
            if (blocked[i][j])
                continue;
            if (is_viable[i][j + 1] == true)
                is_viable[i][j] = true;
        }
    }


    for (int row = 0; row < n; row ++)
    {
        //cout << "row " << row << endl;
        vector < int > ids_left;
        ids_left.push_back(-1);
        int j = k - 1, lc = 0;
        while(j >= 0 && !blocked[row][j])
        {
            if (is_viable[row + 1][j])
                ids_left.push_back(j), lc ++;
            j --;
        }



        vector < int > ids_right;
        ids_right.push_back(-1);
        j = k + 1;
        int rc = 0;
        while(j < m && !blocked[row][j])
        {
            if (is_viable[row + 1][j])
                ids_right.push_back(j), rc ++;
            j ++;
        }



        if (is_viable[row + 1][k])
        {
            bool went = false;
            while(lc > 0 || rc > 0)
            {
                pair < int, int > step;
                step = step_free[lc][rc];

                //cout << lc << " -- " << rc << endl;
                //cout << step.first << " : " << step.second << endl;
                if (step.second == 0)
                {
                    if (investigate(ids_left[step.first]))
                    {
                        int lb = step.first;
                        int rb = lc + 1;
                        while(lb + 1 < rb)
                        {
                            int mb = (lb + rb) / 2;
                            if (investigate(ids_left[mb]))
                                lb = mb;
                            else
                                rb = mb;
                        }

                        k = ids_left[step.first];
                        goDeeper(k);

                        went = true;

                        break;
                    }
                    else
                    {
                        lc = step.first - 1;
                    }
                }
                else
                {

                    if (investigate(ids_right[step.first]))
                    {
                        int rb = rc + 1;
                        int lb = step.first;
                        while(lb + 1 < rb)
                        {
                            int mb = (lb + rb) / 2;
                            if (investigate(ids_right[mb]))
                                lb = mb;
                            else
                                rb = mb;
                        }

                        k = ids_right[step.first];
                        goDeeper(k);
                        went = true;
                        break;
                    }
                    else
                    {
                        rc = step.first - 1;
                    }
                }

            }


            if (!went)
            {
                goDeeper(k);
            }
        }
        else
        {
            while(lc > 0 || rc > 0)
            {
                if (lc == 0 && rc == 1)
                {
                    k = ids_right[1];
                    goDeeper(k);
                    break;
                }
                if (lc == 1 && rc == 0)
                {
                    k = ids_left[1];
                    goDeeper(k);
                    break;
                }
                pair < int, int > step;
                step = step_block[lc][rc];

                if (step.second == 0)
                {
                    if (investigate(ids_left[step.first]))
                    {
                        int lb = step.first;
                        int rb = lc + 1;
                        while(lb + 1 < rb)
                        {
                            int mb = (lb + rb) / 2;
                            if (investigate(ids_left[mb]))
                                lb = mb;
                            else
                                rb = mb;
                        }

                        k = ids_left[step.first];
                        goDeeper(k);
                        break;

                    }
                    else
                    {
                        lc = step.first - 1;
                    }
                }
                else
                {
                    if (investigate(ids_right[step.first]))
                    {
                        int rb = rc + 1;
                        int lb = step.first;
                        while(lb + 1 < rb)
                        {
                            int mb = (lb + rb) / 2;
                            if (investigate(ids_right[mb]))
                                lb = mb;
                            else
                                rb = mb;
                        }

                        k = ids_right[step.first];
                        goDeeper(k);
                        break;

                    }
                    else
                    {
                        rc = step.first - 1;
                    }
                }

            }
        }


    }

}
