#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAXN = 3e5 + 10;
int a[MAXN], n;

int direct[MAXN], lb[MAXN], rb[MAXN];

vector < int > occ[MAXN];

struct Node
{
    int mx, cnt;
    Node(int _mx = 0, int _cnt = 0)
    {
        mx = _mx;
        cnt = _cnt;
    }
};

Node merge_node(Node lf, Node rf)
{
    if (lf.mx > rf.mx)
        return lf;
    if (lf.mx < rf.mx)
        return rf;
    return Node(lf.mx, lf.cnt + rf.cnt);
}

Node tree[4 * MAXN];
int lazy[4 * MAXN];

void push_lazy(int root, int left, int right)
{
    tree[root].mx += (lazy[root]);

    if (left != right)
    {
        lazy[root * 2] += lazy[root];
        lazy[root * 2 + 1] += lazy[root];
    }

    lazy[root] = 0;
}

void update(int root, int left, int right, int qleft, int qright, int val)
{

    //cout << root << " : " << left << " : " << right << " : " << qleft << " : " << qright << endl;
    push_lazy(root, left, right);

    if (left > qright || right < qleft)
        return;

    if (left >= qleft && right <= qright)
    {
        lazy[root] = val;
        push_lazy(root, left, right);
        return;
    }

    int mid = (left + right) / 2;
    update(root * 2, left, mid, qleft, qright, val);
    update(root * 2 + 1, mid + 1, right, qleft, qright, val);

    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
}

Node query(int root, int left, int right, int qleft, int qright)
{
    push_lazy(root, left, right);

    if (left > qright || right < qleft)
        return Node(-1, 0);

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return merge_node(query(root * 2, left, mid, qleft, qright),
                      query(root * 2 + 1, mid + 1, right, qleft, qright));
}
ll ans;
int pivot[MAXN];

void build(int root, int left, int right)
{
    if (left == right)
    {
        tree[root] = Node(0, 1);
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);

    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
}
void init(int N, int Q, const vector < int > &A)
{
    n = N;
    for (int i = 1; i <= n; i ++)
    {
        a[i] = A[i - 1];
        direct[i] = n;
        lb[i] = i;
        rb[i] = n;

        occ[a[i]].push_back(i);
    }

    build(1, 1, n);
    ans = 0;
    for (int i = 1; i <= n; i ++)
    {
        update(1, 1, n, 1, n, 1);
        pivot[i] = -1;
    }

    for (int i = 1; i <= n; i ++)
    {
        int num = a[i];
        pivot[num] ++;

        /// remove last
        if (pivot[num] == 0)
        {
            update(1, 1, n, 1, n, -1);


        }
        else
        if (pivot[num] < num)
        {
            int last = occ[num][pivot[num] - 1] + 1;
            //cout << "Num " << num << " rem " << last << " " <<occ[num][pivot[num] - 1] - 1 << endl;
            update(1, 1, n, last, n, - 1);

        }
        else
        {
            int last = occ[num][pivot[num] - 1] + 1;
            //cout << "Num " << num << " rem " << last << " " <<occ[num][pivot[num] - 1] - 1 << endl;
            update(1, 1, n, last, n, - 1);

            int l = 1, r = occ[num][pivot[num] - num];
            if (pivot[num] > num)
                l = occ[num][pivot[num] - num - 1] + 1;
            //cout << "Num " << num << " rem " << l << " " <<r<< endl;
            update(1, 1, n, l, r, -1);
        }

        int last = occ[num][pivot[num]] + 1;

        update(1, 1, n, last, n, 1);

        if (pivot[num] >= num - 1)
        {
            int l = 1;
            if (pivot[num] >= num)
                l = occ[num][pivot[num] - num] + 1;
            int r = occ[num][pivot[num] - num + 1];

            //cout << "Num " << num << " add " << l << " " << r << endl;
            update(1, 1, n, l, r, 1);
        }


        Node cur = query(1, 1, n, 1, i);
        if (cur.mx == n)
            ans += cur.cnt;

        /**cout << "here " << i << " " << cur.mx << " : " << cur.cnt << endl;
        for (int j = 1; j <= n; j ++)
        {
            Node cur = query(1, 1, n, j, j);
            cout << cur.mx << " ";
        }
        cout << endl;*/
    }


}

long long query(int l, int r)
{
    l ++;
    r ++;

    return ans;
}
