#include "bits_and_tree.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=205;

int n;
int num=0;
vector<pair<int,int> > edges;

int newNode()
{
    return num++;
}

void addEdge(int x,int y)
{
    if(x>=n || y>=n) return;
    edges.push_back({x,y});
}

std::vector<std::pair<int, int>> encode(int _n, std::vector<bool> data)
{
    n=_n;
    num=0;
    int root=newNode();
    for(int i=0;i<4;i++) addEdge(root,newNode());

    int last=root;
    for(int i=0;i<n-5;i++)
    {
        if(num<n)
        {
            addEdge(last,newNode());
            last=num-1;
        }
        else break;
        if(data[i])
        {
            addEdge(last,newNode());
            addEdge(num-2,newNode());
        }
    }

    return edges;
}

vector<int> adj[MAXN];
bool used[MAXN];
int subtr[MAXN];
bool ans[2*MAXN];
int ind;

void dfs(int v,int par)
{
    subtr[v]=1;
    for(auto u: adj[v])
    {
        if(u==par) continue;
        dfs(u,v);
        subtr[v]+=subtr[u];
    }
}

void dfs2(int v)
{
    used[v]=1;
    for(auto u: adj[v])
    {
        if(used[u]) continue;
        if(subtr[u]>=1 && subtr[u]<=3)
        {
            ans[ind++]=1;
            break;
        }
    }
    for(auto u: adj[v])
    {
        if(used[u]) continue;
        if(subtr[u]>3) dfs2(u);
    }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    ind=0;
    for(int i=0;i<2*n;i++) ans[i]=0;
    for(int i=0;i<=n;i++)
    {
        adj[i].clear();
        used[i]=0;
    }

    for(auto [u,v]: tree)
    {
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    int root=0;
    for(int i=0;i<=n;i++)
    {
        if(adj[i].size()>=5)
        {
            root=i;
            break;
        }
    }
//cout<<"root1: "<<root<<endl;
    dfs(root,-1);
    for(auto u: adj[root])
    {
        if(subtr[u]>2)
        {
            used[root]=1;
            root=u;
            break;
        }
    }
//cout<<"root2: "<<root<<endl;
    dfs2(root);
//for(int i=0;i<ind;i++) cout<<ans[ind]; cout<<endl;
    vector<bool> ret;
    ret.resize(2*n);
    for(int i=0;i<ind;i++) ret[i]=ans[i];
    for(int i=ind;i<2*n;i++) ret[i]=0;
    return ret;
}
